# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

import os
import sys
import commands

import subprocess

from basesoft.settings.debug import *
from selenium.webdriver.common.desired_capabilities import DesiredCapabilities
from os import makedirs

DEBUG = True
SYSLOG_IDENT = 'docker'

YUI_DEBUG_FILES = True
ES6_COMPILE = True

ADMINS = (('Tek', 'tek@basesoft.com'), )

# base url
BASE_URL = 'http://web:8000/'
DB_CONNSTR = 'mysql://iqportal:bier@mysql:3306/iqportal?charset=utf8'
DB_CONNSTR_READONLY = 'mysql://iqportal_ro:bier_ro@mysql:3306/iqportal?charset=utf8'
DB_CONNSTR_FOODMART = 'mysql://iqportal_ro:bier_ro@mysql:3306/foodmart?charset=utf8'

FONTS_PATH = '/usr/share/fonts'

EMAIL_HOST = '192.168.8.40'

MONDRIAN_XMLA_SERVER = ('iqube', 8080)
IQUBE_SERVLET = "http://iqube:8080/iqube-docker/IQubeXmlRpcServlet"
MONDRIAN_XMLA_PATH = '/iqube-docker/xmla'
MONDRIAN_XMLA_CACHE_ENABLED = True

# FIXME: tnt should go to its own repo
#INSTALLED_APPS = BASE_APPS + CLIENT_APPS + IQUBE_APPS + IQREPORT_APPS + IQUEST_APPS
#add_test_apps(INSTALLED_APPS)


WRITABLE_DIRECTORY = '/home/clients/iqportal/docker'
TMP_FILE_REPOSITORY = os.path.join('/tmp/iqportal/temp')
FILE_REPOSITORY = os.path.join(WRITABLE_DIRECTORY, 'files')
STATIC_SQUASHED_ROOT = os.path.join(WRITABLE_DIRECTORY, 'files')

for dir in (WRITABLE_DIRECTORY, TMP_FILE_REPOSITORY, FILE_REPOSITORY, STATIC_SQUASHED_ROOT):
    if not os.path.exists(dir):
        makedirs(dir)
    assert os.access(dir, os.W_OK)

LOGGER_STDOUT_LEVEL = logging.ERROR
LOGGER_SYSLOG_LEVEL = logging.DEBUG
LOGGER_SYSLOG_ADDRESS = '/dev/log'
SYSLOG_IDENT = 'iqportal-docker'

EMAIL_HOST = 'vm.office.basesoft.com'

SELENIUM_DJANGO_ADDR = '0.0.0.0:8000'
SELENIUM['host'] = 'selenium'
SELENIUM['desired_capabilities'] = DesiredCapabilities.CHROME
#SELENIUM['closeBrowser'] = False
SELENIUM['browserURL'] = BASE_URL

ORDER_OGONE_POST = "%sbasesoft.web.test/selenium/order/ogone_payment_accept/" % BASE_URL

