'''
Created on Aug 2, 2013

@author: marten
'''
from django.utils.translation import ugettext, ugettext_lazy as _
from basesoft.web.core.config import DefaultConfig
from basesoft.web.core.input.validation import plugins

class MockConfig(DefaultConfig):
    permissions = ['manage_mock_configs']
    label = _('Mock configs')
    is_expanded = False

    def configs(self):
        return [{
            'name': 'basesoft.test.mock.config',
            'label': ugettext('Mock Configuration Option'),
            'type': 'boolean'
        }, {
            'name': 'basesoft.test.mock.config.2',
            'label': ugettext('Mock Configuration Option 2'),
            'type': 'integer'
        }]

    def get_form_behaviour(self, validators, values):

        validators['basesoft.test.mock.config.2'] = [(plugins.Integer, {'max_value': 100}, )]

        return validators

license_configs = {
    'License': (MockConfig(), ),
}
