# -*- coding: utf-8 -*-

# Copyright (c) 2013 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.contrib.iconbar.models import IconBarIcon
from basesoft.web.core.exceptions import PermissionDeniedException

from django.utils.translation import ugettext_lazy as _
from basesoft.web.contrib.account.decorators import assert_user_logged_in


class MockOrderManagerIcon(IconBarIcon):

    id = 'icon-mock-order-manager'
    title = 'MockOrder manager'
    icon_index = 72
    component = 'iq_order_manager'
    group = 'test'
    colorname = 'iconbar-cerulean'

    char_main = u'\uE805'
    char_sub = u'\uE806'

    @assert_user_logged_in
    def assert_permissions(self, controller):
        controller.assert_permissions('view_orders')


def get_icons():

    return [
        MockOrderManagerIcon(),
    ]
