/**
 * # Copyright (c) 2009 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "Test Chart Legend",
	assertClean: true,

	setUp: function(){
		this.div = document.createElement('div');
		this.div.id = 'bs-chart-legend-container';
		YAHOO.util.Dom.get('sandbox').appendChild(this.div);

		this.legend_data = [{
			label: 'January',
			hex: 'cfe8fe'
		}, {
			label: 'February',
			hex: 'fad779'
		}, {
			label: 'March',
			hex: 'bbd66f'
		}, {
			label: 'April',
			hex: 'ffc397'
		}, {
			label: 'May',
			hex: 'ffa8fe'
		}, {
			label: 'June',
			hex: 'fff4b8'
		}, {
			label: 'July',
			hex: 'bdffdf'
		}, {
			label: 'August',
			hex: 'd2c9ff'
		}, {
			label: 'September',
			hex: 'ffabb7'
		}, {
			label: 'October',
			hex: 'ecabff'
		}, {
			label: 'November',
			hex: 'a88dec'
		}, {
			label: 'December',
			hex: 'c2cf69'
		}];

	},

	testChartLegend: function(){
		try {
			var legend = new BASESOFT.widget.ChartLegend({
				legend: this.legend_data,
				colsize: 6,
				title: 'Legend',
				visible: false // make it invisible from the start
			});
			this._garbage.push(legend);

			legend.render(this.div);

			var new_legend = this.legend_data;
			new_legend.pop();
			new_legend.pop();

			// reset the legend items (same as the old items, without the last two items)
			legend.set('legend', new_legend);

			// change the column size
			legend.set('colsize', 4);

			// make it visible again
			legend.set('visible', true);

			this.div.style.width = '500px';
			// make the legend use the whole width
			legend.set('full_width', true);

			// change the itemsize
			legend.set('itemsize', '100px'); // now there should be 5 items per row and rendered to div
			YAHOO.util.Assert.areEqual(legend.item_container.nodeName.toLowerCase(), 'div');

			// change the itemsize
			legend.set('itemsize', '25%'); // now there should be 4 items per row

			// change the itemsize
			legend.set('itemsize', '0'); // back to the table render
			YAHOO.util.Assert.areEqual(legend.item_container.nodeName.toLowerCase(), 'table');
		}
		catch (e) {
			console.error(e);
			throw e;
		}
	}

}));
YAHOO.register("test_chart_legend", null, {version: "1.0.0", build: "1"});
