/**
 * # Copyright (c) 2013 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new YAHOO.tool.TestCase({

	name: "CSV Parser Test",
	setUp: function() {

		YAHOO.util.Dom.get('sandbox').innerHTML = "";

	},
	test_person_dependency : function () {

		// Add first person form
		var pf1 = new BASESOFT.contact.PersonForm(null, {
			validatonRpcUrl: 'basesoft.web.contrib.account.RegistrationCompletionRPCHandler'
		}, {
			localeBrokerMethod: 'get_all_locales',
			localeBrokerFieldValue: 'value'
		});
		YAHOO.util.Dom.get('sandbox').appendChild(pf1.render());

		// Add second person form with dependency to the first.
		var pf2 = new BASESOFT.contact.PersonForm(null, {
			validatonRpcUrl: 'basesoft.web.contrib.account.RegistrationCompletionRPCHandler'
		}, {
			localeBrokerMethod: 'get_all_locales',
			localeBrokerFieldValue: 'value',
			dependency: pf1.form
		});
		YAHOO.util.Dom.get('sandbox').appendChild(pf2.render());

		// Fill the first person form
		pf1.form.set('values', {
			first_name: 'Henry',
			middle_name: 'the',
			last_name: 'Third'
		});

		// Check the dependency checkbox
		pf2.form.set('values', {is_same_person_as: true});

		// Validate state of second form.
		YAHOO.util.Assert.isTrue(YAHOO.util.Dom.hasClass(pf2._fieldsetLayout, 'hidden'));

	}
}));
YAHOO.register("test_contact_forms", null, {version: "1.0.0", build: "1"});
