/**
 * # Copyright (c) 2008 BaseSoft B.V.
 * # See LICENSE for details.
 */
(function(){

	/**
	 * TestModule
	 */
	var TestModule = function() {
		TestModule.superclass.constructor.apply(this, arguments);
	};
	YAHOO.extend(TestModule, BASESOFT.widget.Module, {
		setBody: function(){
			TestPanel.superclass.setBody.call(this);
			this.body.innerHTML = 'hello i am module';
		}
	});

	/**
	 * Overlay
	 */
	var TestOverlay = function() {
		TestOverlay.superclass.constructor.apply(this, arguments);
	};
	YAHOO.extend(TestOverlay, BASESOFT.widget.Overlay, {
		setBody: function(){
			TestPanel.superclass.setBody.call(this);
			this.body.innerHTML = 'hello i am an overlay';
		}
	});

	/**
	 * TestPanel
	 */
	var TestPanel = function(){
		TestPanel.superclass.constructor.apply(this, arguments);
	};
	YAHOO.extend(TestPanel, BASESOFT.widget.Panel, {

		setHeader: function() {
			TestPanel.superclass.setHeader.call(this, 'initital title');
		},

		setBody: function(){
			TestPanel.superclass.setBody.call(this);
			this.body.innerHTML = 'hello i am a panel';
		}
	});

	/**
	 * ModifiedTestPanel
	 */
	var ModifiedTestPanel = function() {
		ModifiedTestPanel.superclass.constructor.apply(this, arguments);
		
		//this.setTitle('aap');
	};
	YAHOO.extend(ModifiedTestPanel, TestPanel, {
		setBody: function(){
			ModifiedTestPanel.superclass.setBody.call(this);

			this._form = new BASESOFT.util.form.Form({layout: new BASESOFT.util.form.Layout({
				children: ['input1']
			})});

			this._form.appendTo(this.body);
			this._form.addInput(BASESOFT.util.form.TextInput, {label: 'input 1'},{name: 'input1'});

			this._form.updateLayout();
		},

		isModified: function() {
			return this._form.get('modified');
		}
	});

	BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

		name: "Container Test",
		//assertClean: true,

		setUp: function(){
			BASESOFT.env.OverlayManager = new YAHOO.widget.OverlayManager();
		},

		/*
		tearDown: function() {
			//BASESOFT.env.OverlayManager.destroy();
			BASESOFT.env.OverlayManager = null;
		},
		*/

		testModule: function() {
			try {
				var p = new TestModule();
				this._garbage.push(p);

				p.render();
			}
			catch (e) {
				console.error(e);
				throw e;
			}
		},

		testOverlay: function() {
			try {
				var p = new TestOverlay();
				this._garbage.push(p);

				p.render();
			}
			catch (e) {
				console.error(e);
				throw e;
			}
		},

		testPanel: function(){
			try {
				var p1 = new TestPanel();
				//this._garbage.push(p1);

				var p2 = new TestPanel();
				//this._garbage.push(p2);

				var p3 = new TestPanel();
				//this._garbage.push(p3);

				// change the title after rendering
				p3.setTitle('updated title');

				var _this = this;
				setTimeout(function () {

					_this.resume(function() {

						p1.destroy();
						p2.destroy();
						p3.destroy();

						// pass
						console.warn('done');

					});
				}, 4000);

				this.wait();
			}
			catch (e) {
				console.error(e);
				throw e;
			}
		},

		testModifiedTestPanel: function() {
			try {
				var p = new ModifiedTestPanel();
				this._garbage.push(p);
				p.render();
			}
			catch (e) {
				console.error(e);
				throw e;
			}
		}

	}));


})();


YAHOO.register("test_container", null, {version: "1.0.0", build: "1"});
