/**
 * # Copyright (c) 2009 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new YAHOO.tool.TestCase({

	name: "CSV Parser Test",
	setUp: function() {

	},
	test_csv_from_string_comma_separated: function() {
		var parser = new BASESOFT.util.CSVParser();
		parser.set('dataSource', ',header1,header2,header3\nrow1,"data1.1,somemoredata",data1.2,data1.3\nrow2,data2.1,data2.2,data2.3');
		parser.execute();
		var result = parser.get('resultSet');
		var expected = [['', 'header1', 'header2', 'header3'],
		                ['row1', 'data1.1,somemoredata', 'data1.2', 'data1.3'],
		                ['row2', 'data2.1', 'data2.2', 'data2.3']];

		var i, j;
		for(i in result) {
			for(j in result[i]) {
				YAHOO.util.Assert.areEqual(result[i][j], expected[i][j]);
			}
		}
	},
	test_csv_from_string_tab_separated: function() {
		var parser = new BASESOFT.util.CSVParser();
		parser.set('dataSource', '\theader1\theader2\theader3\nrow1\t"data1.1\tsomemoredata"\tdata1.2\tdata1.3\nrow2\tdata2.1\tdata2.2\tdata2.3');
		parser.execute();
		var result = parser.get('resultSet');
		var expected = [['', 'header1', 'header2', 'header3'],
		                ['row1', 'data1.1\tsomemoredata', 'data1.2', 'data1.3'],
		                ['row2', 'data2.1', 'data2.2', 'data2.3']];

		var i, j;
		for(i in result) {
			for(j in result[i]) {
				YAHOO.util.Assert.areEqual(result[i][j], expected[i][j]);
			}
		}
	}
}));
YAHOO.register("test_csv_parser", null, {version: "1.0.0", build: "1"});