/**
 * # Copyright (c) 2008 BaseSoft B.V.
 * # See LICENSE for details.
 */
(function () { "use strict";

BASESOFT.test.TestCases.push(new YAHOO.tool.TestCase({

		name: "Custom DataTable Test",

		setUp: function () {
			// create the container
			var form = document.createElement('form');
			this.div = document.createElement('div');
			this.div.id = 'id_mytlo';
			form.appendChild(this.div);
			YAHOO.util.Dom.get('sandbox').innerHTML = "";
			YAHOO.util.Dom.get('sandbox').appendChild(form);

			var data = [
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99', col_x: 'x with long title that should eventually wrap to the next line cuz this really is too much gbye', col_y: 'y with long title', col_z: 'z  with long title'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'},
				{id: '1', product_name: "product 1", description: 'description 1', price: '129.99'},
				{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
				{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
				{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'}
			];

			this._dsDataSource = new YAHOO.util.DataSource(data);

			var resizeable = true;

			this._dsColumnDef = [
				{key: 'id', sortable: true, resizeable: resizeable},
				{key: 'product_name', sortable: true, resizeable: resizeable, visible: false},
				{key: "description", sortable: true, resizeable: resizeable},
				{key: "price", sortable: true, resizeable: resizeable},
				{key: "col_x", sortable: true, resizeable: resizeable},
				{key: "col_y", sortable: true, resizeable: resizeable},
				{key: "col_z", sortable: true, resizeable: resizeable}
			];

			this._dsConfig = {
				show_row_selector: true,
				show_column_select: true,
				export_excel: true,
				visible_columns: ['id', 'product_name', 'description', 'price', 'col_x', 'col_y', 'col_z'],
				rows_per_page: 3,
				draggableColumns: true
			};


			this.new_row = {id: 5, product_name: 'product 5', description: 'description 5', price: '2.56'};
		},

		/**
		 * test select/unselect rows
		 */
		testSelectUnselectRows: function () {

			this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

			this.tlo.selectRow(0);
			this.tlo.selectRow(2);

			var sel = this.tlo.getSelectedRows();

			YAHOO.util.Assert.areEqual(sel.length, 2);
			YAHOO.util.Assert.areEqual(this.tlo.getRecordIndex(this.tlo.getRecord(sel[0])), 0);
			YAHOO.util.Assert.areEqual(this.tlo.getRecordIndex(this.tlo.getRecord(sel[1])), 2);

			this.tlo.unselectRow(2);
			sel = this.tlo.getSelectedRows();
			YAHOO.util.Assert.areEqual(sel.length, 1);
			YAHOO.util.Assert.areEqual(this.tlo.getRecordIndex(this.tlo.getRecord(sel[0])), 0);

		},

		/**
		 * test paginator
		 */
		testPaginator: function () {

			this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

			var pag = this.tlo.get('paginator');
			var indexes = pag.getPageRecords();

			//test rows on first page
			YAHOO.util.Assert.areEqual(indexes.length, 2);
			YAHOO.util.Assert.areEqual(indexes[0], 0);
			YAHOO.util.Assert.areEqual(indexes[1], 2);

			//select a row from first page to test if the row selection is kept when changing pages
			this.tlo.selectRow(2);
			YAHOO.util.Assert.areEqual(this.tlo.getRecordIndex(this.tlo.getRecord(this.tlo.getSelectedRows()[0])), 2);

			//change page
			YAHOO.util.Assert.isTrue(pag.hasNextPage());
			pag.setPage(2);
			indexes = pag.getPageRecords();

			//test rows on second page
			YAHOO.util.Assert.areEqual(indexes.length, 2);
			YAHOO.util.Assert.areEqual(indexes[0], 3);
			YAHOO.util.Assert.areEqual(indexes[1], 5);

			//get back to first page
			pag.setPage(1);

			//row still selected?
			YAHOO.util.Assert.areEqual(this.tlo.getRecordIndex(this.tlo.getRecord(this.tlo.getSelectedRows()[0])), 2);

		},

		/**
		 * test change visible columns attribute
		 */
		testVisibleColumns: function () {
			try {

				this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

				//all columns should be visible
				YAHOO.util.Assert.isFalse(this.tlo.getColumn('id').hidden);
				YAHOO.util.Assert.isFalse(this.tlo.getColumn('product_name').hidden);
				YAHOO.util.Assert.isFalse(this.tlo.getColumn('description').hidden);
				YAHOO.util.Assert.isFalse(this.tlo.getColumn('price').hidden);

				this.tlo.set('visible_columns', ['id', 'price']);

				YAHOO.util.Assert.isFalse(this.tlo.getColumn('id').hidden);
				YAHOO.util.Assert.isTrue(this.tlo.getColumn('product_name').hidden);
				YAHOO.util.Assert.isTrue(this.tlo.getColumn('description').hidden);
				YAHOO.util.Assert.isFalse(this.tlo.getColumn('price').hidden);

			} catch (e) {
				console.error(e);
				throw e;
			}
		},

		/**
		 * test change row selector attribute
		 */
		testRowSelector: function () {
			try {

				this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

				//first column should be the row selector column
				YAHOO.util.Assert.areEqual(this.tlo.getColumn(0).key, 'row_select');

				this.tlo.set('show_row_selector', false);

				//test no row selector column anymore
				YAHOO.util.Assert.isNull(this.tlo.getColumn('row_select'));

				//put it back
				this.tlo.set('show_row_selector', true);
				YAHOO.util.Assert.areEqual(this.tlo.getColumn(0).key, 'row_select');

			} catch (e) {
				console.error(e);
				throw e;
			}
		},

		/**
		 * test show column select attribute
		 */
		testColumnSelect: function () {
			try {

				this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

				// last column should be the column select
				YAHOO.util.Assert.areEqual(this.tlo.getColumn(8).key, 'column_select');

				this.tlo.set('show_column_select', false);

				//test no column select anymore
				YAHOO.util.Assert.isNull(this.tlo.getColumn('column_select'));

				// put it back
				this.tlo.set('show_column_select', true);
				YAHOO.util.Assert.areEqual(this.tlo.getColumn(8).key, 'column_select');

			} catch (e) {
				console.error(e);
				throw e;
			}
		},

		/**
		 * test export excel
		 */
		testExportExcel: function () {

			this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

			this._account_rpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
				executeIfLoggedOut: true
			});
			this._account_rpc.call('login', ['test_account', 'test_password'], function (result) {
				this.resume(function () {
					BASESOFT.env.account.id = result.id;

					try {

						YAHOO.util.Assert.isTrue(YAHOO.util.Dom.hasClass(this.tlo._exportImg, 'export'));
						this.tlo.exportExcel();
						this.tlo.subscribe('exportExcelFinished', function (hash) {
							this.resume(function () {
								YAHOO.util.Assert.isTrue(YAHOO.util.Dom.hasClass(this.tlo._exportImg, 'download'));
								YAHOO.util.Assert.isString(hash);
								YAHOO.util.Assert.areEqual(hash.length, 8);
							});
						}, null, this);
						this.wait();
					} catch (e) {
						console.error(e);
						throw e;
					}
				});

			}, null, this);
			this.wait();
		},

		/**
		 * test add/remove new row
		 */
		testAddRemoveRow: function () {
			try {


				var data = [
					{id: '1', product_name: "product 1", description: 'description 1', price: '129.99', col_x: 'x with long title that should eventually wrap to the next line cuz this really is too much gbye', col_y: 'y with long title', col_z: 'z  with long title'},
					{id: '2', product_name: "product 2 with a longer title", description: 'description 2', price: '5.99'},
					{id: '3', product_name: "product 3", description: 'description 3 with a longer title', price: '0.00'},
					{id: '4', product_name: "product 4", description: 'description 4', price: '59.49'}
				];

				var dsDataSource = new YAHOO.util.DataSource(data);

				this.tlo = new BASESOFT.widget.CustomDataTable(this.div, this._dsColumnDef, dsDataSource, this._dsConfig);

				this.tlo.addRow(this.new_row);

				//this new row should be the fifth
				YAHOO.util.Assert.areEqual(this.tlo.getRecordSet().getLength(), 5);

				YAHOO.util.Assert.areEqual(this.tlo.getRecord(4).getData().id, this.new_row.id);
				YAHOO.util.Assert.areEqual(this.tlo.getRecord(4).getData().product_name, this.new_row.product_name);
				YAHOO.util.Assert.areEqual(this.tlo.getRecord(4).getData().description, this.new_row.description);
				YAHOO.util.Assert.areEqual(this.tlo.getRecord(4).getData().price, this.new_row.price);

				//now remove it
				this.tlo.deleteRow(4);
				YAHOO.util.Assert.areEqual(this.tlo.getRecordSet().getLength(), 4);


			} catch (e) {
				console.error(e);
				throw e;
			}
		},

		testPanel: function () {

			this._dsConfig.rows_per_page = null;

			var p = new BASESOFT.widget.Panel({
				height: '800px',
				width: '800px'
			});
			p.setTitle('my pretty panel');

			var toolbar = null;
			//var toolbar = new BASESOFT.widget.Toolbar();
			//$(p.body).append(toolbar.get('element'));

			var div = $('<div></div>').get(0);
			p.body.appendChild(div);

			var dt = new BASESOFT.widget.CustomDataTable(div, this._dsColumnDef, this._dsDataSource, this._dsConfig);

			dt.hideColumn('product_name');
			dt.hideColumn('description');
			dt.hideColumn('price');

			dt.resize($(p.body).width(), $(p.body).height());

			p.subscribe('resize', function(ea) {

				var w = ea[0];
				var h = ea[1];

				dt.resize(w, h);

			});


		}

	}


));
})();
YAHOO.register("test_customdatatable", null, {version: "1.0.0", build: "1"});
