/**
 * # Copyright (c) 2008 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "History Widget Test",
	assertClean: true,

	setUp : function () {

		this.divText = document.createElement('div');
		this.divText.innerHTML = 'original text';
		YAHOO.util.Dom.get('sandbox').appendChild(this.divText);

		this.history = new BASESOFT.widget.HistoryPanel();
		this._garbage.push(this.history);
	},

	testUndo : function () {

		var hi = this.history.push('Edited text');

		hi.setUndo(function(text) {
			this.divText.innerHTML = text;
		}, this, [this.divText.innerHTML]);

		this.divText.innerHTML = 'edited text';

		hi.setRedo(function(text) {
			this.divText.innerHTML = text;
		}, this, [this.divText.innerHTML]);

		this.history.undo();

		YAHOO.util.Assert.areEqual(this.divText.innerHTML, 'original text');

		this.history.redo();

		YAHOO.util.Assert.areEqual(this.divText.innerHTML, 'edited text');
	}

}));
YAHOO.register("test_history", null, {version: "1.0.0", build: "1"});
