/**
 * # Copyright (c) 2008 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "Test Iconbar",
	assertClean: true,

	setUp: function() {
		this.div = document.createElement('div');
		document.body.appendChild(this.div);
	},

	testShowIconbar: function () {
		try {
			// create the iconbar
			var icons = [
				[
					{
						component: null,
						group: null,
						href: '/',
						icon_index: 0,
						id: null,
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/login.png",
						js_file: null,
						title: "Home",
						type: 'link'
					},{
						component: null,
						group: null,
						href: '/',
						icon_index: 1,
						id: null,
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/home.png",
						js_file: null,
						title: "Someone else's home",
						type: 'link'
					}
				], [
					{
						component: null,
						group: null,
						href: '/',
						icon_index: 2,
						id: null,
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/home.png",
						js_file: null,
						title: "Hotel",
						type: 'link'
					}
				], [
					{
						component: "iq_registration_form",
						group: 'accounts',
						href: '#',
						icon_index: 80,
						id: null,
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/register.png",
						js_file: null,
						title: "Register",
						type: 'link'
					}, {
						component: "icon_login",
						group: 'accounts',
						href: '#',
						icon_index: 90,
						id: "icon-login",
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/login.png",
						js_file: null,
						title: "Login",
						type: 'link'
					}, {
						component: "icon_login",
						group: 'accounts',
						href: '#',
						icon_index: 90,
						id: "icon-login",
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/login.png",
						js_file: null,
						title: "Bla",
						type: 'link'
					}, {
						component: "icon_login",
						group: 'accounts',
						href: '#',
						icon_index: 90,
						id: "icon-login",
						image: "/site_media/basesoft.web.contrib.basesoft/75x75/apps/home.png",
						js_file: null,
						title: "Blergh",
						type: 'link'
					}
				]
			];

			var iconbar = new BASESOFT.widget.IconBar(this.div, icons);
			iconbar.destroy();
			iconbar = new BASESOFT.widget.IconBar(this.div, icons);
			iconbar.destroy();
			iconbar = new BASESOFT.widget.IconBar(this.div, icons);

			this._garbage.push(iconbar);

		} catch(e){
			console.error(e);
			throw e;
		}
	}


}));
YAHOO.register("test_iconbar", null, {version: "1.0.0", build: "1"});
