/**
 * # Copyright (c) 2009 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "Infobox Test",
	setUp: function() {
		this._sandbox = YAHOO.util.Dom.get('sandbox');
	},

	test_infobox: function() {
		try {
			// create the widget (extends module)
			var ib = new BASESOFT.widget.InfoBox({'columns': 3});
			this._garbage.push(ib);
			this._sandbox.appendChild(ib.get('element'));

			// add items to first col
			var item_file = ib.addItem(0, 'Filename', 'My Survey');
			ib.addItem(0, 'Last modified', 'yesterday');

			// second col
			var item_pub = ib.addItem(1, 'Next publication', 'in two weeks');
			item_pub.set('important', true);

			// third
			var item_lang = ib.addItem(2, 'Editing language', 'Dutch');
			ib.addItem(2, 'Fallback language', 'Dutch');

			// lang is clickable
			item_lang.on('click', function(){
				console.info('clicky');
			});

			// then later at some point update the item_file
			item_file.set('value', 'My updated pretty survey');

		} catch (e) {
			console.error(e);
			throw e;
		}
	},

	test_destroy: function() {
		var ib = new BASESOFT.widget.InfoBox({'columns': 3});
		this._sandbox.appendChild(ib.get('element'));

		// add items to first col
		var item_file = ib.addItem(0, 'Filename', 'My Survey');
		ib.addItem(0, 'Last modified', 'yesterday');

		ib.destroy();
	}
}));

YAHOO.register("test_infobox", null, {version: "1.0.0", build: "1"});
