/*
 *
 */
BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name : "License Test",
	assertClean : true,

	s4 : function () {
	  return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
	},

	setUp : function() {
		this.div_wizard = document.createElement('div');
		YAHOO.util.Dom.get('sandbox').appendChild(this.div_wizard);
		YAHOO.util.Dom.get('sandbox').appendChild(document.createElement('br'));
	},
	/*
	 * This tests saving a license with the wizard and then loading it in the LicenseDetailsPanel
	 */
	testSaveAndLoad : function() {

		var date = new Date();
		var license_state = {
			state : {
				license : {
					name : "test_license_" + this.s4(),
					expiration_date : null,
					polymorphic_type : 'License',
					is_default: true
				},
				domain : {
					name : "test_domain_" + this.s4()
				},
				group : {
					name : "test_group_" + this.s4()
				},
				contact_person : {
					first_name : "John",
					last_name : "Smith",
					email : "john@mail-test.basesoft.com"
				},
				company : {
					name : "A Company",
					vat_no : "123456789"
				},
				permissions : [1],
				usage_options : []
			}
		};

		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], function(result) {
			this.resume(function() {
				try {
					BASESOFT.env.account.id = result.id;

					var licenseWizard = new BASESOFT.license.Wizard(this.div_wizard, {
						'title' : 'New License'
					});
					this._garbage.push(licenseWizard);
					licenseWizard.save_license(license_state);
					licenseWizard.subscribe('onFinished', function(license_id) {
						this.resume(function() {
							try {
								var ldp = new BASESOFT.license.LicenseDetailsPanel(license_id);
								this._garbage.push(ldp);
								ldp.subscribe("onLicenseStateLoaded", function(args) {
									// args is the loaded license state
									this.resume(function() {
										var ls = license_state.state;

										// test the names by getting the first chars which are the constant
										YAHOO.util.Assert.areEqual(args.license.name.substring(0, 13), ls.license.name.substring(0, 13));
										YAHOO.util.Assert.areEqual(args.domain.name.substring(0, 12), ls.domain.name.substring(0, 12));
										YAHOO.util.Assert.areEqual(args.group.name.substring(0, 11), ls.group.name.substring(0, 11));

										YAHOO.util.Assert.areEqual(args.contact_person.first_name, ls.contact_person.first_name);
										YAHOO.util.Assert.areEqual(args.contact_person.email, ls.contact_person.email);
										YAHOO.util.Assert.areEqual(args.company.name, ls.company.name);
										YAHOO.util.Assert.areEqual(args.permissions.length, ls.permissions.length);
										YAHOO.util.Assert.areEqual(args.permissions[0], ls.permissions[0]);
										YAHOO.util.Assert.areEqual(args.usage_options.length, ls.usage_options.length);

										// give some time to let rpc calls time out
										var _this = this;
										setTimeout(function() {
											_this.resume(function() {
											});
										}, 3000);
										this.wait();

									});
								}, null, this);
								this.wait();
							} catch (e) {
								e.delay || console.error(e);
								throw e;
							}
						});
					}, null, this);
					this.wait();
				} catch (e) {
					e.delay || console.error(e);
					throw e;
				}
			});
		}, null, this);
		// wait for login callback
		console.debug('waiting for login..');
		this.wait();
	},
	testWizard : function() {

		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], function(result) {
			this.resume(function() {
				try {
					BASESOFT.env.account.id = result.id;

					var licenseWizard = new BASESOFT.license.Wizard(this.div_wizard, {
						'title' : 'New License'
					});
					this._garbage.push(licenseWizard);
					var activeIndex = licenseWizard.get('activeIndex');
					// Skip to the Summary page (this also skips the form behavior)
					licenseWizard.set('activeIndex', activeIndex + 5);
					// Set the page back to the first page and assert the inputs are visible.
					licenseWizard.set('activeIndex', activeIndex);

					// Work around, we should find a better way to wait for the readiness of the forms.
					var _this = this;
					setTimeout(function() {
						_this.resume(function() {
							// Accessing PROTECTED var for assertion. Sorry.
							var form = licenseWizard.__forms.dl;
							YAHOO.util.Assert.areEqual(3, form.get('layout').get('element').childNodes[1].childNodes.length);
							YAHOO.util.Assert.areEqual(6, form.get('layout').get('element').childNodes[1].childNodes[0].childNodes.length);
							YAHOO.util.Assert.areEqual(1, form.get('layout').get('element').childNodes[1].childNodes[0].childNodes[0].childNodes[0].childNodes.length);
						});
					}, 2000);
					this.wait();

				} catch (e) {
					e.delay || console.error(e);
					throw e;
				}
			});
		}, null, this);
		this.wait(15000);

	},
	testGroupManager : function() {
		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], function(result) {
			this.resume(function() {
				BASESOFT.env.account.id = result.id;

				var gm = new BASESOFT.license.GroupManager(1);

				gm._cq.subscribe('dataLoaded', function() {

					this.resume(function() {

						// TODO: add asserts
						this._garbage.push(gm);
						// noop
					});
				}, null, this);

				this.wait();
			});
		}, null, this);
		this.wait(15000);
	},
	testHookWizard : function() {

		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], function(result) {
			this.resume(function() {
				BASESOFT.env.account.id = result.id;
				try {
					var bangarang = new BASESOFT.license.HookWizard(this.div_wizard, {
						'title' : 'New privilege hook'
					});

					// TODO: add asserts

					// The Lost Boys and Peter Pan will get rid of Hook! RUFIO! RUFIO! BANGARANG!
					this._garbage.push(bangarang);

				} catch (e) {
					e.delay || console.error(e);
					throw e;
				}
			});
		}, null, this);
		this.wait(15000);

	},
	testPrivilegeDelegation : function() {
		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], function(result) {
			this.resume(function() {
				BASESOFT.env.account.id = result.id;

				var contact_rpc = new BASESOFT.util.JsonBroker('/basesoft.web.test/selenium/contact_manager/test_data/rpc/', 60000);
				contact_rpc.call('create_contact', [], function(result) {
					this.resume(function() {
						try {
							var pd = new BASESOFT.license.PrivilegeDelegation('Contact', result, 'Johnny Depp');
							this._garbage.push(pd);

							pd.subscribe('initialized', function() {

								this.resume(function() {

									pd._cq.subscribe('dataLoaded', function() {

										this.resume(function() {
											// TODO: add asserts
										});
									}, null, this);

									this.wait();

								});
							}, null, this);

							this.wait();

						} catch (e) {
							console.error(e);
							throw e;
						}

					});
				}, null, this);
				this.wait(15000);
			});
		}, null, this);
		this.wait(15000);
	},

	testObjectBrowser : function() {
		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], function(result) {
			this.resume(function() {
				BASESOFT.env.account.id = result.id;

				var cq = new BASESOFT.license.ObjectBrowser();


			});
		}, null, this);
		this.wait(15000);
	}

}));

YAHOO.register("test_license_wizard", null, {
	version : "1.0.0",
	build : "1"
});
