/*
 * Copyright (c) 2008 BaseSoft Solutions B.V.
 * See LICENSE for details.
 */

(function(){

	/**
	 * TestPanel
	 */
	var TestMenuPanel = function(){
		TestMenuPanel.superclass.constructor.apply(this, arguments);
	};
	YAHOO.extend(TestMenuPanel, BASESOFT.widget.Panel, {

		setHeader: function(){
			TestMenuPanel.superclass.setHeader.call(this, 'initital title');
		},

		setBody: function(){
			TestMenuPanel.superclass.setBody.call(this);
			this.body.innerHTML = 'hello i am a menu panel';

			var menu = new BASESOFT.widget.Menu();
			menu.addItems(menuItems());

			// yahoo menu button
			var menuButton = new YAHOO.widget.Button({
				type: "menu",
				label: 'clicky',
				container: this.body,
				menu: menu.element,
				menualignment: ['tr', 'br']
			});

			menu.clearContent();

			this._garbage.push(menuButton);

		}
	});

	var menuItems = function(){
		return [{
			'text': 'menu 0',
			'onclick': {
				fn: function(){
					console.info('clicky menu 0');
				},
				scope: this
			},
			'checked': true
		}, {
			'text': 'menu 1',
			'submenu': {
				'id': 'id_menu_1',
				'width': 300,
				'itemdata': [{
					'text': 'menu 1.1 but with text that doesnt fit in the box'
				}, {
					'text': 'menu 1.2',
					'submenu': {
						'id': 'id_menu_1_2',
						'itemdata': [{
							'text': 'menu 1.2.1'
						}, {
							'text': 'menu 1.2.2'
						}, {
							'text': 'menu 1.2.3'
						}]
					}
				}, {
					'text': 'menu 1.3 but also with a really long text',
					'submenu': {
						'id': 'id_menu_1_3',
						'itemdata': [{
							'text': 'menu 1.3.1'
						}, {
							'text': 'menu 1.3.2'
						}, {
							'text': 'menu 1.3.3'
						}]
					}

				}]
			}
		}, {
			'text': 'menu 2 but with a really long text'
		}];
	};


	BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

		name: "Menu",
		assertClean: true,

		setUp: function(){
			this._sandbox = YAHOO.util.Dom.get('sandbox');
			this._sandbox.style.textAlign = 'right';
		},

		test_button_menu: function(){
			try {
				var menu = new BASESOFT.widget.Menu({width: 200});
				this._garbage.push(menu);
				menu.addItems(menuItems());

				// yahoo menu button
				var menuButton = new YAHOO.widget.Button({
					type: "menu",
					label: 'clicky',
					container: this._sandbox,
					menu: menu.element,
					menualignment: ['tr', 'br']
				});
				this._garbage.push(menuButton);
			}
			catch (e) {
				console.error(e);
				throw e;
			}

		},

		test_menu_clear: function(){
			var menu = new BASESOFT.widget.Menu();
			this._garbage.push(menu);

			this._sandbox.appendChild(menu.element);
			menu.addItems(menuItems());
			menu.clearContent();
			menu.addItems(menuItems());
		},

		test_menu_panel: function() {
			try {
				var p = new TestMenuPanel();
				this._garbage.push(p);
			} catch (e) {
				console.error(e);
				throw e;
			}
		}

	}));


})();

