/**
 * # Copyright (c) 2010 BaseSoft B.V.
 * # See LICENSE for details.
 *
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name : "env Notification test",
	assertClean : true,

	setUp : function() {
	},
	/**
	 * Tests system notification
	 */
	testCreateSystemNotification : function() {

		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		this._garbage.push(loginrpc);
		loginrpc.call('login', ['test_account', 'test_password'], function(result) {
			this.resume(function() {// continue the test after login
				BASESOFT.env.account.id = result.id;

				// send to test_account (group 1)
				var ev = BASESOFT.env.notification.create_system_notification('test subject', 'test content', 1, null, true, false, false);
				ev.subscribe(function(args, evargs) {
						// if event was fired, all was ok
						// event param should be a notification id
						YAHOO.util.Assert.areEqual( typeof (evargs[0]), "number");
				}, null, this);
			});
		}, null, this);
		this.wait();
		// wait for login
	},
	/**
	 * Tests user send notification
	 */
	testCreateNotification : function() {
		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {
			executeIfLoggedOut : true
		});
		this._garbage.push(loginrpc);
		loginrpc.call('login', ['test_account', 'test_password'], function(result) {
			this.resume(function() {// continue the test after login
				BASESOFT.env.account.id = result.id;

				// send to this account's whole license
				var ev = BASESOFT.env.notification.create_notification('test subject u', 'test content u', 1, false, true, false);
				ev.subscribe(function(args, evargs) {
					this.resume(function() {
						// if event was fired, all was ok
						// event param should be a notification id
						YAHOO.util.Assert.areEqual( typeof (evargs[0]), "number");
					});
				}, null, this);
				this.wait();
			});
		}, null, this);
		this.wait();
		// wait for login
	}
}));
YAHOO.register("test_notification", null, {
	version : "1.0.0",
	build : "1"
});
