/**
 * # Copyright (c) 2008 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "Notify Test",
	assertClean: true,

	setUp : function () {
		// create the container in which notifications are shown
		var div = document.createElement('div');
		div.id = 'bs-notify-container';
		YAHOO.util.Dom.get('sandbox').appendChild(div);
	},

	/**
	 */
	testInformation : function () {
		try {
			var n = new BASESOFT.widget.Notify('Information message');
			this._garbage.push(n);

			n.addMessage('The new user account has been created correctly');
		}
		catch (e) {
			console.error(e);
			throw e;
		}
	},

	testWarning : function () {
		try {
			var n = new BASESOFT.widget.Notify('Please correct the following form errors', 'warning');
			this._garbage.push(n);

			n.addMessage('Name is required');
			n.addMessage('Telephone number is numeric');
			n.addMessage('VAT number is invalid');
		}
		catch (e) {
			console.error(e);
			throw e;
		}
	},

	testError : function () {
		try {
			var n = new BASESOFT.widget.Notify('Unable to save the new user account', 'error');
			this._garbage.push(n);

			n.addMessage('Cannot connect to the database');
		}
		catch (e) {
			console.error(e);
			throw e;
		}
	}

}));


YAHOO.register("test_notify", null, {version: "1.0.0", build: "1"});
