/**
 * # Copyright (c) 2010 BaseSoft B.V.
 * # See LICENSE for details.
 *
 * This TestCase tests the rgraph library.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "RGraph Test",
	assertClean: true,

	setUp : function () {
		this.canvas = document.createElement('canvas');
		this.canvas.width = 480;
		this.canvas.height = 320;
		this.canvas.id = YAHOO.util.Dom.generateId();
		BASESOFT.util.Dom.initCanvas(this.canvas); // need to do this so the canvas works properly on IE

		this.canvas2 = document.createElement('canvas');
		this.canvas2.width = 480;
		this.canvas2.height = 320;
		this.canvas2.id = YAHOO.util.Dom.generateId();
		BASESOFT.util.Dom.initCanvas(this.canvas2);

		YAHOO.util.Dom.get('sandbox').appendChild(this.canvas);
		YAHOO.util.Dom.get('sandbox').appendChild(this.canvas2);
		YAHOO.util.Dom.get('sandbox').appendChild(document.createElement('br'));
	},

	testRGraph: function () {
		/**
		 * draw some graph
		 */

		try {
			// a simple barchart
			var data = [280, 45, 133, 166, 84, 259, 266, 960, 219, 311, 67, 89];
			var bar = new RGraph.Bar(this.canvas.id, data);

			bar.Set('chart.labels', ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']);
			bar.Set('chart.gutter', 35);
			bar.Draw();

			// add also a line chart with zoom, so we can see if new events are generated
			var line1data = [0,300,500,600,100,200,400,500,700,800,400,100];
			var line2data = [500,400,500,700,300,300,500,600,700,800,600,300];
			var line3data = [400,200,400,500,300,300,400,500,400,100,400,300];
			var line = new RGraph.Line(this.canvas2.id, line1data, line2data, line3data);
			line.Set('chart.key', ['2008', '2007', '2006']);
			line.Set('chart.key.background', '#fff');
			line.Set('chart.key.shadow', true);
			line.Set('chart.gutter', 45);

			if (!document.all) { // this is not implemented on IE (this is how RGraph checks things)
				line.Set('chart.zoom.mode', 'thumbnail');
			}

			line.Set('chart.filled', true);
			line.Set('chart.tickmarks', null);
			line.Set('chart.background.barcolor1', 'white');
			line.Set('chart.background.barcolor2', 'white');
			line.Set('chart.title', 'A line chart (zoom, Y axis on the right)');
			line.Set('chart.colors', ['rgba(169, 222, 244, 0.7)', 'red', '#ff0']);
			line.Set('chart.fillstyle', ['#daf1fa', '#faa', '#ffa']);
			line.Set('chart.labels', ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec']);
			line.Set('chart.yaxispos', 'right');
			line.Set('chart.linewidth', 5);
			line.Draw();

			// remove one of the canvas nodes to check that all is still good
			YAHOO.util.Dom.get('sandbox').removeChild(this.canvas);
		} catch (e) {
			console.debug('Exception', e);
			throw e;
		}
	}

}));


YAHOO.register("test_rgraph", null, {version: "1.0.0", build: "1"});
