/**
 * # Copyright (c) 2009 BaseSoft B.V.
 * # See LICENSE for details.
 */

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "RTE Test",

	setUp: function() {
		this.textarea = document.createElement('textarea');
		this.textarea.id = 'bs-rte-container';
		this.textarea.style.width = '800px';
		this.textarea.style.height = '300px';
		YAHOO.util.Dom.get('sandbox').appendChild(this.textarea);
	},

	test_rte: function() {
		try {

			var rf = {
				'Survey': { 'iquest.survey.link': 'Survey link' },
				'Person': {
					'person.department': 'Department',
					'person.first_name': 'First name',
					'person.last_name': 'Last name',
					'person.title': 'Title'
				}
			};

			var callbackContent = function(value) {
				return 'content for ' + value;
			};

			var hf = {
				items: [
					{ text: 'Header 1', value: 1 },
					{ text: 'Footer 2', value: 2 }
				],
				contentCallback: callbackContent
			};

			// create the widget
			var rte = new BASESOFT.widget.RTE(this.textarea, {
				replacementFields: rf,
				headerFooterConfig: hf,
				filterPaste: true
			});
			rte.render();

			this._garbage.push(rte);

			// test resumes when toolbar is loaded
			rte.on('toolbarLoaded', function() {
				this.resume(function() { });
			}, null, this);

			this.wait(10000);

		} catch (e) {
			console.error(e);
			throw e;
		}
	}

}));

YAHOO.register("test_rte", null, {version: "1.0.0", build: "1"});
