


from basesoft.web.core.jsonrpc.dispatcher import JsonRpcDispatcher

from basesoft.web.contrib.contact.controllers import ContactController
from basesoft.web.contrib.contact.models import Contact, Person


def rpc(request):

    class handler:

        def fill_data(self):


            self.controller = ContactController(request.Session(), account_id = request.session['user_id'])

            # trash all contacts
            self.controller.delete_contacts(self.controller.get_contacts(priv=Contact.PRIV_DELETE))


            # contact variations
            departments = [u'Cleaning', u'Marketing', u'Sales', u'Director', u'IT']
            positions = [u'Assistent', u'Manager', U'Boss']
            genders = [Person.MALE, Person.FEMALE]


            # contact template
            person_data = {'first_name': u'John',
                            'middle_name': u'',
                            'last_name': u'Smith',
                            'title': u'mr',
                            'gender': Person.MALE,
                            'email': u'john@mail-test.basesoft.com',
                            'position': u'assistent',
                            'department': u'marketing',
                            'phone': u'0040123456789',
                            'mobile_phone': '',
                            'fax': '',
                            'birth_date': '1978-10-10',
                            'address_data': {'country': '181',
                                             'postcode': u"400295",
                                             'street': u" Bihorului 10",
                                             'city': u"Cluj Napoca",
                                             'state': u"Cluj"
                                            }
                           }


            # create some contacts
            rv = []
            for i in range(200):

                person_data['first_name'] = u'John %s' % i
                person_data['department'] = departments[ i % len(departments) ]
                person_data['position'] = positions[ i % len(positions) ]
                person_data['gender'] = genders[ i % len(genders) ]

                contact = self.controller.save_or_update_contact(id=None, person_data = person_data)
                rv.append({'contact_id': contact.id, 'person_id': contact.person.id})
            return rv





    dispatcher = JsonRpcDispatcher()
    dispatcher.register_instance(handler())
    return dispatcher.handle_request(request)


