"""
"""

import time

from django.http import HttpResponseRedirect, HttpResponse, HttpRequest
from django.conf import settings
from basesoft.web.contrib.order.views import payment_method_ogone_direct_accept
from basesoft.web.contrib.order.controllers import OgonePaymentController
from basesoft.web.core.util.db import Session

def ogone_payment_accept(request):
    """
    this view acts like it would be the ogone payment server. it receives the POST from our form like this:

    request.POST looks something like:
    ORDERID=8&CN=InvoiceFirstName+InvoiceLastName&LANGUAGE=en_GB&PSPID=selenium_accept&OWNERTOWN=Shanghai&OWNERCTY=Belgium&EXCEPTIONURL=http%3A%2F%2Fmartijn-i7.dev.bcn%3A8000%2Fbasesoft.web.contrib.order%2Fpayment_method%2Fogone%2Fselenium_accept%2Fexception%2F&OWNERTELNO=234234235&OWNERZIP=GA+SHA&CURRENCY=EUR&AMOUNT=45375&DECLINEURL=http%3A%2F%2Fmartijn-i7.dev.bcn%3A8000%2Fbasesoft.web.contrib.order%2Fpayment_method%2Fogone%2Fselenium_accept%2Fdecline%2F&SHASIGN=377A4ECB94A136557FD86DEAED51B882CB277804&TITLE=PV+Cycle+Payment+Gateway&CANCELURL=http%3A%2F%2Fmartijn-i7.dev.bcn%3A8000%2Fbasesoft.web.contrib.order%2Fpayment_method%2Fogone%2Fselenium_accept%2Fcancel%2F&ACCEPTURL=http%3A%2F%2Fmartijn-i7.dev.bcn%3A8000%2Fbasesoft.web.contrib.order%2Fpayment_method%2Fogone%2Fselenium_accept%2Faccept%2F&OWNERADDRESS=Some+Shanghai+Street+Name
    """

    psp_id = 'selenium_accept'
    sha_out = 'Tuut1234'
    order_id = request.POST['ORDERID']

    # just like the ogone server would, send a POST with payent info to the iqportal accept view
    # should be something like {u'orderID': [u'104'], u'STATUS': [u'9'], u'IP': [u'77.248.103.186'], u'PAYID': [u'26300663'], u'CN': [u'Base Soft'], u'NCERROR': [u'0'], u'TRXDATE': [u'12/20/13'], u'CARDNO': [u'XXXXXXXXXXXX1111'], u'BRAND': [u'VISA'], u'ACCEPTANCE': [u'test123'], u'currency': [u'EUR'], u'amount': [u'302.5'], u'SHASIGN': [u'3EFBD7E3F6AFDDFFC3D2DCA9424A9BDDCCC70C52'], u'ED': [u'1026'], u'PM': [u'CreditCard']}>"
    request2 = HttpRequest()
    request2.Session = Session
    request2.session = {}
    request2.POST = {
        'ACCEPTANCE': 'test123',
        'BRAND': 'VISA',
        'CARDNO': 'XXXXXXXXXXXX1111',
        'CN': 'InvoiceFirstName InvoiceLastName',
        'ED': '0115',
        'IP': '80.28.174.236',
        'NCERROR': '0',
        'PAYID': '26024396',
        'PM': 'CreditCard',
        'STATUS': '9', # status accept
        'TRXDATE': '12/11/13',
        'AMOUNT': '453.75',
        'CURRENCY': 'EUR',
        'orderID': order_id,
    }

    request2.POST['SHASIGN'] = OgonePaymentController.ogone_hash(request2.POST, sha_out)
    time.sleep(1); payment_method_ogone_direct_accept(request2, psp_id)

    # then redirect the user to the ACCEPTURL from POST
    return HttpResponseRedirect(request.POST['ACCEPTURL'])
