# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.test.selenium import selenium_testcase
from twisted.trial.unittest import SkipTest

class TestCase(selenium_testcase.SeleniumTestCase):
    def setUp(self):
        super(TestCase, self).setUp()
        self.connect_db()

    def test_switch_account_different_theme(self):
        raise SkipTest('Temporarily disabled.')

        manager = self._create_active_account()
        self._attach_permissions_to_group(manager.default_group, 'view_dashboard', 'view_license', 'switch_account')

        switch_to = self._create_active_account(license=manager.default_group.license)
        switch_to.set_config('basesoft.web.core.media.themes', 'newcom_theme_default')
        self._attach_permissions_to_group(switch_to.default_group, 'view_dashboard')

        self.login(manager.name, 'test_password')
        self.wait_for_loading()

        self.click_iconbar('icon-account-manager', hover='icon-license-manager')
        self.wait_for_loading()

        self.filter_cq(panel_name='account-manager', filters=[
            ('Account', 'Equal', switch_to.name),
        ])

        self.click_cq(panel_name='account-manager', row_index=0, col_name='switch_to_user')
        self.wait_for_loading()

        # Bug #4857 prevented the icon bar from showing and this would fail
        self.click_iconbar('icon-settings')
        self.wait_for_loading()

        target = self._driver.find_element_by_css_selector('div#header_title_middle div:first-child')
        self.assertEqual(target.text.strip(), 'IQPortal - Newcom - Research & Consultancy')

