'''
Created on Feb 6, 2015

@author: rado
'''
from basesoft.web.test.selenium.selenium_testcase import SeleniumTestCase
from basesoft.web.contrib.account.models import Account
import os
from basesoft.web.contrib.file.models import FileTmp

class TestCase(SeleniumTestCase):

    def setUp(self):
        super(TestCase, self).setUp()

        self.connect_db()

        self.acc = self.sa_session.query(Account).filter(Account.name == 'sysadmin').one()
        self.group = self.acc.groups[0].group
        self._attach_permissions_to_group(self.group, 'file_manager', 'create_file', 'view_file')

    def test_file_upload(self):
        # login with account
        self.login(self.acc.name, 'RaKa4Rucru8r')
        self.wait_for_loading()

        #open file manager
        self.click_iconbar('icon-file-manager')

        # upload file from manager menu
        self.click_menu('bs-file-manager', menu_index=1, text='Upload file')
        self.wait_for_loading()

        self.fill_form(panel_name='bs-file-upload', values={'category': ('input_text', 'Testing')})
        self.click_button(panel_name='bs-file-upload', text='Save')

        # it takes a second for the growl to show up
        import time
        time.sleep(1)
        self.assert_growl_errors_present()

        # upload a file
        csv_file_path = os.path.join(os.path.dirname(__file__), 'related', 'contacts.csv')
        self.fill_form(panel_name='bs-file-upload', values={
            'hashes': ('upload', csv_file_path),
        })

        self.click_button(panel_name='bs-file-upload', text='Save')
        self.assert_no_growl_errors()

        # check that file is saved
        f = self.sa_session.query(FileTmp).order_by(FileTmp.id.desc()).first()
        self.assertEqual(f.file_name, 'contacts.csv')

