# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from datetime import datetime, timedelta

from basesoft.web.test.unit import iqportal_unittest

from basesoft.web.core.schedule import PrivilegeObjectGarbageCollectorTask
from basesoft.web.test.models import MockPrivilegeObject

class ScheduleTestCase(iqportal_unittest.IQPortalTestCase):
    def setUp(self):
        self.connect_db()

    def test_privileged_object_garbage_collector(self):

        obj = MockPrivilegeObject()
        obj.name = 'random'
        obj.deleted = True
        obj.last_updated = datetime.now()+timedelta(days=-31)
        self.session.add(obj)
        self.session.flush()

        id = obj.id

        PrivilegeObjectGarbageCollectorTask().execute()

        result = self.session.query(MockPrivilegeObject).filter(MockPrivilegeObject.id==id).all()
        self.assertEqual(len(result),0)
