# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.test.unit import iqportal_unittest
from basesoft.web.core.input.validation.plugins import StrongPassword
from django.forms.util import ValidationError

class StrongPasswordTestCase(iqportal_unittest.IQPortalTestCase):
    """
    StrongPassword plugin test case
    """

    def test_strong_password(self):
        """
        test different passwords against the StrongPassword plugin
        """

        #password too short
        st = StrongPassword('ele');
        self.assertRaises(ValidationError, st.check)

        #dictionary word
        st = StrongPassword('elephant');
        self.assertRaises(ValidationError, st.check)

        #reversed dictionary word
        st = StrongPassword('tnahpele');
        self.assertRaises(ValidationError, st.check)

        #not enought different characters
        st = StrongPassword('alabala');
        self.assertRaises(ValidationError, st.check)

        #too simplistic
        st = StrongPassword('abcdefghij');
        self.assertRaises(ValidationError, st.check)

        #good password
        st = StrongPassword('G00dPass');
        self.assertTrue(st.check)
