
BASESOFT.test.TestCases.push(new YAHOO.tool.TestCase({

	name: "DataTableCube TestCase",

	setUp : function () {
		// prepare a container where we can build the table into
		this.div = YAHOO.util.Dom.get('sandbox');
		this.div.innerHTML = ''; // clear

		// json rpc
		this.testcase_rpc = new BASESOFT.util.JsonBroker('/iqportal.iqreport.test/selenium/yui/rpc/');
		this.login_rpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/');
		this.iqreport_rpc = new BASESOFT.util.JsonBroker('/iqportal.iqreport.core/rpc/');

	},

	testTable1 : function () {

		/**
		 * This tests the building of a DataTableCube by just building it and see if
		 * we dont get any errors. More assertions would be nice but for now its ok.
		 *
		 * Any bugs in the datatable cube should be tested here
		 */

		try {

			var headersDefs = {
				columns: [{
					'key': 'key_col_1',
					'label': '1',
					'children': [{
						'key': 'key_col_1_1',
						'label': 'Col 1_1',
						'children': [{
							'key': 'key_col_1_1_1',
							'label': 'Row 1_1_1'
						}, {
							'key': 'key_col_1_1_2',
							'label': 'Col 1_1_2'
						}]
					}]
				}, {
					'key': 'key_col_2',
					'label': '2'
				}, {
					'key': 'key_col_3',
					'label': '3'
				}],
				rows: [{
					'key': 'key_row_1',
					'label': 'Row 1',
					'children': [{
						'key': 'key_row_1_1',
						'label': 'Row 1_1',
						'children': [{
							'key': 'key_row_1_1_1',
							'label': 'Row 1_1_1'
						}, {
							'key': 'key_row_1_1_2',
							'label': 'Row 1_1_2'
						}]
					}, {
						'key': 'key_row_1_2',
						'label': 'Row 1_2',
						'children': [{
							'key': 'key_row_1_2_1',
							'label': 'Row 1_2_1'
						}, {
							'key': 'key_row_1_2_2',
							'label': 'Row 1_2_2'
						}]
					}]
				}, {
					'key': 'key_row_2',
					'label': 'Row 2',
					'children': [{
						'key': 'key_row_2_1',
						'label': 'Row 2_1',
						'children': [{
							'key': 'key_row_2_1_1',
							'label': 'Row 2_1_1'
						}, {
							'key': 'key_row_2_1_2',
							'label': 'Row 2_1_2'
						}]
					}, {
						'key': 'key_row_2_2',
						'label': 'Row 2_2',
						'children': [{
							'key': 'key_row_2_2_1',
							'label': 'Row 2_2_1'
						}, {
							'key': 'key_row_2_2_2',
							'label': 'Row 2_2_2'
						}]
					}]
				}, {
					'key': 'key_row_3',
					'label': 'Row 3',
					'children': [{
						'key': 'key_row_3_1',
						'label': 'Row 3_1',
						'children': [{
							'key': 'key_row_3_1_1',
							'label': 'Row 3_1_1'
						}, {
							'key': 'key_row_3_1_2',
							'label': 'Row 3_1_2'
						}]
					}, {
						'key': 'key_row_3_2',
						'label': 'Row 3_2',
						'children': [{
							'key': 'key_row_3_2_2',
							'label': 'Row 3_2_1'
						}, {
							'key': 'key_row_3_2_2',
							'label': 'Row 3_2_2'
						}]
					}]
				}]
			};

			var data = [['blebleblebleble', 2, 3], [4, 5, 6], [7, 8, 9], [10, 11, 12], [13, 14, 15], [16, 17, 18]];

			var oDataSource = new YAHOO.util.DataSource(data);
			oDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
			oDataSource.responseSchema = {
				fields: ['key_col_1_1_1', 'key_col_1_1_2', 'key_col_2', 'key_col_3']
			};

			var table = new BASESOFT.widget.DataTableCube('sandbox', headersDefs, oDataSource);

			// start asserting.. we probably need some more in the future

			// try to get a column
			oTestColumn = table.getColumn("key_row_3_2");
			YAHOO.util.Assert.areSame('Row 3_2', oTestColumn.label);
			YAHOO.util.Assert.areSame('key_row_3_2', oTestColumn.key);

		} catch (e) {
			console.error(e);
			throw e;
		}
	},

	/**
	 * A testcase from a non working mdx
	 */
	testTable2 : function () {
		try {
			var columnDef = {
				"rows": [{
					"mdxkey": "[Lampen-Recycling und Service GmbH]",
					"key": "a5a8a6d5b84a9a1927b7c35526badcf4",
					"label": "Lampen-Recycling und Service GmbH"
				}, {
					"mdxkey": "[ZEOS d.o.o.]",
					"key": "3d933f939368c951ff0eb3ccf526d450",
					"label": "ZEOS d.o.o."
				}, {
					"mdxkey": "[Ekogaisma]",
					"key": "c09f3609e9c95224dfef8c356fb92d47",
					"label": "Ekogaisma"
				}, {
					"mdxkey": "[Ekogaisma SIA Eesti filiaal]",
					"key": "a2bb16f546916fad35d134431473aeee",
					"label": "Ekogaisma SIA Eesti filiaal"
				}, {
					"mdxkey": "[Lyskildebranchens WEEE Forening]",
					"key": "34c5add9036af1d2de7b1c5da7ca1cc4",
					"label": "Lyskildebranchens WEEE Forening"
				}, {
					"mdxkey": "[Asociatia Recolamp]",
					"key": "3e8252a3cddc23db0a5618b56bc4d90f",
					"label": "Asociatia Recolamp"
				}, {
					"mdxkey": "[Elektroeko]",
					"key": "1feaa6ff9bf84b2ae278e9009f76c325",
					"label": "Elektroeko"
				}, {
					"mdxkey": "[Consorzio Ecolamp]",
					"key": "492d64f19b4ba48ab1440a299e84c1e1",
					"label": "Consorzio Ecolamp"
				}, {
					"mdxkey": "[Recolight Limited]",
					"key": "a17178dabbd69c1f9a10cadfd8310e4e",
					"label": "Recolight Limited"
				}, {
					"mdxkey": "[Elektroeko (Luminaires)]",
					"key": "7780471ff8a87a1e22ce7ea6bf931d2d",
					"label": "Elektroeko (Luminaires)"
				}],
				"columns": [{
					"mdxkey": "[Cat 2 - Small Appliances]",
					"children": [{
						"mdxkey": "[Cat 2 - Small Appliances][Quantity]",
						"key": "74592ae82fbc6332727a4d6187e7e5bb",
						"label": "Quantity"
					}],
					"key": "addb5e6e3a722c2ae1b4b3551a76912b",
					"label": "Cat 2 - Small Appliances"
				}, {
					"mdxkey": "[Cat 5 (1,6) - Luminaires]",
					"children": [{
						"mdxkey": "[Cat 5 (1,6) - Luminaires][Quantity]",
						"key": "da01addd9b06f59b6e399ca9eb6294dd",
						"label": "Quantity"
					}],
					"key": "dd9408f50bec73719d23d966d88d0ca2",
					"label": "Cat 5 (1,6) - Luminaires"
				}, {
					"mdxkey": "[Cat 5 (2-5) - Lamps]",
					"children": [{
						"mdxkey": "[Cat 5 (2-5) - Lamps][Quantity]",
						"key": "4a17b4080115e50dc105f2a166622039",
						"label": "Quantity"
					}],
					"key": "901e5ceae451020b7602cacb488592cf",
					"label": "Cat 5 (2-5) - Lamps"
				}]
			};
			var data = [[1, "2579971", 'bier'], [null, null, "688126"], [null, null, "41544308"], [null, null, "2237895"], [null, null, "1825285"], [null, null, "14751002"], ["1661", "74775", "50792965"], [null, null, "1402857"], [null, "652748", "4124628"], [null, null, "94308107"]];
			var oDataSource = new YAHOO.util.DataSource(data);
			oDataSource.responseType = YAHOO.util.DataSource.TYPE_JSARRAY;
			oDataSource.responseSchema = {
				fields: ['74592ae82fbc6332727a4d6187e7e5bb', 'da01addd9b06f59b6e399ca9eb6294dd', '4a17b4080115e50dc105f2a166622039']
			};

			var table = new BASESOFT.widget.DataTableCube('sandbox', columnDef, oDataSource);

		} catch(e) {
			console.error(e);
			throw e;
		}
	}

}));

YAHOO.register("test_datatablecube", null, {version: "1.0.0", build: "1"});
