# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.


from basesoft.web.core.jsonrpc.dispatcher import JsonRpcDispatcher
from basesoft import logging
logger = logging.getLogger("iqreport.test.yui")

def rpc(request):

    class handler:

        def get_datasources(self):
            """
            returns a dict with all datasources to which the user has permissions to
            """
            return [
                {'id': 1, 'name': 'weeeblackbox'},
                {'id': 2, 'name': 'iquest'},
                {'id': 3, 'name': 'mondrian'},
            ]

        def get_cubes(self, datasource_id):
            """
            returns a list of cube names for the given datasource_id
            """

            return [
                'cube %d.1' % datasource_id,
                'cube %d.2' % datasource_id,
                'cube %d.3' % datasource_id,
            ]

        def get_measures(self, datasource_id, cube_name):
            """
            returns a list of strings for the given datasource_id and cube_name
            """

            return [
                {'label': 'Quantity'},
                {'label': 'Turnover'},
            ]

        def get_dimensions(self, datasource_id, cube_name):
            return [
                {'label': 'Dimension 1'},
                {'label': 'Dimension 2', 'children': [
                    {'label': 'Dimension 2.1'},
                    {'label': 'Dimension 2.2'},
                    {'label': 'Dimension 2.3'},
                ]},
                {'label': 'Dimension 3'},
            ]

        def get_values(self, datasource_id, cube_name, mdx):
            return ['Value 1', 'Value 2']




    dispatcher = JsonRpcDispatcher()
    dispatcher.register_instance(handler())
    return dispatcher.handle_request(request)
