# Copyright (c) 2008 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.core.jsonrpc.dispatcher import JsonRpcDispatcher
from iqportal.iqube.core.controllers import DataSourceController
from django.conf import settings

def rpc(request):

    class handler:

        def create_datasource(self):
            """
            Creates a test datasource
            """
            test_ds_name = "test_iqportal_ds"
            test_ds_descr = "test_iqportal_ds descr"
            dsc = DataSourceController(request.Session(), account_id=request.session['user_id'])

            # first check if the ds is already created
            ds = dsc.get_datasource_by('name', test_ds_name)
            if len(ds) > 0:
                return ds[0].id

            # there isn't one created, so do it
            import re
            db = settings.DB_CONNSTR
            p_def = re.compile('(?P<protocol>\w+):\/\/(?P<user_name>[\w_\d]+):(?P<password>[\w_\d]+)@(?P<host>[\w\d\.]+):(?P<port>\d+)\/(?P<database_name>[\w\d_]+)')
            m = p_def.search(db)

            ds = dsc.save_or_update_datasource(id = None,
                     name = test_ds_name,
                     description = test_ds_descr,
                     mondrian_project = test_ds_name,
                     protocol =  m.group("protocol"),
                     user = m.group("user_name"),
                     password = m.group("password"),
                     host =  m.group("host"),
                     port =  m.group("port"),
                     database =  m.group("database_name"),
                    )
            return ds.id
    dispatcher = JsonRpcDispatcher()
    dispatcher.register_instance(handler())
    return dispatcher.handle_request(request)
