/**
 * Copyright (c) 2011 BaseSoft Solutions B.V.
 * See LICENSE for details.
 */

(function() {
	"use strict";

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "test_configurable_widget",

	setUp: function(){
		this.sandbox = YAHOO.util.Dom.get('sandbox');
		this.sandbox.innerHTML = '';
	},

	getConfig: function() {

		return {"category": "CLM",
		    "show_hide_empty": true,
		    "transposable": true,
		    "dimensions": [
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": true,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Attribute",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": true,
		            "children": [
		                {
		                    "unique_name": "[Attribute].[Attribute]",
		                    "has_children_available": false,
		                    "caption": "Attribute",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Attribute].[Attribute]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Answer",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": true,
		            "children": [
		                {
		                    "unique_name": "[Answer].[Answer]",
		                    "has_children_available": false,
		                    "caption": "Answer",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Answer].[Answer]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "KPI",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": true,
		            "children": [
		                {
		                    "unique_name": "[KPI].[KPI]",
		                    "has_children_available": false,
		                    "caption": "KPI",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[KPI].[KPI]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": true,
		            "available_as_slicer": false,
		            "caption": "Geolevel",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Geolevel].[Business Unit]",
		                    "has_children_available": true,
		                    "caption": "Business Unit",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Geolevel].[Business Unit]",
		                    "method": "get_level_members"
		                },
		                {
		                    "unique_name": "[Geolevel].[Region]",
		                    "has_children_available": true,
		                    "caption": "Region",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Geolevel].[Region]",
		                    "method": "get_level_members"
		                },
		                {
		                    "unique_name": "[Geolevel].[Sub Region]",
		                    "has_children_available": true,
		                    "caption": "Sub Region",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Geolevel].[Sub Region]",
		                    "method": "get_level_members"
		                },
		                {
		                    "unique_name": "[Geolevel].[Country]",
		                    "has_children_available": true,
		                    "caption": "Country",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Geolevel].[Country]",
		                    "method": "get_level_members"
		                },
		                {
		                    "unique_name": "[Geolevel].[Depot]",
		                    "has_children_available": true,
		                    "caption": "Depot",
		                    "has_all_member_available": false,
		                    "show_members": false,
		                    "method_argument": "[Geolevel].[Depot]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Location",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Location].[Location]",
		                    "has_children_available": true,
		                    "caption": "Location",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Location].[Location]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Respondent Type",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Respondent Type].[Respondent Type]",
		                    "has_children_available": true,
		                    "caption": "Respondent Type",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Respondent Type].[Respondent Type]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Revenue Band",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Revenue Band].[Revenue Band]",
		                    "has_children_available": true,
		                    "caption": "Revenue Band",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Revenue Band].[Revenue Band]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Service",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Service].[Service]",
		                    "has_children_available": true,
		                    "caption": "Service",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Service].[Service]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": true,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Wave",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Wave].[Main]",
		                    "has_children_available": false,
		                    "caption": "Main",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Wave].[Main]",
		                    "method": "get_level_members"
		                },
		                {
		                    "unique_name": "[Wave].[Code]",
		                    "has_children_available": false,
		                    "caption": "Code",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Wave].[Code]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "P1",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[P1].[P1]",
		                    "has_children_available": false,
		                    "caption": "P1",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[P1].[P1]",
		                    "method": "get_level_members"
		                }
		            ]
		        },
		        {
		            "available_on_rows": true,
		            "show_named_sets": false,
		            "has_select_as_group": false,
		            "available_as_split_by": false,
		            "required": false,
		            "available_as_slicer": true,
		            "caption": "Measures",
		            "fancy_select_module": "iq_fancyselect",
		            "available_on_columns": true,
		            "show_calculated_members": false,
		            "children": [
		                {
		                    "unique_name": "[Measures].[MeasuresLevel]",
		                    "has_children_available": false,
		                    "caption": "MeasuresLevel",
		                    "has_all_member_available": false,
		                    "show_members": true,
		                    "method_argument": "[Measures].[MeasuresLevel]",
		                    "method": "get_level_members"
		                }
		            ]
		        }
		    ],
		    "reporter": "iqportal.tnt.report.TntCLMDefaultConfigurableWidgetReporter",
		    "has_drill_through": true,
		    "datasource_id": 2,
		    "label": "Respondents Widget",
		    "show_excel_export": true,
		    "has_drill_position": true,
		    "cube": "TntCLMVirtualCube",
		    "has_graph": false,
		    "table_object_name": "tnt_graph_datatablecube",
		    "table_module": "tnt_graph_datatablecube",
		    "has_table": true,
		    "graph_config": {},
		    "has_drill_replace": true,
		    "open_settings_on_drag": false
		};

	},

	_testFilterPanel: function() {
		// Skipped for now, as it requires access to datasource.

		var validateCMCorben = function(e, objs) {
			this.resume(function() {

				var p = objs[0];
				var o1val = objs[1];
				var o2val = objs[2];

				var tb = p._tbody;
				YAHOO.util.Assert.areEqual(tb.childNodes.length, 3);

				YAHOO.util.Assert.areEqual(tb.childNodes[0].firstChild.innerHTML, o1val.member_unique_name);
				YAHOO.util.Assert.areEqual(tb.childNodes[1].firstChild.innerHTML, '+');
				YAHOO.util.Assert.areEqual(tb.childNodes[2].firstChild.innerHTML, o2val.member_unique_name);


			});
		};

		var makeSelectionsCorben = function(e, objs) {
			this.resume(function() {
				try {
					var cwfp = objs[0];
					var fs = objs[1];
					// Dom <select> object
					var defaultSelect = fs.getSelects()['default'];

					// select the 2nd and 3rd options
					var o1 = defaultSelect.options[1];
					o1.selected = true;
					var o2 = defaultSelect.options[2];
					o2.selected = true;

					// We now want to select a couple of attributes as group
					var p = BASESOFT.iqube.DimensionSelectAsGroup().call(fs);

					// "p" should be a SelectAsGroupPanel
					YAHOO.util.Assert.isTrue(p instanceof BASESOFT.iqube.SelectAsGroupPanel);

					// We now set a name for the group, which we can then assert.
					var f = p._form.getInput('name');
					f.set('value', 'MyGroupedSelect');
					p.setGrouped();

					var selected = fs.getSelects()['selected'];
					var s1 = selected.options[0];
					YAHOO.util.Assert.areEqual(s1.label, 'MyGroupedSelect');

					var o1val = YAHOO.lang.JSON.parse(o1.value);
					var o2val = YAHOO.lang.JSON.parse(o2.value);

					// We should also assert the title.
					var title = o1val.member_unique_name+'+'+o2val.member_unique_name;
					YAHOO.util.Assert.areEqual(s1.title, title);

					s1.selected = true;
					// Now we validate the actual content of the CM (#2748)
					p = BASESOFT.iqube.DimensionShowCMComposition().call(fs, 'click', cwfp);
					p.subscribe('bodyFilled', validateCMCorben, [p, o1val, o2val], this);
					this._garbage.push(p);
					this.wait();
				} catch (e) {
					console.error(e);
					throw e;
				}

			});
		};

		var showPanelCorben = function(result) {
			this.resume(function() {
				try {
					BASESOFT.env.account.id = result.id;

					var _this = this;
					var mockComposeItem = {
						get: function(x) {
							if (x == 'config' || x == 'appliedConfig') {
								return _this.getConfig();
							}
							else {
								console.warn('unknown x: ', x);
								return null;
							}
						}
					};

					var cwfp = new BASESOFT.iqube.ConfigurableWidgetConfigPanel(mockComposeItem);
					this._garbage.push(cwfp);

					// Open the first fieldset of the Dimension settings (attribute)
					var form = cwfp._form;
					var layout = form.get('layout');
					var dimensionSettings = layout.get('children')[2];
					var attribute = dimensionSettings.get('children')[0];
					var fsName = attribute.get('children')[0];
					var fs = form.getInput(fsName);
					fs.subscribe('onOptionsLoaded', makeSelectionsCorben, [cwfp, fs], this);

					attribute.set('is_expanded', true);

				} catch (e) {
					console.error(e);
					throw e;
				}
				this.wait();
			});
		};

		// Login
		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
		loginrpc.call('login', ['tnt_account_test', 'tnt_password'], showPanelCorben, null, this);

		this.wait();
	},

	testWizard: function () {

		var showWizardCorben = function(result) {
			this.resume(function() {
				BASESOFT.env.account.id = result.id;

				var cwwp = new BASESOFT.iqube.ConfigurableWidgetWizardPanel();
				this._garbage.push(cwwp);
			});
		};

		// Login
		var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
		loginrpc.call('login', ['sysadmin', 'RaKa4Rucru8r'], showWizardCorben, null, this);

		this.wait();

	},



	_makeMockItem: function() {

		var MockItem = function() {
			this.manager = {
				canvas: {
					on: function() {},
					hasMode: function() {}
				},
				subscribe: function() {}
			};

			this.kv = {
				appliedConfig : {
					"axes_0" : "",
					"axes_1" : "rows",
					"axes_2" : "",
					"axes_3" : "",
					"axes_4" : "",
					"axes_5" : "",
					"axes_6" : "rows",
					"axes_7" : "",
					"axes_8" : "",
					"axes_9" : "columns",
					"named_sets" : [],
					"show_graph" : false,
					"show_table_headers" : true,
					"dimensions" : {
						"STATUS" : "5",
						"Measures" : "9",
						"CRSO_NAME" : "1",
						"INVOICE_NR" : "0",
						"VAT_NO" : "3",
						"PERIOD" : "4",
						"EXPORT_DATE" : "8",
						"COMPANY_NAME" : "2",
						"UNLINK_DOCUMENT" : "7",
						"DOCUMENT" : "6"
					},
					"show_slicers" : true,
					"result_full_headers_6" : false,
					"result_full_headers_7" : false,
					"result_full_headers_4" : false,
					"result_full_headers_5" : false,
					"result_full_headers_2" : false,
					"result_full_headers_3" : false,
					"result_full_headers_0" : false,
					"result_full_headers_1" : false,
					"result_full_headers_8" : false,
					"hide_empty_fields" : true,
					"showValuesAsPercentage" : 0,
					"rowColorsFill" : false,
					"hideBorder" : false,
					"rowColors" : false,
					"initialRefresh" : true,
					"kwargs" : {
						"showSlicers" : true,
						"isDecapitated" : false
					},
					"quick_filters" : [],
					"showHierarchyNames" : false,
					"show_table" : true,
					"display_graph_above_table" : false,
					"dimension_2" : [],
					"dimension_3" : [],
					"dimension_0" : [],
					"dimension_1" : [
							"{\"dimension_unique_name\":\"[CRSO_NAME]\",\"member_unique_name\":\"[CRSO_NAME].[Asociatia Recolamp]\",\"depth\":\"1\",\"level_unique_name\":\"[CRSO_NAME].[CRSO_NAME]\",\"member_name\":\"Asociatia Recolamp\",\"hierarchy_unique_name\":\"[CRSO_NAME]\"}",
							"{\"dimension_unique_name\":\"[CRSO_NAME]\",\"member_unique_name\":\"[CRSO_NAME].[Consorzio Ecolamp]\",\"depth\":\"1\",\"level_unique_name\":\"[CRSO_NAME].[CRSO_NAME]\",\"member_name\":\"Consorzio Ecolamp\",\"hierarchy_unique_name\":\"[CRSO_NAME]\"}",
							"{\"dimension_unique_name\": \"[CRSO_NAME]\", \"member_unique_name\": \"[CRSO_NAME].[Elektroeko]\", \"depth\": \"1\", \"level_unique_name\": \"[CRSO_NAME].[CRSO_NAME]\", \"member_name\": \"Elektroeko\", \"hierarchy_unique_name\": \"[CRSO_NAME]\"}",
							"{\"dimension_unique_name\": \"[CRSO_NAME]\", \"member_unique_name\": \"[CRSO_NAME].[Lampen-Recycling und Service GmbH]\", \"depth\": \"1\", \"level_unique_name\": \"[CRSO_NAME].[CRSO_NAME]\", \"member_name\": \"Lampen-Recycling und Service GmbH\", \"hierarchy_unique_name\": \"[CRSO_NAME]\"}",
							"{\"dimension_unique_name\": \"[CRSO_NAME]\", \"member_unique_name\": \"[CRSO_NAME].[Lyskildebranchens WEEE Forening]\", \"depth\": \"1\", \"level_unique_name\": \"[CRSO_NAME].[CRSO_NAME]\", \"member_name\": \"Lyskildebranchens WEEE Forening\", \"hierarchy_unique_name\": \"[CRSO_NAME]\"}",
							"{\"dimension_unique_name\": \"[CRSO_NAME]\", \"member_unique_name\": \"[CRSO_NAME].[Recolight Limited]\", \"depth\": \"1\", \"level_unique_name\": \"[CRSO_NAME].[CRSO_NAME]\", \"member_name\": \"Recolight Limited\", \"hierarchy_unique_name\": \"[CRSO_NAME]\"}",
							"{\"dimension_unique_name\": \"[CRSO_NAME]\", \"member_unique_name\": \"[CRSO_NAME].[ZEOS d.o.o.]\", \"depth\": \"1\", \"level_unique_name\": \"[CRSO_NAME].[CRSO_NAME]\", \"member_name\": \"ZEOS d.o.o.\", \"hierarchy_unique_name\": \"[CRSO_NAME]\"}"
							],
					"dimension_6" : [
							"{\"dimension_unique_name\": \"[DOCUMENT]\", \"member_unique_name\": \"[DOCUMENT].[True]\", \"depth\": \"1\", \"level_unique_name\": \"[DOCUMENT].[DOCUMENT]\", \"member_name\": \"True\", \"hierarchy_unique_name\": \"[DOCUMENT]\"}",
							"{\"dimension_unique_name\": \"[DOCUMENT]\", \"member_unique_name\": \"[DOCUMENT].[False]\", \"depth\": \"1\", \"level_unique_name\": \"[DOCUMENT].[DOCUMENT]\", \"member_name\": \"False\", \"hierarchy_unique_name\": \"[DOCUMENT]\"}"
							],
					"dimension_7" : [],
					"dimension_4" : [],
					"dimension_5" : [],
					"dimension_8" : [],
					"dimension_9" : [ "{\"dimension_unique_name\": \"[Measures]\", \"member_unique_name\": \"[Measures].[QUANTITY]\", \"depth\": \"0\", \"level_unique_name\": \"[Measures].[MeasuresLevel]\", \"member_name\": \"QUANTITY\", \"hierarchy_unique_name\": \"[Measures]\"}" ],

					"row_order" : [ "CRSO_NAME", "DOCUMENT"],
					"column_order" : [ "Measures" ]

					// notice: deliberately not specificying axis slicer order to test live scneario (tested in testMemberOrHierarchyDrag5)
					//"slicer_order" : []
				}
			};

		};
		MockItem.prototype = {

			set: function(k, v) {
				//console.warn('set', arguments);
				this.kv[k] = v;
			},
			get: function(k) {
				//console.warn('get', arguments);
				return this.kv[k];
			},
			on: function() {},
			createEvent: function() {},
			subscribe: function() {},

			get_member_4test: function(dimension_index, member_index) {
				var ac = mockItem.get('appliedConfig');
				var m = ac['dimension_'+dimension_index][member_index];
				YAHOO.util.Assert.isTrue(typeof m != 'undefined', 'invalid member');
				return YAHOO.lang.JSON.parse(m);

			},

			hasMode: function() {
				return true;
			}
		};


		var mockItem = new MockItem();
		return mockItem;
	},

	/**
	 * CASE 1: re-order on same axis
	 * drag 'Asociatia Recolamp' under 'Consorzio Ecolamp' on rows
	 */
	testMemberOrHierarchyDrag1: function() {

		console.info('TEST: testMemberOrHierarchyDrag1');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[CRSO_NAME]",
					member_unique_name : "[CRSO_NAME].[Asociatia Recolamp]"
				}
			},
			target_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[CRSO_NAME]",
					member_unique_name : "[CRSO_NAME].[Consorzio Ecolamp]"
				}
			}
		});

		YAHOO.util.Assert.areEqual(item.get_member_4test(1, 0)['member_unique_name'], '[CRSO_NAME].[Consorzio Ecolamp]', 'case 1');
		YAHOO.util.Assert.areEqual(item.get_member_4test(1, 1)['member_unique_name'], '[CRSO_NAME].[Asociatia Recolamp]', 'case 1');

		YAHOO.util.Assert.areEqual(item.get('appliedConfig').axes_1, 'rows', 'case 1 axes');

		var row_order = item.get('appliedConfig').row_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['CRSO_NAME', 'DOCUMENT']), 'case 1 row_order: '+row_order);

	},

	/**
	 * CASE 2: re-order member on same axis under different dimension
	 * drag 'Asociatia Recolamp' under 'True' on rows
	 */
	testMemberOrHierarchyDrag2: function() {

		console.info('TEST: testMemberOrHierarchyDrag2');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[CRSO_NAME]",
					member_unique_name : "[CRSO_NAME].[Asociatia Recolamp]"
				}
			},
			target_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[DOCUMENT]",
					member_unique_name : "[DOCUMENT].[True]"
				}
			}
		});

		YAHOO.util.Assert.areEqual(item.get('appliedConfig').axes_1, 'rows', 'case 1 axes');

		var row_order = item.get('appliedConfig').row_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['DOCUMENT', 'CRSO_NAME']), 'case 2 row_order: '+row_order);


	},


	/**
	 * CASE 3: drag member to _same_ axis but not on a member
	 * drag 'Asociatia Recolamp' to rows
	 */
	testMemberOrHierarchyDrag3: function() {

		console.info('TEST: testMemberOrHierarchyDrag3');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[CRSO_NAME]",
					member_unique_name : "[CRSO_NAME].[Asociatia Recolamp]"
				}
			},
			target_info: {
				axis: 'rows',
				member : null
			}
		});

		var row_order = item.get('appliedConfig').row_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['DOCUMENT', 'CRSO_NAME']), 'case 3 row_order: '+row_order);

	},


	/**
	 * CASE 4: drag member to _other_ axis but not on a member
	 * drag 'Asociatia Recolamp' to columns
	 */
	testMemberOrHierarchyDrag4: function() {

		console.info('TEST: testMemberOrHierarchyDrag4');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[CRSO_NAME]",
					member_unique_name : "[CRSO_NAME].[Asociatia Recolamp]"
				}
			},
			target_info: {
				axis: 'columns',
				member : null
			}
		});

		var row_order = item.get('appliedConfig').row_order;
		var column_order = item.get('appliedConfig').column_order;

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['DOCUMENT']), 'case 4 row_order: '+row_order);
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(column_order, ['Measures', 'CRSO_NAME']), 'case 4 column_order: '+column_order);


	},

	/**
	 * CASE 5: drag new member to slicers
	 * drag 'exportdate.2014' to slicers
	 */
	testMemberOrHierarchyDrag5: function() {

		console.info('TEST: testMemberOrHierarchyDrag5');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: null,
				member : {
					dimension_unique_name : "[EXPORT_DATE]",
					member_unique_name : "[EXPORT_DATE.Time Weekly].[2014]"
				}
			},
			target_info: {
				axis: 'slicers',
				hierarchy: null
			}
		});

		var row_order = item.get('appliedConfig').row_order;
		var column_order = item.get('appliedConfig').column_order;
		var slicer_order = item.get('appliedConfig').slicer_order;

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(slicer_order, ['EXPORT_DATE']), 'case 5 slicer_order: '+slicer_order);
		YAHOO.util.Assert.areEqual(item.get('appliedConfig').axes_8, 'slicers', 'case 5 axes');
		YAHOO.util.Assert.areEqual(item.get_member_4test(8, 0)['member_unique_name'], '[EXPORT_DATE.Time Weekly].[2014]', 'case 5');


	},

	/**
	 * CASE 6: drag new member between two existing members
	 * drag 'exportdate.2014' to rows after any crso
	 */
	testMemberOrHierarchyDrag6: function() {

		console.info('TEST: testMemberOrHierarchyDrag6');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: null,
				member : {
					dimension_unique_name : "[EXPORT_DATE]",
					member_unique_name : "[EXPORT_DATE.Time Weekly].[2014]"
				}
			},
			target_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[CRSO_NAME]",
					member_unique_name : "[CRSO_NAME].[Asociatia Recolamp]"
				}
			}
		});

		var row_order = item.get('appliedConfig').row_order;
		var column_order = item.get('appliedConfig').column_order;
		var slicer_order = item.get('appliedConfig').slicer_order;

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['CRSO_NAME', 'EXPORT_DATE', 'DOCUMENT']), 'case 6 row_order: '+row_order);
		YAHOO.util.Assert.areEqual(item.get_member_4test(8, 0)['member_unique_name'], '[EXPORT_DATE.Time Weekly].[2014]', 'case 5');


	},

	/**
	 * CASE 7: hierarchy drag to pivot table on same axis
	 * drag 'CRSO' to after DOCUMENT
	 */
	testMemberOrHierarchyDrag7: function() {

		console.info('TEST: testMemberOrHierarchyDrag7');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				hierarchy: 'CRSO_NAME'
			},
			target_info: {
				axis: 'rows',
				member : {
					dimension_unique_name : "[DOCUMENT]",
					member_unique_name : "[DOCUMENT].[True]"
				}
			}
		});

		var row_order = item.get('appliedConfig').row_order;

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['DOCUMENT', 'CRSO_NAME']), 'case 7 row_order: '+row_order);

	},

	/**
	 * CASE 8: hierarchy drag to pivot table on other axis
	 * drag 'CRSO' to slicers (empty)
	 */
	testMemberOrHierarchyDrag8: function() {

		console.info('TEST: testMemberOrHierarchyDrag8');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				hierarchy: 'CRSO_NAME'
			},
			target_info: {
				axis: 'slicers',
				member: null
			}
		});

		var row_order = item.get('appliedConfig').row_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['DOCUMENT']), 'case 8 row_order: '+row_order);

		var slicer_order = item.get('appliedConfig').slicer_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(slicer_order, ['CRSO_NAME']), 'case 8 slicer_order: '+slicer_order);

	},

	/**
	 * CASE 9: hierarchy drag to different axis on top of member
	 */
	testMemberOrHierarchyDrag9: function() {

		console.info('TEST: testMemberOrHierarchyDrag9');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);

		// first drag a new member to columns
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: null,
				member : {
					dimension_unique_name : "[EXPORT_DATE]",
					member_unique_name : "[EXPORT_DATE.Time Weekly].[2014]"
				}
			},
			target_info: {
				axis: 'columns',
				member : null
			}
		});

		// now drag crso on top of the hierarchy of the just added member
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				hierarchy: 'CRSO_NAME'
			},
			target_info: {
				axis: 'columns',

				// notice that this 'member' comes from the cubetable, it has other keys
				member: {
					uname: '[EXPORT_DATE.Time Weekly].[2014]',
					hierarchy: 'EXPORT_DATE.Time Weekly'

				}

			}
		});

		var column_order = item.get('appliedConfig').column_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(column_order, ['Measures', 'EXPORT_DATE', 'CRSO_NAME']), 'case 8 column_order: '+column_order);
	},

	/**
	 * CASE 10: hierarchy drag to same axis
	 */
	testMemberOrHierarchyDrag10: function() {

		console.info('TEST: testMemberOrHierarchyDrag10');

		var item = this._makeMockItem();
		var hook = new BASESOFT.iqube.ConfigurableComposeItemHook(item);

		// first drag a new member to rows
		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: null,
				member : {
					dimension_unique_name : "[EXPORT_DATE]",
					member_unique_name : "[EXPORT_DATE.Time Weekly].[2014]"
				}
			},
			target_info: {
				axis: 'rows',
				member : null
			}
		});

		hook._memberOrHierarchyDrag({
			remove: false,
			src_info: {
				axis: 'rows',
				hierarchy: 'EXPORT_DATE.Time Weekly'
			},
			target_info: {
				axis: 'rows',

				// notice that this 'member' comes from the cubetable, it has other keys
				member: {
					uname: '[CRSO_NAME].[Elektroeko]',
					hierarchy: 'CRSO_NAME'

				}

			}
		});

		var row_order = item.get('appliedConfig').row_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['CRSO_NAME', 'EXPORT_DATE', 'DOCUMENT']), 'case 8 row_order: '+row_order);
	},

	// TODO: test 'remove' drag


	/**
	 * apply links test keeses start here
	 */

	testApplyLinks1: function() {

		var item1 = this._makeMockItem();
		var item2 = this._makeMockItem();

		var hook1 = new BASESOFT.iqube.ConfigurableComposeItemHook(item1);

		item1.manager.canvas.itemDBDomMap = {
			'item_1': item1,
			'item_2': item2
		};

		// make a link to item_2 (id=2) to columns (1)
		item1.set('linkedItems', {
			2: 1
		});

		// click on a CRSO on item1
		// because the CRSO is already on columns, we expect it to stay on columns on item2
		hook1._applyLinks([{
			hierarchy_unique_name: '[CRSO_NAME]',
			member_unique_name: '[CRSO_NAME].[Asociatia Recolamp]'
		}], true);

		var row_order = item2.get('appliedConfig').row_order;
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(row_order, ['CRSO_NAME', 'DOCUMENT']), 'testApplyLinks1: '+row_order);
		YAHOO.util.Assert.areEqual(item2.get_member_4test(1, 0)['member_unique_name'], '[CRSO_NAME].[Asociatia Recolamp]', 'case 5');
		YAHOO.util.Assert.areEqual(item2.get('appliedConfig')['dimension_1'].length, 7);

		// click on a Company and expect that one will go to columns
		hook1._applyLinks([{
			hierarchy_unique_name: '[COMPANY_NAME]',
			member_unique_name: '[COMPANY_NAME].[Company1]'
		}], true);

		var column_order = item2.get('appliedConfig').column_order;
		YAHOO.util.Assert.areEqual(item2.get('appliedConfig').axes_2, 'columns', 'testApplyLinks1 company axes');
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(column_order, ['Measures', 'COMPANY_NAME']), 'testApplyLinks1 company column_order: '+column_order);





	}

}));

})();
