/**
 * Copyright (c) 2014 BaseSoft B.V.
 * See LICENSE for details.
 *
 * @module test_cube_table
 */

(function() {"use strict";

	BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

		name: "test_mdx",

		setUp: function(){
			this.sandbox = YAHOO.util.Dom.get('sandbox');
			this.sandbox.innerHTML = '';
		},

		testSH : function () {

			var mdx = "\nWITH SET [Preview] AS TopCount({[Product].[Drink],[Product].[Food],[Product].[Non-Consumable]},5,[Measures].[Unit Sales])\nSELECT {[Measures].[Customer Count]} ON COLUMNS\n , {[Preview]} ON ROWS\nFROM [Sales]";
			this.sandbox.innerHTML = BASESOFT.iqube.util.MdxSyntaxHighlight(mdx);

		},

		testComplexSyntaxHighlight: function () {

			var mdx = "WITH SET [repeater1] AS '{[Survey].[1].[3],[Survey].[1].[2],[Survey].[1].[1]}'\n" +
				"SET [repeater0] AS '{[Survey].[1].[3],[Survey].[1].[2],[Survey].[1].[1]}'\n" +
				"MEMBER [Measures].[repeater2] AS '[repeater0].Item(([repeater1].CurrentOrdinal-1))'\n" +
				"MEMBER [Measures].[Preview] AS (([repeater0].Item([repeater1].CurrentOrdinal)-[Measures].[repeater2])/[Measures].[repeater2])\n" +
				"SELECT {[Measures].[Preview]} ON COLUMNS\n" +
				"FROM [Response]";
			this.sandbox.innerHTML = BASESOFT.iqube.util.MdxSyntaxHighlight(mdx);
		},

		testFormatString: function () {

			var fmt_string = "IIF({value}>25000, '|$#,##0.00|font-weight: bold\\; font-style: italic; color: rgb\\(86\\,174\\,36\\)', '$#,##0.00')";

			var values = BASESOFT.iqube.parseFormatString(fmt_string);
			YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(values, {
				compare_value: "25000",
				left_text_color: "#56AE24",
				left_text_style: "font-weight: bold\\; font-style: italic",
				number_of_decimals: 2,
				operator: ">",
				pre_character: "$"
			}));

		}

	}));

})();
