/**
 * Copyright (c) 2010 BaseSoft B.V.
 * See LICENSE for details.
 */
BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "Member Tree Test",

	setUp : function () {
		var sandbox = YAHOO.util.Dom.get('sandbox');
		this.container = document.createElement('div');
		sandbox.appendChild(this.container);

		this._rpc = new BASESOFT.util.JsonBroker( "/iqportal.iqube.test/luciddb/rpc/", {timeout: 120000, executeIfLoggedOut : true});
		this._garbage.push(this._rpc);

	},

	test_member_tree: function () {


		this._rpc.call("create_blackbox_project", [], function(result) {
			this.resume(function() {
				try {
					
					BASESOFT.env.account.id = result.account_id;

					var tree = new BASESOFT.iqube.MemberTree({
						datasource: result.datasource_id,
						cube: result.cube
					});
					tree.render();
					tree.appendTo(this.container);

					this._garbage.push(tree);

					this._openRoot(tree);

				} catch (e) {
					throw e;
				}

			});
		}, null, this);
		this.wait(120000);


	},

	_openRoot: function(tree) {

		var corben = function() {
			try {
				this.resume(function() {
					tree.getTree().unsubscribe(corben);
					this._openCrso(tree);
				});
			} catch (e) {
				console.error(e);
			}
		};

		// open root children
		tree.getTree().subscribe('expandComplete', corben, null, this);
		tree.getTree().getRoot().children[0].expand();
		this.wait();
	},

	_openCrso: function(tree) {

		var corben = function() {
			try {
				this.resume(function() {
					tree.getTree().unsubscribe(corben);
					this._openCrsoCompany(tree);
				});
			} catch (e) {
				console.error(e);
			}
		};

		// click on 'crso'
		tree.getTree().subscribe('expandComplete', corben, null, this);
		tree.getTree().getRoot().children[0].children[0].expand();
		this.wait();
	},

	_openCrsoCompany: function(tree) {

		var corben = function() {
			try {
				this.resume(function() {
					tree.getTree().unsubscribe(corben);

					// test done

				});
			} catch (e) {
				console.error(e);
			}
		};

		// click on 'company_name'
		tree.getTree().subscribe('expandComplete', corben, null, this);
		tree.getTree().getRoot().children[0].children[0].children[2].expand();
		this.wait();

	}

}));
