/**
 * # Copyright (c) 2008 BaseSoft B.V.
 * # See LICENSE for details.
 */

(function() {
	"use strict";


BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "test_pivottable",

	setUp: function() {
		this.sandbox = YAHOO.util.Dom.get('sandbox');
		this.sandbox.innerHTML = '';
	},

	testPivotTableDrag: function() {
		try {

			// {"rows":[{"dimension_unique_name":"[NAME]","member_ordinal":"0","children_cardinality":"3","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[NAME].[All NAMEs].Children","catalog_name":"ds_3","member_type":"2","level_number":"0","member_caption":"All NAMEs","cube_name":"cube_bt1","member_name":"All NAMEs","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[(All)]","depth":"0"},{"dimension_unique_name":"[NAME]","member_ordinal":"2","children_cardinality":"0","schema_name":"bt1","parent_count":"1","parent_unique_name":"[NAME].[All NAMEs]","parent_level":"0","member_unique_name":"[NAME].[Joop]","catalog_name":"ds_3","member_type":"1","level_number":"1","member_caption":"Joop","cube_name":"cube_bt1","member_name":"Joop","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[NAME]","depth":"1"}],"datasource_id":"3","showHierarchyNames":true,"show_slicers":true,"show_table":true,"display_graph_above_table":false,"nonempty":false,"rowColorsFill":false,"hideBorder":false,"rowColors":false,"cube":"cube_bt1","slicers":[],"dragDrop":true,"hide_empty_fields":false,"show_graph":true,"show_table_headers":true,"columns":[{"dimension_unique_name":"[Measures]","member_ordinal":"1","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[GROUP]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"GROUP","cube_name":"cube_bt1","member_name":"GROUP","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[Measures]","member_ordinal":"0","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[TIME__TIME]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"TIME__TIME","cube_name":"cube_bt1","member_name":"TIME__TIME","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"}]}

			// {"rows":[],"datasource_id":"3","showHierarchyNames":true,"show_slicers":false,"show_table":true,"display_graph_above_table":false,"nonempty":false,"rowColorsFill":false,"hideBorder":false,"rowColors":false,"cube":"cube_bt1","slicers":[],"dragDrop":true,"hide_empty_fields":false,"show_graph":true,"show_table_headers":true,"columns":[{"dimension_unique_name":"[Measures]","member_ordinal":"1","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[GROUP]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"GROUP","cube_name":"cube_bt1","member_name":"GROUP","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[Measures]","member_ordinal":"0","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[TIME__TIME]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"TIME__TIME","cube_name":"cube_bt1","member_name":"TIME__TIME","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[NAME]","member_ordinal":"0","children_cardinality":"3","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[NAME].[All NAMEs].Children","catalog_name":"ds_3","member_type":"2","level_number":"0","member_caption":"All NAMEs","cube_name":"cube_bt1","member_name":"All NAMEs","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[(All)]","depth":"0"}]}

			var p = new BASESOFT.iqube.PivotTable();
			p.setAppliedConfig({"axes_0":"rows","axes_1":"columns","axes_2":"","axes_3":"","axes_4":"rows","axes_5":"columns","axes_6":"","axes_7":"","axes_8":"slicers","dimension_5":["{\"dimension_unique_name\": \"[Submitted Time]\", \"member_unique_name\": \"[Submitted Time.Quarter].[2014].[1]\", \"depth\": \"2\", \"level_unique_name\": \"[Submitted Time.Quarter].[Quarter]\", \"member_name\": \"1\", \"hierarchy_unique_name\": \"[Submitted Time.Quarter]\"}","{\"dimension_unique_name\": \"[Submitted Time]\", \"member_unique_name\": \"[Submitted Time.Quarter].[2014].[2]\", \"depth\": \"2\", \"level_unique_name\": \"[Submitted Time.Quarter].[Quarter]\", \"member_name\": \"2\", \"hierarchy_unique_name\": \"[Submitted Time.Quarter]\"}","{\"dimension_unique_name\": \"[Submitted Time]\", \"member_unique_name\": \"[Submitted Time.Quarter].[2014].[3]\", \"depth\": \"2\", \"level_unique_name\": \"[Submitted Time.Quarter].[Quarter]\", \"member_name\": \"3\", \"hierarchy_unique_name\": \"[Submitted Time.Quarter]\"}","{\"dimension_unique_name\": \"[Submitted Time]\", \"member_unique_name\": \"[Submitted Time.Quarter].[2014].[4]\", \"depth\": \"2\", \"level_unique_name\": \"[Submitted Time.Quarter].[Quarter]\", \"member_name\": \"4\", \"hierarchy_unique_name\": \"[Submitted Time.Quarter]\"}"],"show_graph":false,"initialRefresh":true,"dimensions":{"Merchant":"0","Client":"1","GL Account":"2","Invoice Type":"3","Order Type":"4","Submitted Time":"5","Payment Time":"6","Payment Method":"7","Measures":"8"},"dimension_3":[],"column_order":["Submitted Time","Client"],"showValuesAsPercentage":0,"kwargs":{"showSlicers":true,"isDecapitated":false},"rowColorsFill":false,"hideBorder":false,"rowColors":false,"row_order":["Merchant","Order Type"],"show_table_headers":true,"quick_filters":[],"show_table":true,"display_graph_above_table":false,"dimension_2":[],"show_slicers":true,"dimension_0":["{\"dimension_unique_name\": \"[Merchant]\", \"member_unique_name\": \"[Merchant].[22]\", \"depth\": \"1\", \"level_unique_name\": \"[Merchant].[Merchant]\", \"member_name\": \"22\", \"hierarchy_unique_name\": \"[Merchant]\"}"],"dimension_1":["{\"dimension_unique_name\": \"[Client]\", \"member_unique_name\": \"[Client].[79]\", \"depth\": \"1\", \"level_unique_name\": \"[Client].[Client]\", \"member_name\": \"79\", \"hierarchy_unique_name\": \"[Client]\"}"],"dimension_6":[],"dimension_7":[],"dimension_4":["{\"hierarchy_unique_name\": \"[Order Type]\", \"dimension_unique_name\": \"[Order Type]\", \"level_unique_name\": \"[Order Type].[Order Type]\", \"member_unique_name\": \"[Order Type].[Order Type].Members\", \"member_name\": \"[Order Type].[Order Type]\"}"],"hide_empty_fields":false,"dimension_8":["{\"dimension_unique_name\": \"[Measures]\", \"member_unique_name\": \"[Measures].[Amount]\", \"depth\": \"0\", \"level_unique_name\": \"[Measures].[MeasuresLevel]\", \"member_name\": \"Amount\", \"hierarchy_unique_name\": \"[Measures]\"}"]});

			this._garbage.push(p);

			this.sandbox.appendChild(p.get('element'));

		} catch (e) {
			console.error(e);
			throw e;
		}
	},

	testPivotTableLink: function() {
		try {

			// {"rows":[{"dimension_unique_name":"[NAME]","member_ordinal":"0","children_cardinality":"3","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[NAME].[All NAMEs].Children","catalog_name":"ds_3","member_type":"2","level_number":"0","member_caption":"All NAMEs","cube_name":"cube_bt1","member_name":"All NAMEs","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[(All)]","depth":"0"},{"dimension_unique_name":"[NAME]","member_ordinal":"2","children_cardinality":"0","schema_name":"bt1","parent_count":"1","parent_unique_name":"[NAME].[All NAMEs]","parent_level":"0","member_unique_name":"[NAME].[Joop]","catalog_name":"ds_3","member_type":"1","level_number":"1","member_caption":"Joop","cube_name":"cube_bt1","member_name":"Joop","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[NAME]","depth":"1"}],"datasource_id":"3","showHierarchyNames":true,"show_slicers":true,"show_table":true,"display_graph_above_table":false,"nonempty":false,"rowColorsFill":false,"hideBorder":false,"rowColors":false,"cube":"cube_bt1","slicers":[],"dragDrop":true,"hide_empty_fields":false,"show_graph":true,"show_table_headers":true,"columns":[{"dimension_unique_name":"[Measures]","member_ordinal":"1","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[GROUP]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"GROUP","cube_name":"cube_bt1","member_name":"GROUP","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[Measures]","member_ordinal":"0","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[TIME__TIME]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"TIME__TIME","cube_name":"cube_bt1","member_name":"TIME__TIME","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"}]}

			// {"rows":[],"datasource_id":"3","showHierarchyNames":true,"show_slicers":false,"show_table":true,"display_graph_above_table":false,"nonempty":false,"rowColorsFill":false,"hideBorder":false,"rowColors":false,"cube":"cube_bt1","slicers":[],"dragDrop":true,"hide_empty_fields":false,"show_graph":true,"show_table_headers":true,"columns":[{"dimension_unique_name":"[Measures]","member_ordinal":"1","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[GROUP]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"GROUP","cube_name":"cube_bt1","member_name":"GROUP","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[Measures]","member_ordinal":"0","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[TIME__TIME]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"TIME__TIME","cube_name":"cube_bt1","member_name":"TIME__TIME","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[NAME]","member_ordinal":"0","children_cardinality":"3","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[NAME].[All NAMEs].Children","catalog_name":"ds_3","member_type":"2","level_number":"0","member_caption":"All NAMEs","cube_name":"cube_bt1","member_name":"All NAMEs","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[(All)]","depth":"0"}]}

			var mockItem = {
				set: function(k, v) {
				},
				get: function(k) {
				}
			};

			var p = new BASESOFT.iqube.PivotTable({mode: BASESOFT.iqube.PivotTable.prototype.MODE_LINK, container: this.sandbox, item: mockItem});

			p.setAppliedConfig({"rows":[{"dimension_unique_name":"[NAME]","member_ordinal":"0","children_cardinality":"3","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[NAME].[All NAMEs].Children","catalog_name":"ds_3","member_type":"2","level_number":"0","member_caption":"All NAMEs","cube_name":"cube_bt1","member_name":"All NAMEs","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[(All)]","depth":"0"},{"dimension_unique_name":"[NAME]","member_ordinal":"2","children_cardinality":"0","schema_name":"bt1","parent_count":"1","parent_unique_name":"[NAME].[All NAMEs]","parent_level":"0","member_unique_name":"[NAME].[Joop]","catalog_name":"ds_3","member_type":"1","level_number":"1","member_caption":"Joop","cube_name":"cube_bt1","member_name":"Joop","hierarchy_unique_name":"[NAME]","level_unique_name":"[NAME].[NAME]","depth":"1"}],"datasource_id":"3","showHierarchyNames":true,"show_slicers":true,"show_table":true,"display_graph_above_table":false,"nonempty":false,"rowColorsFill":false,"hideBorder":false,"rowColors":false,"cube":"cube_bt1","slicers":[],"dragDrop":true,"hide_empty_fields":false,"show_graph":true,"show_table_headers":true,"columns":[{"dimension_unique_name":"[Measures]","member_ordinal":"1","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[GROUP]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"GROUP","cube_name":"cube_bt1","member_name":"GROUP","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"},{"dimension_unique_name":"[Measures]","member_ordinal":"0","children_cardinality":"0","schema_name":"bt1","parent_count":"0","parent_level":"0","member_unique_name":"[Measures].[TIME__TIME]","catalog_name":"ds_3","member_type":"3","level_number":"0","member_caption":"TIME__TIME","cube_name":"cube_bt1","member_name":"TIME__TIME","hierarchy_unique_name":"[Measures]","level_unique_name":"[Measures].[MeasuresLevel]","depth":"0"}]});


			this.sandbox.appendChild(p.get('element'));

		} catch (e) {
			console.error(e);
			throw e;
		}
	},

	testPivotTableSelectAsGroup: function() {
		var mockItem = {
			set: function(k, v) {
			},
			get: function(k) {
			}
		};
		var p = new BASESOFT.iqube.PivotTable({mode: BASESOFT.iqube.PivotTable.prototype.MODE_LINK, container: this.sandbox, item: mockItem});
		p.setAppliedConfig({
			"axes_0": "",
			"axes_1": "",
			"axes_2": "slicers",
			"axes_3": "",
			"axes_4": "",
			"axes_5": "columns",
			"kwargs": {"showSlicers": true, "isDecapitated": false},
			"slicer_order": ["NAME"],
			"dimension_5": ["{\"dimension_unique_name\": \"[Measures]\", \"member_unique_name\": \"[Measures].[COUNT]\", \"depth\": \"0\", \"level_unique_name\": \"[Measures].[MeasuresLevel]\", \"member_name\": \"COUNT\", \"hierarchy_unique_name\": \"[Measures]\"}"],
			"named_sets": [],
			"show_graph": true,
			"show_table_headers": true,
			"dimensions": {
				"GROUP": "4",
				"NAME": "2",
				"COUNTRY": "0",
				"Measures": "5",
				"DATE": "3",
				"COUNTRY_LATLONG": "1"
			},
			"show_slicers": true,
			"result_full_headers_4": false,
			"result_full_headers_2": false,
			"result_full_headers_3": false,
			"result_full_headers_0": false,
			"showValuesAsPercentage": 0,
			"result_full_headers_1": false,
			"rowColorsFill": false,
			"hideBorder": false,
			"rowColors": false,
			"row_order": [],
			"initialRefresh": true,
			"quick_filters": [],
			"showHierarchyNames": false,
			"show_table": true,
			"display_graph_above_table": false,
			"dimension_2": ["\"MEMBER [NAME].[group] AS 'AGGREGATE({[NAME].[Henk],[NAME].[Joop],[NAME].[Piet]})'\""],
			"dimension_3": [],
			"dimension_0": [],
			"dimension_1": [],
			"dimension_4": [],
			"hide_empty_fields": true,
			"column_order": ["Measures"]
		});
		this.sandbox.appendChild(p.get('element'));

	}


}));

YAHOO.register("test_pivottable", null, {
	version: "1.0.0",
	build: "1"
});

})();
