'''
Created on Oct 23, 2014

@author: marten
'''
from basesoft.web.core.util.db import Session
from basesoft.web.test.unit.iqportal_unittest import IQPortalTestCase
from iqportal.iqube.core.models import DataSource
from iqportal.iqube.core import MDX_METHODS, get_properties_map
from basesoft.web.core.exceptions import PublicSecurityException

from django.conf import settings

class IQubeTestRPCHandler:
    def __init__(self, request, **kwargs):
        self.sa_session = request.Session()

    def get_raw_result(self, datasource, _type, method):
        ds = self.sa_session.query(DataSource).filter(DataSource.name==datasource).first()
        mdx = None

        if _type == 'method':
            if not MDX_METHODS.has_key(method):
                raise PublicSecurityException('Incorrect MDX method supplied')

            mdx = MDX_METHODS[method].example_mdx

        else: # Dealing with properties
            _bitbucket, category = _type.split('_')
            properties = get_properties_map()
            _property = properties[category][method]
            mdx = _property.example_mdx

        if mdx is None:
            raise PublicSecurityException('No example MDX available')

        client = ds.connect()
        return client.execute_mdx(mdx).get_dict()


    def get_foodmart_datasource(self):

        tc = IQPortalTestCase()
        tc.session = Session()
        account = tc._create_active_account()

        datasource = self.sa_session.query(DataSource).filter(DataSource.name == '%s.FoodMart' % settings.SETTINGS_MODULE).first()

        return {
            'account_id': account.id,
            'datasource_id': datasource.id,
        }



handlers = (IQubeTestRPCHandler, )
