# -*- coding: utf-8 -*-

import os


from django.conf import settings
from twisted.trial.unittest import SkipTest

import iqportal.iqube.test

from basesoft.web.test.selenium.selenium_testcase import SeleniumTestCase, XPath

class TestCase(SeleniumTestCase):
    """
    trial iqportal.iqube.test.selenium.test_optiq.TestCase
    """

    def setUp(self):
        super(TestCase, self).setUp()
        self.connect_db()

    def test_excel_import(self):

        ds_name = self._uniquestring('ds')

        # create an account with survey privileges
        account = self._create_active_account()
        self._attach_permissions_to_group(account.groups[0].group,
            'view_dashboard', 'save_dashboard',
            'datasource_manager',
            'create_datasource', 'update_datasource', 'view_datasource', 'delete_datasource',
            'datasource_view_cube', 'datasource_create_cube',
            'file_based_datasource_access', 'view_file', 'create_file',
            'create_calculated_member', 'view_calculated_member', 'update_calculated_member', 'delete_calculated_member',
            'create_datasource_widget', 'view_datasource_widget', 'update_datasource_widget', 'delete_datasource_widget',
            'item_result'

        )

        # login as that account
        self.login(account.name, 'test_password')
        self.wait_for_loading()

        self.click_iconbar(title='Data source manager')

        self.click_menu(panel_name='datasource-manager', text='New File Datasource')
        self.wait_for_loading()

        self.fill_form(panel_name='optiq-wizard-panel', values={
            'datasource_name': ds_name,
            'file_input': ('upload', os.path.join(iqportal.iqube.test.__path__[0], 'csv', '2012_rand.csv'))
        })
        self.wait_for_loading()

        # goto column page
        self.click_button(panel_name='optiq-wizard-panel', text=u'Next »')
        self.wait_for_loading()
        self.assert_no_growl_errors()

        # goto cube designer
        self.click_button(panel_name='optiq-wizard-panel', text=u'Next »')
        self.wait_for_loading(stable_time=4)
        self.assert_no_growl_errors()

        # finish
        self.click_button(panel_name='optiq-wizard-panel', text=u'Finish')
        self.wait_for_loading(stable_time=4)
        self.assert_no_growl_errors()

        self.filter_cq(panel_name='datasource-manager', filters=[('Name', 'Equal', ds_name)])

        self.assert_cq(panel_name='datasource-manager', row_index=0, data={
            'name': ds_name,
        })
