'''
Created on Sep 3, 2014

@author: rado
'''

from django.conf import settings
from iqportal.iqube.xmla.client import XMLAClient
from basesoft.web.test.unit import iqportal_unittest

class TestCase(iqportal_unittest.IQPortalTestCase):


    def setUp(self):
        self.connect_db()

    def test_get_time_dimension(self):

        host, port = settings.MONDRIAN_XMLA_SERVER
        mdx_client = XMLAClient(host, port, settings.MONDRIAN_XMLA_PATH, '%s.FoodMart' % settings.SETTINGS_MODULE)
        dimension = mdx_client.get_dimensions_by_type('Sales', mdx_client.MD_DIMTYPE_TIME)
        self.assertEqual(int(dimension[0]['dimension_type']), mdx_client.MD_DIMTYPE_TIME)


    def test_get_dimension_levels(self):

        cube = 'Sales'
        host, port = settings.MONDRIAN_XMLA_SERVER
        mdx_client = XMLAClient(host, port, settings.MONDRIAN_XMLA_PATH, '%s.FoodMart' % settings.SETTINGS_MODULE)
        dims = mdx_client.get_dimensions(cube)
        dim_levels = mdx_client.get_dimension_levels(cube, dims[0]['dimension_unique_name'])
        self.assertEqual(dim_levels[0]['dimension_unique_name'], dims[0]['dimension_unique_name'])
        self.assertEqual(dim_levels[0]['level_unique_name'], '[Customers].[(All)]')