'''
Created on Aug 1, 2014

@author: rado
'''
from django.conf import settings
from iqportal.iqube.xmla.client import XMLAClient
from basesoft.web.test.unit import iqportal_unittest
from iqportal.iqube.core.models import DataSource

class TestCase(iqportal_unittest.IQPortalTestCase):


    def setUp(self):
        self.connect_db()


    def test_full_headers(self):
        cube= 'Sales'
        validate_captions = ['1997, Q1', '1997, Q2','1997, Q3','1997, Q4']

        ds = self.sa_session.query(DataSource).filter(DataSource.name == '%s.FoodMart' % settings.SETTINGS_MODULE).one()
        mdx = """
            SELECT {[Measures].[Unit Sales],[Measures].[Store Cost]} ON COLUMNS,
                CROSSJOIN({[Time].[1997].[Q1], [Time].[1997].[Q2], [Time].[1997].[Q3], [Time].[1997].[Q4]}, {[Product].[Food],[Product].[Drink]}) ON ROWS
            FROM [%s]
            """ % cube

        host, port = settings.MONDRIAN_XMLA_SERVER
        mdx_client = XMLAClient(host, port, settings.MONDRIAN_XMLA_PATH, '%s.FoodMart' % settings.SETTINGS_MODULE)
        result = mdx_client.execute_mdx(mdx)
        #get full headers
        result.process_full_headers(['[Time]'], ds.id, cube, with_ancestors=True)

        headers = result.get_headers()
        rows = headers['rows']
        test_row_caption = []

        # test caption on ROWS
        for r in rows:
            for mem in r:
                if mem.get('hierarchy') == 'Time' and mem.get('caption') not in test_row_caption:
                    test_row_caption.append(mem.get('caption'))
        self.assertEqual(test_row_caption, validate_captions)

        #test caption on COLUMNS as well
        mdx = """
            SELECT {[Time].[1997].[Q1], [Time].[1997].[Q2], [Time].[1997].[Q3], [Time].[1997].[Q4]} ON COLUMNS,
                CROSSJOIN({[Measures].[Unit Sales],[Measures].[Store Cost]}, {[Product].[Food],[Product].[Drink]}) ON ROWS
            FROM [%s]
            """ % cube

        result = mdx_client.execute_mdx(mdx)
        #get full headers
        result.process_full_headers(['[Time]'], ds.id, cube, with_ancestors=True)

        full_headers = result.get_headers()
        cols = full_headers['columns']
        test_col_caption = []

        for c in cols:
            for m in c:
                if m.get('hierarchy') == 'Time' and m.get('caption') not in test_col_caption:
                    test_col_caption.append(m.get('caption'))
        self.assertEqual(test_col_caption, validate_captions)
