'''
Created on Jul 14, 2014

@author: rado
'''
from basesoft.web.test.unit import iqportal_unittest
from django.conf import settings
from iqportal.iqube.core.controllers import IQubeController
from iqportal.iqube.core.models import DataSource

class TestCase(iqportal_unittest.IQPortalTestCase):


    def setUp(self):
        self.connect_db()

        self.qc = IQubeController()


    def test_iqube_get_member_captions(self):

        members_str = ['[Time.Weekly].[1997].[1]', '[Store].[Mexico].[Guerrero].[Acapulco]', '[Store].[Mexico]',
                       '[Store].[All Stores]', '[Store].[Mexico].Children', '[Store].[Store Country].Members']
        cube = 'Sales'
        ds = self.sa_session.query(DataSource).filter(DataSource.name == '%s.FoodMart' % settings.SETTINGS_MODULE).one()

        captions = self.qc.get_members_captions(ds.id, cube, members_str, with_ancestors=True)
        self.assertEqual(captions['[Time.Weekly].[1997].[1]'], ['1997','1'])
        self.assertEqual(captions['[Store].[Mexico].[Guerrero].[Acapulco]'], ['Mexico', 'Guerrero', 'Acapulco'])
        self.assertEqual(captions['[Store].[Mexico]'], ['Mexico'])
        self.assertEqual(captions['[Store].[All Stores]'], ['Store', 'All Stores'])
        self.assertEqual(captions['[Store].[Mexico].Children'], ['Mexico', '(Children)'])
        self.assertEqual(captions['[Store].[Store Country].Members'], ['Store Country', '(Members)'])

        captions = self.qc.get_members_captions(ds.id, cube, members_str)
        self.assertEqual(captions['[Time.Weekly].[1997].[1]'], ['1'])
        self.assertEqual(captions['[Store].[Mexico].[Guerrero].[Acapulco]'], ['Acapulco'])
        self.assertEqual(captions['[Store].[Mexico]'], ['Mexico'])
        self.assertEqual(captions['[Store].[All Stores]'], ['All Stores'])
        self.assertEqual(captions['[Store].[Mexico].Children'], ['Mexico', '(Children)'])
        self.assertEqual(captions['[Store].[Store Country].Members'], ['Store Country', '(Members)'])
