# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from django.conf import settings

from basesoft.web.test.unit import iqportal_unittest
import xmlrpclib
from twisted.trial.unittest import SkipTest

class ServletTestCase(iqportal_unittest.IQPortalTestCase):

    def setUp(self):
        self.proxy = xmlrpclib.ServerProxy(settings.IQUBE_SERVLET)

        raise SkipTest('needs rewriting')

    def _test_update_datasource(self):

        foodmart = settings.DB_CONNSTR_FOODMART
        db = {}

        conn = foodmart.split("/")
        db['protocol'] = conn[0].replace(":", "")
        db['db_name'] = conn[3]

        m = conn[2].split("@")

        hp = m[1].split(":")
        db['host'] = hp[0]
        db['port'] = "3306"
        if len(hp) > 1:
            db['port'] = hp[1]

        up = m[0].split(":")
        db['user'] = up[0]
        db['password'] = up[1]

        p = self.proxy.IQubeServer.updateDatasource("ds_name", "ds_descr", db, "ds_name")
        self.assertEqual(p["status"], "OK")

    def _test_update_cube(self):

        xml = '<Cube name="mynewcube">\
<Table name="sales_fact_1997" />\
<Dimension foreignKey="promotion_id" name="Promotions">\
<Hierarchy allMemberName="All Promotions" defaultMember="[All Promotions]" hasAll="true" primaryKey="promotion_id">\
<Table name="promotion" />\
<Level column="promotion_name" name="Promotion Name" />\
</Hierarchy>\
</Dimension>\
<Measure aggregator="sum" column="unit_sales" formatString="##,####.##" name="Unit Sales" />\
<Measure aggregator="sum" column="store_cost" formatString="##,####.##" name="Store Cost" />\
</Cube>'
        p = self.proxy.IQubeServer.updateCube("ds_name", xml)
        self.assertEqual(p["status"], "OK")

    def _test_get_datasource(self):
        p = self.proxy.IQubeServer.getDatasourceInfo("ds_name")
        self.assertEqual(p["status"], "OK")

    def _test_flush_schema(self):
        p = self.proxy.IQubeServer.flushSchema("ds_name")
        self.assertEqual(p["status"], "OK")

    def test_servlet(self):
        """
        Since the above tests need a certain order, better test them all in here
        """
        #print
        #print 'test_update_datasource'
        self._test_update_datasource()

        #print 'test_update_cube'
        self._test_update_cube()

        #print 'test_get_datasource'
        self._test_get_datasource()

        #print 'test_flush_schema_cache'
        self._test_flush_schema()
