# Copyright (c) 2009 BaseSoft B.V.
# See LICENSE for details.

from basesoft.web.contrib.account.models import Account
from iqportal.iquest.core.models import IQuestTheme, IQuestThemeGroup
from iqportal.iqreport.core.models import ReportTheme, ReportThemeGroup

from sqlalchemy.orm.exc import NoResultFound

def sync(session):
    """
    """
    account = None
    try:
        account = session.query(Account).filter(Account.name=='user_compose').one()
        group = account.groups[0].group
    except NoResultFound:
        print 'WARNING: iquest/test/db_sync: user_compose not found'

    if account is not None:
        theme = session.query(IQuestTheme).filter(IQuestTheme.name=='Debug').one()
        groups = [g.group for g in theme.groups]
        if group not in groups:
            tg = IQuestThemeGroup()
            tg.privilege = IQuestTheme.PRIV_VIEW
            tg.group = group
            tg.theme = theme
            tg.group_has_privilege = True
            session.add(tg)

        session.flush()

