/**
 * Copyright (c) 2010 BaseSoft B.V.
 * See LICENSE for details.
 */
(function() {

	//
	// Important: this test is currently disabled, it should become a proper selenium test
	//

	BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

		name: "IQuest Reporting Test",

		setUp: function() {

			var sandbox = YAHOO.util.Dom.get('sandbox');
			sandbox.innerHTML = '';

			this.composition_el = document.createElement('div');
			sandbox.appendChild(this.composition_el);
		},

		testReport: function() {

			this._rpc = new BASESOFT.util.JsonBroker('iqportal.iquest.test.IQuestReportRpc', {executeIfLoggedOut: true, timeout: 3600 * 1000});
			this._rpc.call('create_report', [], function(result) {

				this.resume(function() {
					console.warn('result', result);

					BASESOFT.env.account.id = result['account_id'];

					var publication1_id = result['pub1'];
					var publication2_id = result['pub2'];

					var p = new BASESOFT.iquest.report.ReportPanel({runner_id: publication1_id});

					var _this = this;

					var checky = function() {
						console.warn('in checky');

						var tables = YAHOO.util.Selector.query('table[class~=bs-iqreport-result-table]');

						// wait till tables are 10 else schedule new timeout
						if (tables.length !== 10) {
							console.warn('scheduling new checky');
							setTimeout(checky, 2000);
							return;
						}

						_this.resume(function() {
							try {

								console.warn('tables', tables);

								// first table
								_this.assertTable(tables[0], 'Do you like cows?', [
									['Answer', '#', null, '%'],
									['Yes', '3', null, '60'],
									['No.. bleh', '2', null, '40'],
									[null, '5', null, null]
								]);

								// do you like... dog
								_this.assertTable(tables[1], 'Dog', [
									['Answer', '#', null, '%'],
									['Little', '1', null, '16.67'],
									['Medium', '0', null, '0'],
									['A Lot', '5', null, '83.33'],
									[null, '6', null, null]
								]);

								_this.assertTable(tables[5], 'But how many cows do you have?', [
									['Answer', '#', 'Sum', 'Average'],
									['Number of cows', '10', '135', '13.5']
								]);

								// the 'how much?.. dog table
								_this.assertTable(tables[6], 'Dog', [
									['Answer', '#', 'Sum', 'Average'],
									['Yesterday', '10', '472.5', '47.25'],
									['Today', '10', '0', '0'],
									['Tomorrow', '10', '238.5', '23.85']
								]);

								console.warn('passy!');

							} catch (e) {
								console.error(e);
								throw e;
							}

						});

					};

					setTimeout(checky, 5000);

					this.wait(10*60*1000); // mdx execution


				});

			}, null, this);

			this.wait(10 * 60*1000); // serverside survey/responses creation

		},

		assertTable: function(tableEl, caption, data) {

			if (!tableEl.id)
				tableEl.id = YAHOO.util.Dom.generateId();

			if (caption) {
				var captionEl = YAHOO.util.Selector.query('table#'+tableEl.id+' > caption', tableEl.parentNode)[0];
				YAHOO.util.Assert.areEqual(caption, captionEl.innerHTML);
			}

			var trs = YAHOO.util.Selector.query('table#'+tableEl.id+' > * > tr', tableEl.parentNode);

			for (var i in data) {
				var row = data[i];

				for (var j in row) {
					var v = row[j];

					if (v === null)
						continue;

					YAHOO.util.Assert.areEqual(data[i][j], trs[i].childNodes[j].innerHTML);


				}
			}

		}

	}));

})();

YAHOO.register("test_iquest_report", null, {version: "1.0.0", build: "1"});
