# Copyright (c) 2011 BaseSoft B.V.
# See LICENSE for details.
from iqportal.iquest.test.unit.test_report import ReportTest
from basesoft.web.contrib.account.controllers import AccountController




class IQuestReportRpc:

    def __init__(self, request, **kwargs):
        self.request = request


    def create_report(self):
        """
        returns values needed to build a multidimensional datatable
        """

        rt = ReportTest()
        rt.setUp()
        pub1, pub2 = rt.test_report(assert_=False)

        self.request.session['user_id'] = rt.account.id

        ac = AccountController(self.request.Session(), account_id = rt.account.id)
        if not ac.config.get('basesoft.web.contrib.locale'):
            ac.config.set('basesoft.web.contrib.locale', 'en_GB')

        self.request.session['config'] = ac.config.get_configs()

        return {
            'account_id': rt.account.id,
            'pub1': pub1,
            'pub2': pub2,
        }

handlers = (IQuestReportRpc, )
