/*
 * Copyright (c) 2010 BaseSoft Solutions B.V.
 * See LICENSE for details.
 */
(function() {

	BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

		name: "Wave Runner Test",
		assertClean: true,

		setUp: function() {
			var sandbox = YAHOO.util.Dom.get('sandbox');
			sandbox.innerHTML = '';

			this.container = document.createElement('div');
			sandbox.appendChild(this.container);
		},

		testWave39c: function() {

			var runner = null;

			var runSurveyCorben = function(result) {
				this.resume(function() {
					runner = new BASESOFT.tnt.clm.WaveRunner(result);
					runner.render(this.container);

					runner.subscribe('waveLoaded', function(){
						this.resume(function() {
							//runner.destroy();
						});
					}, null, this);
					this.wait();
				});
			};

			var createSurveyCorben = function(result) {
				this.resume(function() {

					BASESOFT.env.account.id = result.id;

					var broker = new BASESOFT.util.JsonBroker('/iqportal.tnt.test/selenium/yui/rpc/', 60000);
					broker.call('create_wave_39c', [], runSurveyCorben, null, this);

					this.wait();
				});
			};

			// Login
			var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
			loginrpc.call('login', ['user_compose', 'pass_compose'], createSurveyCorben, null, this);

			this.wait();
		},

		testWave36: function() {

			var runner = null;

			var runSurveyCorben = function(result) {
				this.resume(function() {
					runner = new BASESOFT.tnt.clm.WaveRunner(result);
					runner.render(this.container);

					runner.subscribe('waveLoaded', function(){
						this.resume(function() {
							runner.destroy();
						});
					}, null, this);
					this.wait();
				});
			};

			var createSurveyCorben = function(result) {
				this.resume(function() {
					BASESOFT.env.account.id = result.id;

					var broker = new BASESOFT.util.JsonBroker('/iqportal.tnt.test/selenium/yui/rpc/', 60000);
					broker.call('create_wave_36', [], runSurveyCorben, null, this);

					this.wait();
				});
			};

			// Login
			var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
			loginrpc.call('login', ['user_compose', 'pass_compose'], createSurveyCorben, null, this);

			this.wait();
		},

		testWave33: function() {

			var runner = null;

			var runSurveyCorben = function(result) {
				this.resume(function() {
					runner = new BASESOFT.tnt.clm.WaveRunner(result);
					runner.render(this.container);

					runner.subscribe('waveLoaded', function(){
						this.resume(function() {
							runner.destroy();
						});
					}, null, this);
					this.wait();
				});
			};

			var createSurveyCorben = function(result) {
				this.resume(function() {
					BASESOFT.env.account.id = result.id;

					var broker = new BASESOFT.util.JsonBroker('/iqportal.tnt.test/selenium/yui/rpc/', 60000);
					broker.call('create_wave_33', [], runSurveyCorben, null, this);

					this.wait();
				});
			};

			// Login
			var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
			loginrpc.call('login', ['user_compose', 'pass_compose'], createSurveyCorben, null, this);

			this.wait();

		},

        testWavePriority: function(){

            var runSurveyCorben = function(wave_id){
                this.resume(function(){

                    console.warn('resuming afterlogin');

                    try {

                        var p = new BASESOFT.tnt.clm.WaveRunnerPreviewPanel(wave_id, null, true);

                        p.runner.subscribe('waveLoaded', function(){

                            this.resume(function(){

                                // todo: select some priorities, tho it does save also without

                                p.set_priorities();
                                p.subscribe('prioritiesSet', function(){
                                    this.resume(function(){
                                        p.destroy();
                                    });
                                }, null, this);
								this.wait();
                            });
                            this.wait();
                        }, null, this);
                    }
                    catch (e) {
                        console.error(e);
                    }
                    this.wait();
                });
            };

            // create survey
            var createSurveyCorben = function(result){
                this.resume(function(){
					BASESOFT.env.account.id = result.id;

                    var broker = new BASESOFT.util.JsonBroker('/iqportal.tnt.test/selenium/yui/rpc/', 60000);
                    broker.call('create_wave_36', [], runSurveyCorben, null, this);

                    console.warn('waiting for login');
                    this.wait();
                });
            };

            // Login
            var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
            loginrpc.call('login', ['tnt_account_test', 'tnt_password'], createSurveyCorben, null, this);
            this.wait();

        }
	}));
})();