/*
 * Copyright (c) 2010 BaseSoft Solutions B.V.
 * See LICENSE for details.
 */
(function(){

    BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

        name: "Wave Translate Test",
        assertClean: true,

        setUp: function(){
            var sandbox = YAHOO.util.Dom.get('sandbox');
            sandbox.innerHTML = '';

            this.container = document.createElement('div');
            sandbox.appendChild(this.container);
        },

        testWaveTranslate: function(){

            var runner = null;

            // this is a hack to have all permissions
            BASESOFT.env.permissions.has = function(){
                return true;
            };

            var waveLoaded = function(e, p) {
                this.resume(function(){

                    console.warn('resuming after wave state loaded');

                    try {
                        // unsubscribe this method so it wont be called again when new state is loaded
                        p.unsubscribe('waveStateLoaded', waveLoaded);

                        var loc = 8;
                        if(loc == BASESOFT.env.account.config.get('tnt.clm.translate.locale.right'))
                            loc = 7;
                        var localeInput = p._rightForm.getChildByName('locale');
                        localeInput.input.set('value', loc); // FIXME: is there a better way to set a option by name in form?

                        // TODO: fill in locale and save, change to another locale and add translations then press save

                        // close panel when new translations are loaded
                        p.subscribe('waveStateLoaded', function(){
							p.unsubscribeAll('waveStateLoaded');
							this.resume(function(){
                                console.warn('received waveStateLoaded again');
                                p.copyLeftToRight();
                                p.save();
                                p.subscribe('waveStateSaved', function(){
                                    this.resume(function(){
                                        console.warn('destroying panel');
                                        p.destroy();
                                    });
                                }, null, this);
                                this.wait();
                            });

                        }, null, this);
                    }
                    catch (e) {
                        console.error(e);
                    }

                    this.wait();
                });
            };

            var runSurveyCorben = function(wave_id){
                this.resume(function(){

                    console.warn('resuming afterlogin');

                    try {

                        // show new translation panel
                        var p = new BASESOFT.tnt.clm.WaveTranslationPanel(wave_id);
                        p.subscribe('waveStateLoaded', waveLoaded, p, this);

                    }
                    catch (e) {
                        console.error(e);
                    }

                    console.warn('waiting for wave state loaded');
                    this.wait();

                });
            };

            var createSurveyCorben = function(result){
                this.resume(function(){
					BASESOFT.env.account.id = result.id;

                    var broker = new BASESOFT.util.JsonBroker('/iqportal.tnt.test/selenium/yui/rpc/', 60000);
                    broker.call('create_wave_36', [], runSurveyCorben, null, this);

                    console.warn('waiting for login');
                    this.wait();
                });
            };

            // Login
            var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
            loginrpc.call('login', ['tnt_account_test', 'tnt_password'], createSurveyCorben, null, this);
            this.wait();
        },

        testWaveHistory: function(){

            var runSurveyCorben = function(wave_id){
                this.resume(function(){
                    console.warn('resuming afterlogin');
                    try {
                        var p = new BASESOFT.tnt.clm.WaveTranslationsDiffPanel(wave_id);
                        p.subscribe('onTranslationsChanged', function(){
                            try {
                                // TODO: change some revisions
                                // finally destroy panel
                                p.destroy();
                            }
                            catch (e) {
                                console.error(e);
                            }
                        }, null, this);
                    }
                    catch (e) {
                        console.error(e);
                    }
                });
            };

            // create survey
            var createSurveyCorben = function(result){
                this.resume(function(){
					BASESOFT.env.account.id = result.id;

                    var broker = new BASESOFT.util.JsonBroker('/iqportal.tnt.test/selenium/yui/rpc/', 60000);
                    broker.call('create_wave_36', [], runSurveyCorben, null, this);

                    console.warn('waiting for login');
                    this.wait();
                });
            };

            // Login
            var loginrpc = new BASESOFT.util.JsonBroker('/basesoft.web.contrib.account/login/rpc/', {executeIfLoggedOut: true});
            loginrpc.call('login', ['tnt_account_test', 'tnt_password'], createSurveyCorben, null, this);
            this.wait();

        }
    }));
})();
