'''
Created on Jan 27, 2015

@author: rado
'''
from basesoft.web.test.selenium.selenium_testcase import SeleniumTestCase
from basesoft.web.contrib.account.models import Account

class TestCase(SeleniumTestCase):

    def setUp(self):
        super(TestCase, self).setUp()

        self.connect_db()

        self.tnt_account = self.session.query(Account).filter(Account.name=='tnt_account_test').one()

    def test_location_2015(self):
        # login with account
        self.login(self.tnt_account.name, 'tnt_password')
        self.wait_for_loading()

        #open category manager
        self.click_iconbar('icon-clm-locale-manager', 'icon-wave-manager')

        #create new category from manager menu
        self.click_menu('tnt-locale-manager', menu_index=1, text='Create a new locale')
        self.wait_for_loading()

        values = {
            'label': ('input_text', 'ABCDE'),
            'description': ( 'textarea', 'Test tnt description'),
            'location': ( 'select', 'Domestic'),
            'location_2015': ( 'select', 'International'),
            'country': ( 'select', 'Austria'),
            'service': ( 'input_text', 'Express'),
        }
        self.fill_form(panel_name='tnt-locale-panel', values=values)
        self.click_button(panel_name='tnt-locale-panel', text='Save and close')
        self.wait_for_loading()

        # find the new Record
        self.filter_cq(panel_name='tnt-locale-manager', filters=[('Label', 'Equal', 'ABCDE')])
        self.wait_for_loading()

        self.assert_cq(panel_name='tnt-locale-manager', row_index=0, data={'location_2015': 'I', 'label': 'ABCDE'})