# Copyright (c) 2010 BaseSoft B.V.
# See LICENSE for details.

from twisted.trial import unittest
from django.conf import settings

from basesoft.web.test.unit import iqportal_unittest
from iqportal.tnt.sr.controllers import TntServiceRecoveryPHP4ConversionController

class ConversionControllerTestCase(iqportal_unittest.IQPortalTestCase):
    def setUp(self):
        if settings.DB_PHP4_IQUEST is None:
            raise unittest.SkipTest("This test will only run if the PHP4 IQuest DB settings are provided")

        self.connect_db()
        self.account = self._create_active_account()
        self.group = self.account.groups[0].group
        self._attach_permissions_to_group(self.group, 'develop_tools')

        self.controller = TntServiceRecoveryPHP4ConversionController(self.session, account_id=self.account.id)
        self.controller.set_connection(**settings.DB_PHP4_IQUEST)

    def test_convert_geolevels(self):
        self.controller.convert_geolevels(self.group)

    def test_convert_responses(self):
        user_map = self.controller.convert_accounts(self.group.license, 'SR User', self.group)
        self.controller.convert_responses(self.group, user_map)