# Copyright (c) 2015 BaseSoft B.V.
# See LICENSE for details.
from basesoft.web.core.exceptions import PermissionDeniedException
from basesoft.web.test.unit import iqportal_unittest

from iqportal.weee.core.controllers import WEEEController
from iqportal.weee.core.models import WEEEProductLevel


class TestCase(iqportal_unittest.IQPortalTestCase):

    def setUp(self):
        self.connect_db()
        account = self._create_active_account()
        self.group = account.default_group
        self.controller = WEEEController(self.sa_session, account_id=account.id)

    def test_get_product_level_tree(self):
        # TODO extend this test
        # we should not have permissions to access this
        self.assertRaises(PermissionDeniedException, self.controller.get_product_level_tree)

        self._attach_permissions_to_group(self.group, 'view_weee_product_levels')

        # we should have privileges to all default WEEE products
        plt = self.controller.get_product_level_tree()
        self.assertEqual(len(plt), 3)

