/**
 * Copyright (c) 2011 BaseSoft B.V.
 * See LICENSE for details.
 *
 * @module test_cube_table
 */

(function() {
	"use strict";

BASESOFT.test.TestCases.push(new BASESOFT.tool.TestCase({

	name: "test_cube_table",

	setUp: function(){
		this.sandbox = YAHOO.util.Dom.get('sandbox');
		this.sandbox.innerHTML = '';
	},

	testTableCubeCols: function() {
		var columns = [[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		},{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		},{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}],[{
			hierarchy: 'Answers',
			caption: '% Much lower',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[% Much lower]'
		},{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}],[{
			hierarchy: 'Answers',
			caption: '% Much lower',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[% Much lower]'
		},{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		},{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		},{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		},{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		},{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}]];

		var rows = [[{
			hierarchy: 'Attributes',
			caption: 'Ability of our drivers to offer assistance',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[31]'
		}]];

		var slicers = [[{
			hierarchy: 'Measures',
			caption: 'Responses'
		}]];

		var data = [{
			cellOrdinal: 0,
			value: 72
		}, {
			cellOrdinal: 1,
			value: 76
		},{
			cellOrdinal: 2,
			value: 22.222222
		}, {
			cellOrdinal: 3,
			value: 17.105263
		},{
			cellOrdinal: 4,
			value: 72
		}, {
			cellOrdinal: 5,
			value: 76
		},{
			cellOrdinal: 6,
			value: 72
		}, {
			cellOrdinal: 7,
			value: 76
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {
			columns: columns, rows: rows, slicers: slicers, data: data,
			showSlicers: true, showHierarchyNames: true, dragDrop: true,
			drillHierarchies: ['Wave', 'Attributes'],
			hasDrillPosition:false, hasDrillReplace: false, hasDrillThrough:false
		});

		this._garbage.push(ct);
		var grid = [
		    ['','Total','','% Much lower','','Total','','',''],
		    ['','W38Q12010','W39Q22011','W38Q12010','W39Q22011','W38Q12010','W39Q22011','W38Q12010','W39Q22011'],
		    ['Ability of our drivers to offer assistance',72,76,22.222222,17.105263,72,76,72,76]
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));


		this.sandbox.appendChild(ct.get('element'));


	},

	testTableCubeRows: function() {

		var columns = [[{
			hierarchy: 'Measures',
			caption: 'Unit Sales'
		}]];

		var rows = [[{
			hierarchy: 'Time',
			caption: 'Q1',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q1]'
		}, {
			hierarchy: 'Store',
			caption: 'Canada',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Canada]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q1',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q1]'
		}, {
			hierarchy: 'Store',
			caption: 'Mexico',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Mexico]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q1',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q1]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q2',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q2]'
		}, {
			hierarchy: 'Store',
			caption: 'Canada',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Canada]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q2',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q2]'
		}, {
			hierarchy: 'Store',
			caption: 'Mexico',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Mexico]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q2',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q2]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q3',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q3]'
		}, {
			hierarchy: 'Store',
			caption: 'Canada',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Canada]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q3',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q3]'
		}, {
			hierarchy: 'Store',
			caption: 'Mexico',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Mexico]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q3',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q3]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q4',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q4]'
		}, {
			hierarchy: 'Store',
			caption: 'Canada',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Canada]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q4',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q4]'
		}, {
			hierarchy: 'Store',
			caption: 'Mexico',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[Mexico]'
		}], [{
			hierarchy: 'Time',
			caption: 'Q4',
			lname: '[Time].[(All)]',
			lnum: "0",
			uname: '[Time].[Q4]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}]];

		var slicers = [];

		var data = [{
			cellOrdinal: 2,
			value: 66291
		},{
			cellOrdinal: 5,
			value: 62610
		},{
			cellOrdinal: 8,
			value: 20179
		},{
			cellOrdinal: 11,
			value: 21081
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: columns, rows: rows, slicers: slicers, data: data});
		this._garbage.push(ct);
		var grid = [
		    ['','','Unit Sales'],
		    ['Q1','Canada','-'],
		    ['','Mexico','-'],
		    ['','USA',66291],
		    ['Q2','Canada','-'],
		    ['','Mexico','-'],
		    ['','USA',62610],
		    ['Q3','Canada','-'],
		    ['','Mexico','-'],
		    ['','USA',20179],
		    ['Q4','Canada','-'],
		    ['','Mexico','-'],
		    ['','USA',21081]
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));

		this.sandbox.appendChild(ct.get('element'));

	},

	testMultiLevelRows: function() {
		var columns = [[{
			hierarchy: 'Measures',
			caption: 'Unit Sales'
		}]];

		var rows = [[ {
			hierarchy: 'Product',
			caption: 'Food',
			lname: '[Product].[(All)]',
			lnum: "0",
			uname: '[Product].[Food]'
		}, {
			hierarchy: 'Store Type',
			caption: 'HeadQuarters',
			lname: '[Store Type].[(All)]',
			lnum: "0",
			uname: '[Store Type].[HeadQuarters]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}],[{
			hierarchy: 'Product',
			caption: 'Food',
			lname: '[Product].[(All)]',
			lnum: "0",
			uname: '[Product].[Food]'
		}, {
			hierarchy: 'Store Type',
			caption: 'Small Grocery',
			lname: '[Store Type].[(All)]',
			lnum: "0",
			uname: '[Store Type].[Small Grocery]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}],[{
			hierarchy: 'Product',
			caption: 'Baking Goods',
			lname: '[Product].[(All)]',
			lnum: "0",
			uname: '[Product].[Baking Goods]'
		}, {
			hierarchy: 'Store Type',
			caption: 'HeadQuarters',
			lname: '[Store Type].[(All)]',
			lnum: "0",
			uname: '[Store Type].[HeadQuarters]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}],[{
			hierarchy: 'Product',
			caption: 'Baking Goods',
			lname: '[Product].[(All)]',
			lnum: "0",
			uname: '[Product].[Baking Goods]'
		}, {
			hierarchy: 'Store Type',
			caption: 'Small Grocery',
			lname: '[Store Type].[(All)]',
			lnum: "0",
			uname: '[Store Type].[Small Grocery]'
		}, {
			hierarchy: 'Store',
			caption: 'USA',
			lname: '[Store].[(All)]',
			lnum: "0",
			uname: '[Store].[USA]'
		}]];

		var slicers = [[
			{hierarchy: 'Year',caption: '2010'},
			{hierarchy: 'Status',caption: 'debit'}
			],[
			{hierarchy: 'Year',caption: '2011'},
			{hierarchy: 'Status',caption: 'debit'}
			],[
			{hierarchy: 'Year',caption: '2012'},
			{hierarchy: 'Status',caption: 'debit'}
		],[
			{hierarchy: 'Year',caption: '2010'},
			{hierarchy: 'Status',caption: 'credit'}
			],[
			{hierarchy: 'Year',caption: '2011'},
			{hierarchy: 'Status',caption: 'credit'}
			],[
			{hierarchy: 'Year',caption: '2012'},
			{hierarchy: 'Status',caption: 'credit'}
		]];

		var data = [{
			cellOrdinal: 1,
			value: 4764
		}, {
			cellOrdinal: 3,
			value: 538
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: columns, rows: rows, slicers: slicers, data: data, showTransposeOption: true, showSlicers: true, dragDrop: true, showHierarchyNames: true});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','','','Unit Sales'],
		    ['Food','HeadQuarters','USA','-'],
		    ['','Small Grocery','USA',4764],
		    ['Baking Goods','HeadQuarters','USA','-'],
		    ['','Small Grocery','USA',538]
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));

		// Test axes swapping.
		ct.swapAxes();
		var swappedGrid = [
		    ['','Food','','Baking Goods',''],
		    ['','HeadQuarters','Small Grocery','HeadQuarters','Small Grocery'],
		    ['','USA','USA','USA','USA'],
		    ['Unit Sales','-',4764,'-',538]
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(swappedGrid, ct.get('grid')));

		// Now we swap it back and assert the original grid.
		ct.swapAxes();
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testNoRows: function() {
		var columns = [[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}], [{
			hierarchy: 'Answers',
			caption: 'Dissatisfied',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Dissatisfied]'
		}], [{
			hierarchy: 'Answers',
			caption: 'Meeting Cust. Exp.',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Meeting Cust. Exp.]'
		}], [{
			hierarchy: 'Answers',
			caption: 'Exceeding Cust. Exp.',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Exceeding Cust. Exp.]'
		}], [{
			hierarchy: 'Answers',
			caption: 'NCS Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[NCS Score]'
		}], [{
			hierarchy: 'Answers',
			caption: 'Mean Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Mean Score]'
		}]];

		var rows = [];

		var slicers = [[{
			hierarchy: 'Position',
			caption: 'Overall satisfaction'
		}]];

		var data = [{
			cellOrdinal: 0,
			value: 448
		},{
			cellOrdinal: 1,
			value: 37.723214
		}, {
			cellOrdinal: 2,
			value: 62.276785
		}, {
			cellOrdinal: 3,
			value: 41.964285
		}, {
			cellOrdinal: 4,
			value: 4.241071
		},{
			cellOrdinal: 5,
			value: 3.055803
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: columns, rows: rows, slicers: slicers, data: data, showSlicers: true});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['Total','Dissatisfied','Meeting Cust. Exp.','Exceeding Cust. Exp.','NCS Score','Mean Score'],
		    [448,37.723214,62.276785,41.964285,4.241071,3.055803]
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testRowsAndCols: function() {
		var columns = [[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}], [{
			hierarchy: 'Answers',
			caption: 'NCS Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[NCS Score]'
		}], [{
			hierarchy: 'Answers',
			caption: 'Mean Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Mean Score]'
		}]];

		var rows = [[{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}], [{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}]];

		var slicers = [[{
			hierarchy: 'Position',
			caption: 'Overall satisfaction'
		}]];

		var data = [{
			cellOrdinal: 0,
			value: 223
		},{
			cellOrdinal: 1,
			value: 4.484
		}, {
			cellOrdinal: 2,
			value: 3.053
		}, {
			cellOrdinal: 3,
			value: 225
		}, {
			cellOrdinal: 4,
			value: 4
		},{
			cellOrdinal: 5,
			value: 3.057
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: columns, rows: rows, slicers: slicers, data: data, showSlicers: true});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','Total','NCS Score','Mean Score'],
		    ['W39Q22011',223,4.484,3.053],
		    ['W38Q12010',225,4,3.057]
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testMultiRowAndCols: function() {
		var columns = [[{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}, {
			hierarchy: 'Pool',
			caption: '9',
			lname: '[Pool].[(All)]',
			lnum: "0",
			uname: '[Pool].[9]'
		}],[{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}, {
			hierarchy: 'Pool',
			caption: '19',
			lname: '[Pool].[(All)]',
			lnum: "0",
			uname: '[Pool].[19]'
		}],[{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}, {
			hierarchy: 'Pool',
			caption: '9',
			lname: '[Pool].[(All)]',
			lnum: "0",
			uname: '[Pool].[9]'
		}],[{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}, {
			hierarchy: 'Pool',
			caption: '19',
			lname: '[Pool].[(All)]',
			lnum: "0",
			uname: '[Pool].[19]'
		}]];

		var rows = [[{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'NCS Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[NCS Score]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'Dissatisfied',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Dissatisfied]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'Meeting Cust. Exp.',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Meeting Cust. Exp.]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'Exceeding Cust. Exp.',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Exceeding Cust. Exp.]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'Mean Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Mean Score]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Friendliness and attitude of our Customer Service representatives',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[1]'
		}, {
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'NCS Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[NCS Score]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'Dissatisfied',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Dissatisfied]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'Meeting Cust. Exp.',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Meeting Cust. Exp.]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'Exceeding Cust. Exp.',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Exceeding Cust. Exp.]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'Mean Score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Mean Score]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}], [{
			hierarchy: 'Attributes',
			caption: 'Ease of use of TNT Express internet services',
			lname: '[Attributes].[(All)]',
			lnum: "0",
			uname: '[Attributes].[2]'
		}, {
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}]];

		var slicers = [];

		var data = [{
			cellOrdinal: 3,
			value: -7.5
		}, {
			cellOrdinal: 7,
			value: 46.25
		}, {
			cellOrdinal: 11,
			value: 53.75
		}, {
			cellOrdinal: 15,
			value: 38.75
		}, {
			cellOrdinal: 19,
			value: 2.9375
		}, {
			cellOrdinal: 23,
			value: 80
		}, {
			cellOrdinal: 27,
			value: 80
		}, {
			cellOrdinal: 28,
			value: 3.75
		}, {
			cellOrdinal: 30,
			value: 5.1948
		}, {
			cellOrdinal: 32,
			value: 37.5
		}, {
			cellOrdinal: 34,
			value: 36.3636
		}, {
			cellOrdinal: 36,
			value: 62.5
		}, {
			cellOrdinal: 38,
			value: 63.6363
		}, {
			cellOrdinal: 40,
			value: 41.25
		}, {
			cellOrdinal: 42,
			value: 41.5584
		}, {
			cellOrdinal: 44,
			value: 3.0375
		}, {
			cellOrdinal: 46,
			value: 3.1038
		}, {
			cellOrdinal: 48,
			value: 80
		}, {
			cellOrdinal: 50,
			value: 77
		}, {
			cellOrdinal: 52,
			value: 80
		}, {
			cellOrdinal: 54,
			value: 77
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: columns, rows: rows, slicers: slicers, data: data, showSlicers: true, showHierarchyNames: true, dragDrop: true});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','','W38Q12010','','W39Q22011',''],
		    ['','','9','19','9','19'],
		    ['Friendliness and attitude of our Customer Service representatives','NCS Score','-','-','-',-7.5],
		    ['','Dissatisfied','-','-','-',46.25],
		    ['','Meeting Cust. Exp.','-','-','-',53.75],
		    ['','Exceeding Cust. Exp.','-','-','-',38.75],
		    ['','Mean Score','-','-','-',2.9375],
		    ['','Total','-','-','-',80],
		    ['','','-','-','-',80],
		    ['Ease of use of TNT Express internet services','NCS Score',3.75,'-',5.1948,'-'],
		    ['','Dissatisfied',37.5,'-',36.3636,'-'],
		    ['','Meeting Cust. Exp.',62.5,'-',63.6363,'-'],
		    ['','Exceeding Cust. Exp.',41.25,'-',41.5584,'-'],
		    ['','Mean Score',3.0375,'-',3.1038,'-'],
		    ['','Total',80,'-',77,'-'],
		    ['','',80,'-',77,'-']
		];




		console.warn('grid', grid);
		console.warn('grid', ct.get('grid'));
		this.sandbox.appendChild(ct.get('element'));

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testHiddenColumn: function() {
		var columns = [[{
			hierarchy: 'Answers',
			caption: '# of Answers',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[# of Answers]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Loyalty score',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Loyalty score]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Loyalty score %',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Loyalty score %]'
		}],[{
			hierarchy: 'Answers',
			caption: 'Total',
			lname: '[Answers].[(All)]',
			lnum: "0",
			uname: '[Answers].[Total]'
		}]];

		var rows = [[{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W38Q12010]'
		}],[{
			hierarchy: 'Wave',
			caption: 'W39Q22011',
			lname: '[Wave].[(All)]',
			lnum: "0",
			uname: '[Wave].[W39Q22011]'
		}]];

		var slicers = [];

		var data = [{
			cellOrdinal: 0,
			value: 90
		}, {
			cellOrdinal: 4,
			value: 90
		}];

		var corben = function (rows, columns, data, index, direction) {
			// Now we hide the columns/rows & its data
			var currentIndex, member, members, removeAxis = direction=='rows' ? rows : columns;
			var maxIndex = removeAxis[removeAxis.length-1].length-1;
			for(var i in removeAxis) {
				members = removeAxis[i];
				currentIndex = maxIndex;
				for(var j=members.length-1; j>=0; j--) {
					member = members[j];
					// We found the last entry of it.
					if(member.hierarchy == 'Answers' && member.caption == 'Total') {
						if(direction=='rows') {
							this._hiddenRows = [currentIndex];
						} else {
							this._hiddenColumns = [currentIndex];
						}
						break;
					}
					currentIndex -= (typeof member.axisSpan != 'undefined') ? member.axisSpan : 1;
				}
			}
		};

		var callbacks = [{
			hierarchy: 'Answers',
			caption: 'Total',
			callback: corben
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: columns, rows: rows, slicers: slicers, data: data, callbacks: callbacks});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		// This should not have a Total entry.
		var grid = [
		    ['','# of Answers','Loyalty score','Loyalty score %'],['W38Q12010',90,'-','-'],['W39Q22011',90,'-','-']
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testLeagueTable1: function() {

		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "19.231", "value": "19.230769230769226"}, {"cellOrdinal": "1", "formattedValue": "18.056", "value": "18.055555555555554"}, {"cellOrdinal": "2", "formattedValue": "17.284", "value": "17.28395061728395"}, {"cellOrdinal": "3", "formattedValue": "12.346", "value": "12.345679012345677"}, {"cellOrdinal": "4", "formattedValue": "12.329", "value": "12.328767123287669"}, {"cellOrdinal": "5", "formattedValue": "16.667", "value": "16.666666666666664"}, {"cellOrdinal": "6", "formattedValue": "16.216", "value": "16.216216216216218"}, {"cellOrdinal": "7", "formattedValue": "14.474", "value": "14.473684210526319"}, {"cellOrdinal": "8", "formattedValue": "13.514", "value": "13.513513513513516"}, {"cellOrdinal": "9", "formattedValue": "8.75", "value": "8.75"}, {"cellOrdinal": "10", "formattedValue": "33.333", "value": "33.333333333333336"}, {"cellOrdinal": "11", "formattedValue": "29.167", "value": "29.166666666666668"}, {"cellOrdinal": "12", "formattedValue": "30.864", "value": "30.864197530864196"}, {"cellOrdinal": "13", "formattedValue": "37.037", "value": "37.03703703703704"}, {"cellOrdinal": "14", "formattedValue": "32.877", "value": "32.87671232876713"}, {"cellOrdinal": "15", "formattedValue": "32.051", "value": "32.05128205128205"}, {"cellOrdinal": "16", "formattedValue": "35.135", "value": "35.13513513513514"}, {"cellOrdinal": "17", "formattedValue": "31.579", "value": "31.57894736842105"}, {"cellOrdinal": "18", "formattedValue": "37.838", "value": "37.83783783783784"}, {"cellOrdinal": "19", "formattedValue": "31.25", "value": "31.25"}, {"cellOrdinal": "20", "formattedValue": "66.667", "value": "66.66666666666667"}, {"cellOrdinal": "21", "formattedValue": "70.833", "value": "70.83333333333333"}, {"cellOrdinal": "22", "formattedValue": "69.136", "value": "69.1358024691358"}, {"cellOrdinal": "23", "formattedValue": "62.963", "value": "62.96296296296296"}, {"cellOrdinal": "24", "formattedValue": "67.123", "value": "67.12328767123287"}, {"cellOrdinal": "25", "formattedValue": "67.949", "value": "67.94871794871794"}, {"cellOrdinal": "26", "formattedValue": "64.865", "value": "64.86486486486487"}, {"cellOrdinal": "27", "formattedValue": "68.421", "value": "68.42105263157895"}, {"cellOrdinal": "28", "formattedValue": "62.162", "value": "62.16216216216216"}, {"cellOrdinal": "29", "formattedValue": "68.75", "value": "68.75"}, {"cellOrdinal": "30", "formattedValue": "52.564", "value": "52.56410256410256"}, {"cellOrdinal": "31", "formattedValue": "47.222", "value": "47.22222222222222"}, {"cellOrdinal": "32", "formattedValue": "48.148", "value": "48.148148148148145"}, {"cellOrdinal": "33", "formattedValue": "49.383", "value": "49.382716049382715"}, {"cellOrdinal": "34", "formattedValue": "45.205", "value": "45.205479452054796"}, {"cellOrdinal": "35", "formattedValue": "48.718", "value": "48.717948717948715"}, {"cellOrdinal": "36", "formattedValue": "51.351", "value": "51.351351351351354"}, {"cellOrdinal": "37", "formattedValue": "46.053", "value": "46.05263157894737"}, {"cellOrdinal": "38", "formattedValue": "51.351", "value": "51.351351351351354"}, {"cellOrdinal": "39", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "40", "formattedValue": "3.308", "value": "3.3076923076923075"}, {"cellOrdinal": "41", "formattedValue": "3.292", "value": "3.2916666666666665"}, {"cellOrdinal": "42", "formattedValue": "3.346", "value": "3.345679012345679"}, {"cellOrdinal": "43", "formattedValue": "3.123", "value": "3.123456790123457"}, {"cellOrdinal": "44", "formattedValue": "3.137", "value": "3.136986301369863"}, {"cellOrdinal": "45", "formattedValue": "3.218", "value": "3.217948717948718"}, {"cellOrdinal": "46", "formattedValue": "3.257", "value": "3.2567567567567566"}, {"cellOrdinal": "47", "formattedValue": "3.132", "value": "3.1315789473684212"}, {"cellOrdinal": "48", "formattedValue": "3.162", "value": "3.1621621621621623"}, {"cellOrdinal": "49", "formattedValue": "3.175", "value": "3.175"}, {"cellOrdinal": "50", "formattedValue": "78", "value": "78"}, {"cellOrdinal": "51", "formattedValue": "72", "value": "72"}, {"cellOrdinal": "52", "formattedValue": "81", "value": "81"}, {"cellOrdinal": "53", "formattedValue": "81", "value": "81"}, {"cellOrdinal": "54", "formattedValue": "73", "value": "73"}, {"cellOrdinal": "55", "formattedValue": "78", "value": "78"}, {"cellOrdinal": "56", "formattedValue": "74", "value": "74"}, {"cellOrdinal": "57", "formattedValue": "76", "value": "76"}, {"cellOrdinal": "58", "formattedValue": "74", "value": "74"}, {"cellOrdinal": "59", "formattedValue": "80", "value": "80"}, {"cellOrdinal": "60", "formattedValue": "78", "value": "78"}, {"cellOrdinal": "61", "formattedValue": "72", "value": "72"}, {"cellOrdinal": "62", "formattedValue": "81", "value": "81"}, {"cellOrdinal": "63", "formattedValue": "81", "value": "81"}, {"cellOrdinal": "64", "formattedValue": "73", "value": "73"}, {"cellOrdinal": "65", "formattedValue": "78", "value": "78"}, {"cellOrdinal": "66", "formattedValue": "74", "value": "74"}, {"cellOrdinal": "67", "formattedValue": "76", "value": "76"}, {"cellOrdinal": "68", "formattedValue": "74", "value": "74"}, {"cellOrdinal": "69", "formattedValue": "80", "value": "80"}], "rows": [[{"hierarchy": "Answers", "caption": "NCS Score", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Score]"}], [{"hierarchy": "Answers", "caption": "Dissatisfied", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Dissatisfied]"}], [{"hierarchy": "Answers", "caption": "Meeting Cust. Exp.", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Meeting Cust. Exp.]"}], [{"hierarchy": "Answers", "caption": "Exceeding Cust. Exp.", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Exceeding Cust. Exp.]"}], [{"hierarchy": "Answers", "caption": "Mean Score", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Mean Score]"}], [{"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]], "slicers": [], "columns": [[{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Position", "caption": "29", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[29]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Position", "caption": "13", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[13]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Position", "caption": "2", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[2]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Position", "caption": "17", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[17]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Position", "caption": "12", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[12]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Position", "caption": "21", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[21]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Position", "caption": "22", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[22]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Position", "caption": "23", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[23]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Position", "caption": "10", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[10]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Position", "caption": "13", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[13]"}]]};

		var corben = function (rows, columns, data, index, direction) {
			// Now we hide the columns/rows & its data
			var currentIndex, member, members, removeAxis = direction=='rows' ? rows : columns;
			var maxIndex = ((direction=='columns') ? this._columnTotal : this._rowTotal)-1;
			for(var i in removeAxis) {
				members = removeAxis[i];
				currentIndex = maxIndex;
				for(var j=members.length-1; j>=0; j--) {
					member = members[j];
					// We found the last entry of it.
					if(member.hierarchy == 'Answers' && member.caption == 'Total') {
						if(direction=='rows') {
							this._hiddenRows = [currentIndex];
						} else {
							this._hiddenColumns = [currentIndex];
						}
						break;
					}
					currentIndex -= (typeof member.axisSpan != 'undefined') ? member.axisSpan : 1;
				}
			}
		};

		var callbacks =  [{
			hierarchy: 'Answers',
			caption: 'Total',
			callback: corben
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: response.columns, rows: response.rows, slicers: response.slicers, data: response.data, callbacks: callbacks});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','W38Q12010','','','','','W39Q22011','','','',''],
		    ['','29','13','2','17','12','21','22','23','10','13'],
		    ['NCS Score','19.230769230769226','18.055555555555554','17.28395061728395','12.345679012345677','12.328767123287669','16.666666666666664','16.216216216216218','14.473684210526319','13.513513513513516','8.75'],
		    ['Dissatisfied','33.333333333333336','29.166666666666668','30.864197530864196','37.03703703703704','32.87671232876713','32.05128205128205','35.13513513513514','31.57894736842105','37.83783783783784','31.25'],
		    ['Meeting Cust. Exp.','66.66666666666667','70.83333333333333','69.1358024691358','62.96296296296296','67.12328767123287','67.94871794871794','64.86486486486487','68.42105263157895','62.16216216216216','68.75'],
		    ['Exceeding Cust. Exp.','52.56410256410256','47.22222222222222','48.148148148148145','49.382716049382715','45.205479452054796','48.717948717948715','51.351351351351354','46.05263157894737','51.351351351351354','40'],
		    ['Mean Score','3.3076923076923075','3.2916666666666665','3.345679012345679','3.123456790123457','3.136986301369863','3.217948717948718','3.2567567567567566','3.1315789473684212','3.1621621621621623','3.175'],
		    ['Total','78','72','81','81','73','78','74','76','74','80']
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testHideMultiHierarchyNormal: function () {

		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "1", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "2", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "3", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "4", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "5", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "6", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "7", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "8", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "9", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "10", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "11", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "12", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "13", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "14", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "15", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "16", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "17", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "18", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "19", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "20", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "21", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "22", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "23", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "24", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "25", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "26", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "27", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "28", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "29", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "30", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "31", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "32", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "33", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "34", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "35", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "36", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "37", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "38", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "39", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "40", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "41", "formattedValue": "26", "value": "26"}], "rows": [[{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "JP", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JP]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}]], "slicers": [[{"hierarchy": "Position", "caption": "Overall satisfaction", "lname": "[Position].[(All)]", "lnum": "0", "uname": "[Position].[Overall satisfaction]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};
		//var response = {"data": [{"cellOrdinal": "0", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "1", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "2", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "3", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "4", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "5", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "6", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "7", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "8", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "9", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "10", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "11", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "12", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "13", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "14", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "15", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "16", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "17", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "18", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "19", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "20", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "21", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "22", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "23", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "24", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "25", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "26", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "27", "formattedValue": "26", "value": "26"}], "rows": [[{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "JP", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JP]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}]], "slicers": [[{"hierarchy": "Position", "caption": "Overall satisfaction", "lname": "[Position].[(All)]", "lnum": "0", "uname": "[Position].[Overall satisfaction]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};

		var corben = function (rows, columns, data, indexes, direction) {
			if(direction=='rows') {
				this._hiddenRows = [0, 3];
			} else {
				this._hiddenColumns = [0, 3];
			}
		};

		var callbacks =  [{
			hierarchy: 'Answers',
			caption: 'Total',
			callback: corben
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {showExcelExport: true, columns: response.columns, rows: response.rows, slicers: response.slicers, data: response.data, callbacks: callbacks});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','W39Q22011','','W38Q12010',''],
		    ['','NCS Rank','Total','NCS Rank','Total'],
		    ['CN','1','25','6','21'],
		    ['JP','2','40','1','42'],
		    ['NL','3','37','2','33'],
		    ['GB','4','29','3','32'],
		    ['EG','5','26','4','27'],
		    ['DE','6','34','7','44'],
		    ['BE','7','32','5','26']
		];
		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));

	},

	testHideMultiHierarchyTopDown: function () {

		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "1", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "2", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "3", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "4", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "5", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "6", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "7", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "8", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "9", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "10", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "11", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "12", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "13", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "14", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "15", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "16", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "17", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "18", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "19", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "20", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "21", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "22", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "23", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "24", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "25", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "26", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "27", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "28", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "29", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "30", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "31", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "32", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "33", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "34", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "35", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "36", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "37", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "38", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "39", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "40", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "41", "formattedValue": "26", "value": "26"}], "rows": [[{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "JP", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JP]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}]], "slicers": [[{"hierarchy": "Position", "caption": "Overall satisfaction", "lname": "[Position].[(All)]", "lnum": "0", "uname": "[Position].[Overall satisfaction]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};

		var corben = function (rows, columns, data, indexes, direction) {
			var hide = [];
			var x, add;
			for(var i in indexes) {
				add = this.get_indexes_for(rows, columns, indexes[i].index, indexes[i].depth, direction);
				for(x in add) {
					hide.push(add[x]);
				}
			}
			if(direction=='rows') {
				this._hiddenRows = hide;
			} else {
				this._hiddenColumns = hide;
			}
		};

		var callbacks =  [{
			hierarchy: 'Wave',
			caption: 'W38Q12010',
			callback: corben
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {showExcelExport: true, columns: response.columns, rows: response.rows, slicers: response.slicers, data: response.data, callbacks: callbacks});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','W39Q22011','',''],
		    ['','Total','NCS Rank','Total'],
		    ['CN','25','1','25'],
		    ['JP','40','2','40'],
		    ['NL','37','3','37'],
		    ['GB','29','4','29'],
		    ['EG','26','5','26'],
		    ['DE','34','6','34'],
		    ['BE','32','7','32']
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testHideWithEmptyData: function() {
		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "\n          ", "value": ""}, {"cellOrdinal": "7", "formattedValue": "1,873", "value": "1873"}, {"cellOrdinal": "8", "formattedValue": "40.31", "value": "40.3096636412173"}, {"cellOrdinal": "9", "formattedValue": "59.69", "value": "59.6903363587827"}, {"cellOrdinal": "10", "formattedValue": "40.31", "value": "40.3096636412173"}, {"cellOrdinal": "11", "formattedValue": "0", "value": "0"}, {"cellOrdinal": "12", "formattedValue": "2.999", "value": "2.99893219434063"}, {"cellOrdinal": "13", "formattedValue": "1,873", "value": "1873"}], "rows": [[{"hierarchy": "Country", "caption": "IE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IE]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}]], "slicers": [[]], "columns": [[{"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Answers", "caption": "Dissatisfied", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Dissatisfied]"}], [{"hierarchy": "Answers", "caption": "Meeting Cust. Exp.", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Meeting Cust. Exp.]"}], [{"hierarchy": "Answers", "caption": "Exceeding Cust. Exp.", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Exceeding Cust. Exp.]"}], [{"hierarchy": "Answers", "caption": "NCS Score", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Score]"}], [{"hierarchy": "Answers", "caption": "Mean Score", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Mean Score]"}], [{"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};

		var corben = function (rows, columns, data, indexes, direction) {
			if(direction=='rows') {
				this._hiddenRows = [6];
			} else {
				this._hiddenColumns = [6];
			}
		};

		var callbacks =  [{
			hierarchy: 'Answers',
			caption: 'Total',
			callback: corben
		}];

		//callbacks = [];
		var ct = new BASESOFT.iqube.CubeTable(null, {columns: response.columns, rows: response.rows, slicers: response.slicers, data: response.data, callbacks: callbacks});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','Total','Dissatisfied','Meeting Cust. Exp.','Exceeding Cust. Exp.','NCS Score','Mean Score'],
		    ['IE','','-','-','-','-','-'],
		    ['GB','1873','40.3096636412173','59.6903363587827','40.3096636412173','0','2.99893219434063']
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));
	},

	testLeagueTable: function() {
		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "50", "value": "50"}, {"cellOrdinal": "1", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "2", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "4", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "5", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "6", "formattedValue": "33.333", "value": "33.333333333333336"}, {"cellOrdinal": "7", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "8", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "9", "formattedValue": "50", "value": "50"}, {"cellOrdinal": "10", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "11", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "12", "formattedValue": "50", "value": "50"}, {"cellOrdinal": "13", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "14", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "16", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "18", "formattedValue": "100", "value": "100"}, {"cellOrdinal": "19", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "20", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "22", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "24", "formattedValue": "33.333", "value": "33.333333333333336"}, {"cellOrdinal": "25", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "26", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "28", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "29", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "31", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "34", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "35", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "36", "formattedValue": "33.333", "value": "33.333333333333336"}, {"cellOrdinal": "37", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "38", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "40", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "41", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "42", "formattedValue": "33.333", "value": "33.333333333333336"}, {"cellOrdinal": "43", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "44", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "45", "formattedValue": "66.667", "value": "66.66666666666667"}, {"cellOrdinal": "46", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "47", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "49", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "50", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "51", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "52", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "53", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "55", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "56", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "58", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "61", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "62", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "64", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "65", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "66", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "67", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "68", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "69", "formattedValue": "20", "value": "20"}, {"cellOrdinal": "70", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "71", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "73", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "76", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "79", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "80", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "81", "formattedValue": "66.667", "value": "66.66666666666667"}, {"cellOrdinal": "82", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "83", "formattedValue": "3", "value": "3"}], "rows": [[{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}], [{"hierarchy": "Country", "caption": "FR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FR]"}], [{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "PL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PL]"}]], "slicers": [[{"hierarchy": "Service", "caption": "Express", "lname": "[Service].[Service]", "lnum": "1", "uname": "[Service].[Express]"}, {"hierarchy": "Position", "caption": "31", "lname": "[Position].[Position]", "lnum": "1", "uname": "[Position].[31]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W.4", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W.4]"}, {"hierarchy": "KPI", "caption": "Score %", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Score %]"}], [{"hierarchy": "Wave", "caption": "W.4", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W.4]"}, {"hierarchy": "KPI", "caption": "Rank", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Rank]"}], [{"hierarchy": "Wave", "caption": "W.4", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W.4]"}, {"hierarchy": "KPI", "caption": "No. of Answers", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W.2", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W.2]"}, {"hierarchy": "KPI", "caption": "Score %", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Score %]"}], [{"hierarchy": "Wave", "caption": "W.2", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W.2]"}, {"hierarchy": "KPI", "caption": "Rank", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Rank]"}], [{"hierarchy": "Wave", "caption": "W.2", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W.2]"}, {"hierarchy": "KPI", "caption": "No. of Answers", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W.1", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Other Waves].[W.1]"}, {"hierarchy": "KPI", "caption": "Score %", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Score %]"}], [{"hierarchy": "Wave", "caption": "W.1", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Other Waves].[W.1]"}, {"hierarchy": "KPI", "caption": "Rank", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Rank]"}], [{"hierarchy": "Wave", "caption": "W.1", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Other Waves].[W.1]"}, {"hierarchy": "KPI", "caption": "No. of Answers", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W.3", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Other Waves].[W.3]"}, {"hierarchy": "KPI", "caption": "Score %", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Score %]"}], [{"hierarchy": "Wave", "caption": "W.3", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Other Waves].[W.3]"}, {"hierarchy": "KPI", "caption": "Rank", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[Rank]"}], [{"hierarchy": "Wave", "caption": "W.3", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Other Waves].[W.3]"}, {"hierarchy": "KPI", "caption": "No. of Answers", "lname": "[KPI].[(All)]", "lnum": "0", "uname": "[KPI].[No. of Answers]"}]]};

		var corben = function (rows, columns, data, indexes, direction) {
			var targetAxis = direction=='columns' ? rows : columns;
			var parentAxis = direction=='columns' ? columns : rows;
			var axisLength = direction=='columns' ? this._rowTotal : this._columnTotal;

			var newindexes = [], member, inc, currentIndex, j, i, x;
			var eq = false, depth, index, ord, value, parents = [], myparents = [];

			//this._intValuesCallback(rows, columns, data, indexes, direction);

			// Determine parents, last indexes first.
			for(j=indexes.length-1; j>=0; j--) {
				index = indexes[j].index;
				depth = indexes[j].depth;
				myparents = [];
				eq = false;

				while(depth > 0) {
					currentIndex = 0;
					depth--;
					for(x = 0; x < parentAxis[depth].length; x++) {
						member = parentAxis[depth][x];
						inc = (typeof member.axisSpan == 'undefined') ? 1 : member.axisSpan;
						if(index>=currentIndex && (index < inc+currentIndex)) {
							myparents.push({'depth': depth, 'parent': member, 'axisLength': inc});
						}
						currentIndex += inc;
					}
				}

				for(x in parents) {
					if(BASESOFT.util.isEqual(parents[x], myparents)) {
						eq = true;
						break;
					}
				}
				if(eq) {
					continue;
				}
				// We didn't use the same parents
				parents.push(myparents);
				newindexes.push({'index': index, 'parents': myparents});
			}


			var hide = [], multiple = (newindexes.length > 1);

			for(j=0; j<newindexes.length; j++) {
				index = newindexes[j].index;
				parents = newindexes[j].parents;
				hide.push(index);
			}

			if(direction=='rows') {
				this._hiddenRows = hide;
			} else {
				this._hiddenColumns = hide;
			}
		};

		var callbacks = [{
			hierarchy: 'KPI',
			caption: 'No. of Answers',
			callback: corben
		}];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: response.columns, rows: response.rows, slicers: response.slicers, data: response.data, callbacks: callbacks});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = [
		    ['','W.4','','W.2','','W.1','','W.3',''],
		    ['','Score %','Rank','Score %','Rank','Score %','Rank','Score %','Rank'],
		    ['BE','50','1','-','2','33.333333333333336','2','50','3'],
		    ['FR','50','1','-','2','100','1','-','5'],
		    ['CN','33.333333333333336','3','-','2','-','5','-','5'],
		    ['NL','33.333333333333336','3','-','2','33.333333333333336','2','66.66666666666667','1'],
		    ['DE','-','5','40','1','-','5','-','5'],
		    ['GB','-','5','-','2','25','4','20','4'],
		    ['PL','-','5','-','2','-','5','66.66666666666667','1']
		];

		YAHOO.util.Assert.isTrue(BASESOFT.util.isEqual(grid, ct.get('grid')));

	},

	testBigTable: function() {
		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "1", "formattedValue": "10", "type": 2, "value": 10.16949152542373}, {"cellOrdinal": "2", "formattedValue": "7", "type": 1, "value": 7}, {"cellOrdinal": "3", "formattedValue": "2", "type": 2, "value": 1.7369727047146404}, {"cellOrdinal": "4", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "5", "formattedValue": "1", "type": 2, "value": 0.85470085470085477}, {"cellOrdinal": "6", "formattedValue": "33", "type": 1, "value": 33}, {"cellOrdinal": "7", "formattedValue": "16", "type": 2, "value": 15.789473684210526}, {"cellOrdinal": "8", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "9", "formattedValue": "3", "type": 2, "value": 2.666666666666667}, {"cellOrdinal": "10", "formattedValue": "2", "type": 1, "value": 2}, {"cellOrdinal": "11", "formattedValue": "1", "type": 2, "value": 1.1111111111111112}, {"cellOrdinal": "12", "formattedValue": "5", "type": 1, "value": 5}, {"cellOrdinal": "13", "formattedValue": "3", "type": 2, "value": 2.5510204081632653}, {"cellOrdinal": "14", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "15", "formattedValue": "2", "type": 2, "value": 2.1857923497267762}, {"cellOrdinal": "16", "formattedValue": "7", "type": 1, "value": 7}, {"cellOrdinal": "17", "formattedValue": "6", "type": 2, "value": 5.982905982905983}, {"cellOrdinal": "18", "formattedValue": "20", "type": 1, "value": 20}, {"cellOrdinal": "19", "formattedValue": "8", "type": 2, "value": 8.4388185654008439}, {"cellOrdinal": "20", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "21", "formattedValue": "1", "type": 2, "value": 0.64308681672025725}, {"cellOrdinal": "22", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "23", "formattedValue": "5", "type": 2, "value": 4.6153846153846159}, {"cellOrdinal": "24", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "25", "formattedValue": "1", "type": 2, "value": 1.2605042016806722}, {"cellOrdinal": "26", "formattedValue": "67", "type": 1, "value": 67}, {"cellOrdinal": "27", "formattedValue": "2", "type": 2, "value": 1.5338827838827838}, {"cellOrdinal": "28", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "29", "formattedValue": "2", "type": 2, "value": 2.1897810218978102}, {"cellOrdinal": "30", "formattedValue": "2", "type": 1, "value": 2}, {"cellOrdinal": "31", "formattedValue": "2", "type": 2, "value": 1.6129032258064515}, {"cellOrdinal": "32", "formattedValue": "13", "type": 1, "value": 13}, {"cellOrdinal": "33", "formattedValue": "4", "type": 2, "value": 3.5326086956521738}, {"cellOrdinal": "34", "formattedValue": "86", "type": 1, "value": 86}, {"cellOrdinal": "35", "formattedValue": "7", "type": 2, "value": 7.29431721798134}, {"cellOrdinal": "36", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "37", "formattedValue": "2", "type": 2, "value": 1.9230769230769231}, {"cellOrdinal": "38", "formattedValue": "1", "type": 1, "value": 1}, {"cellOrdinal": "39", "formattedValue": "2", "type": 2, "value": 2.4390243902439024}, {"cellOrdinal": "40", "formattedValue": "87", "type": 1, "value": 87}, {"cellOrdinal": "41", "formattedValue": "7", "type": 2, "value": 6.7389620449264136}, {"cellOrdinal": "42", "formattedValue": "213", "type": 1, "value": 213}, {"cellOrdinal": "43", "formattedValue": "6", "type": 2, "value": 6.4214651793789574}, {"cellOrdinal": "44", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "45", "formattedValue": "2", "type": 2, "value": 1.7857142857142856}, {"cellOrdinal": "46", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "47", "formattedValue": "3", "type": 2, "value": 3.3707865168539324}, {"cellOrdinal": "48", "formattedValue": "1", "type": 1, "value": 1}, {"cellOrdinal": "49", "formattedValue": "0", "type": 2, "value": 0.40160642570281119}, {"cellOrdinal": "50", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "51", "formattedValue": "3", "type": 2, "value": 2.8571428571428572}, {"cellOrdinal": "52", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "53", "formattedValue": "3", "type": 2, "value": 2.6200873362445414}, {"cellOrdinal": "54", "formattedValue": "1", "type": 1, "value": 1}, {"cellOrdinal": "55", "formattedValue": "7", "type": 2, "value": 7.1428571428571423}, {"cellOrdinal": "56", "formattedValue": "129", "type": 1, "value": 129}, {"cellOrdinal": "57", "formattedValue": "8", "type": 2, "value": 8.4093872229465454}, {"cellOrdinal": "58", "formattedValue": "105", "type": 1, "value": 105}, {"cellOrdinal": "59", "formattedValue": "4", "type": 2, "value": 3.690685413005272}, {"cellOrdinal": "60", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "61", "formattedValue": "12", "type": 2, "value": 12.244897959183673}, {"cellOrdinal": "62", "formattedValue": "2", "type": 1, "value": 2}, {"cellOrdinal": "63", "formattedValue": "2", "type": 2, "value": 1.5873015873015872}, {"cellOrdinal": "64", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "65", "formattedValue": "3", "type": 2, "value": 3.296703296703297}, {"cellOrdinal": "66", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "67", "formattedValue": "11", "type": 2, "value": 11.111111111111111}, {"cellOrdinal": "68", "formattedValue": "5", "type": 1, "value": 5}, {"cellOrdinal": "69", "formattedValue": "3", "type": 2, "value": 2.5380710659898478}, {"cellOrdinal": "72", "formattedValue": "1", "type": 1, "value": 1}, {"cellOrdinal": "73", "formattedValue": "1", "type": 2, "value": 0.6097560975609756}, {"cellOrdinal": "74", "formattedValue": "9", "type": 1, "value": 9}, {"cellOrdinal": "75", "formattedValue": "4", "type": 2, "value": 3.75}, {"cellOrdinal": "76", "formattedValue": "40", "type": 1, "value": 40}, {"cellOrdinal": "77", "formattedValue": "4", "type": 2, "value": 4.287245444801715}, {"cellOrdinal": "78", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "79", "formattedValue": "2", "type": 2, "value": 1.7857142857142856}, {"cellOrdinal": "80", "formattedValue": "8", "type": 1, "value": 8}, {"cellOrdinal": "81", "formattedValue": "5", "type": 2, "value": 5.3691275167785237}, {"cellOrdinal": "84", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "85", "formattedValue": "2", "type": 2, "value": 2.1857923497267762}, {"cellOrdinal": "86", "formattedValue": "94", "type": 1, "value": 94}, {"cellOrdinal": "87", "formattedValue": "13", "type": 2, "value": 12.533333333333333}, {"cellOrdinal": "88", "formattedValue": "33", "type": 1, "value": 33}, {"cellOrdinal": "89", "formattedValue": "2", "type": 2, "value": 2.181097157964309}, {"cellOrdinal": "92", "formattedValue": "14", "type": 1, "value": 14}, {"cellOrdinal": "93", "formattedValue": "4", "type": 2, "value": 4.0816326530612246}, {"cellOrdinal": "94", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "95", "formattedValue": "7", "type": 2, "value": 7.3170731707317067}, {"cellOrdinal": "96", "formattedValue": "10", "type": 1, "value": 10}, {"cellOrdinal": "97", "formattedValue": "2", "type": 2, "value": 1.8975332068311195}, {"cellOrdinal": "98", "formattedValue": "25", "type": 1, "value": 25}, {"cellOrdinal": "99", "formattedValue": "3", "type": 2, "value": 2.9761904761904758}, {"cellOrdinal": "100", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "101", "formattedValue": "3", "type": 2, "value": 2.6548672566371683}, {"cellOrdinal": "102", "formattedValue": "1", "type": 1, "value": 1}, {"cellOrdinal": "103", "formattedValue": "0", "type": 2, "value": 0.27322404371584702}, {"cellOrdinal": "104", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "105", "formattedValue": "5", "type": 2, "value": 4.838709677419355}, {"cellOrdinal": "106", "formattedValue": "7", "type": 1, "value": 7}, {"cellOrdinal": "107", "formattedValue": "3", "type": 2, "value": 2.7777777777777777}, {"cellOrdinal": "108", "formattedValue": "13", "type": 1, "value": 13}, {"cellOrdinal": "109", "formattedValue": "3", "type": 2, "value": 3.1941031941031941}, {"cellOrdinal": "110", "formattedValue": "6", "type": 1, "value": 6}, {"cellOrdinal": "111", "formattedValue": "3", "type": 2, "value": 2.9850746268656714}, {"cellOrdinal": "112", "formattedValue": "28", "type": 1, "value": 28}, {"cellOrdinal": "113", "formattedValue": "7", "type": 2, "value": 7.1428571428571423}, {"cellOrdinal": "114", "formattedValue": "8", "type": 1, "value": 8}, {"cellOrdinal": "115", "formattedValue": "4", "type": 2, "value": 3.9800995024875623}, {"cellOrdinal": "116", "formattedValue": "25", "type": 1, "value": 25}, {"cellOrdinal": "117", "formattedValue": "10", "type": 2, "value": 10.204081632653061}, {"cellOrdinal": "118", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "119", "formattedValue": "20", "type": 2, "value": 20.33898305084746}, {"cellOrdinal": "120", "formattedValue": "52", "type": 1, "value": 52}, {"cellOrdinal": "121", "formattedValue": "13", "type": 2, "value": 12.903225806451612}, {"cellOrdinal": "122", "formattedValue": "14", "type": 1, "value": 14}, {"cellOrdinal": "123", "formattedValue": "4", "type": 2, "value": 3.9886039886039883}, {"cellOrdinal": "124", "formattedValue": "40", "type": 1, "value": 40}, {"cellOrdinal": "125", "formattedValue": "19", "type": 2, "value": 19.138755980861244}, {"cellOrdinal": "126", "formattedValue": "65", "type": 1, "value": 65}, {"cellOrdinal": "127", "formattedValue": "14", "type": 2, "value": 14.444444444444443}, {"cellOrdinal": "128", "formattedValue": "15", "type": 1, "value": 15}, {"cellOrdinal": "129", "formattedValue": "8", "type": 2, "value": 8.3333333333333321}, {"cellOrdinal": "130", "formattedValue": "20", "type": 1, "value": 20}, {"cellOrdinal": "131", "formattedValue": "10", "type": 2, "value": 10.204081632653061}, {"cellOrdinal": "132", "formattedValue": "30", "type": 1, "value": 30}, {"cellOrdinal": "133", "formattedValue": "16", "type": 2, "value": 16.393442622950818}, {"cellOrdinal": "134", "formattedValue": "14", "type": 1, "value": 14}, {"cellOrdinal": "135", "formattedValue": "12", "type": 2, "value": 11.965811965811966}, {"cellOrdinal": "136", "formattedValue": "56", "type": 1, "value": 56}, {"cellOrdinal": "137", "formattedValue": "24", "type": 2, "value": 23.628691983122362}, {"cellOrdinal": "138", "formattedValue": "149", "type": 1, "value": 149}, {"cellOrdinal": "139", "formattedValue": "24", "type": 2, "value": 23.95498392282958}, {"cellOrdinal": "140", "formattedValue": "9", "type": 1, "value": 9}, {"cellOrdinal": "141", "formattedValue": "14", "type": 2, "value": 13.846153846153847}, {"cellOrdinal": "142", "formattedValue": "7", "type": 1, "value": 7}, {"cellOrdinal": "143", "formattedValue": "3", "type": 2, "value": 2.9411764705882351}, {"cellOrdinal": "144", "formattedValue": "424", "type": 1, "value": 424}, {"cellOrdinal": "145", "formattedValue": "10", "type": 2, "value": 9.706959706959708}, {"cellOrdinal": "146", "formattedValue": "38", "type": 1, "value": 38}, {"cellOrdinal": "147", "formattedValue": "14", "type": 2, "value": 13.868613138686131}, {"cellOrdinal": "148", "formattedValue": "10", "type": 1, "value": 10}, {"cellOrdinal": "149", "formattedValue": "8", "type": 2, "value": 8.064516129032258}, {"cellOrdinal": "150", "formattedValue": "78", "type": 1, "value": 78}, {"cellOrdinal": "151", "formattedValue": "21", "type": 2, "value": 21.195652173913043}, {"cellOrdinal": "152", "formattedValue": "286", "type": 1, "value": 286}, {"cellOrdinal": "153", "formattedValue": "24", "type": 2, "value": 24.257845631891435}, {"cellOrdinal": "154", "formattedValue": "49", "type": 1, "value": 49}, {"cellOrdinal": "155", "formattedValue": "16", "type": 2, "value": 15.705128205128204}, {"cellOrdinal": "156", "formattedValue": "5", "type": 1, "value": 5}, {"cellOrdinal": "157", "formattedValue": "12", "type": 2, "value": 12.195121951219512}, {"cellOrdinal": "158", "formattedValue": "240", "type": 1, "value": 240}, {"cellOrdinal": "159", "formattedValue": "19", "type": 2, "value": 18.590240123934933}, {"cellOrdinal": "160", "formattedValue": "667", "type": 1, "value": 667}, {"cellOrdinal": "161", "formattedValue": "20", "type": 2, "value": 20.10853180584866}, {"cellOrdinal": "162", "formattedValue": "32", "type": 1, "value": 32}, {"cellOrdinal": "163", "formattedValue": "14", "type": 2, "value": 14.285714285714285}, {"cellOrdinal": "164", "formattedValue": "91", "type": 1, "value": 91}, {"cellOrdinal": "165", "formattedValue": "51", "type": 2, "value": 51.123595505617978}, {"cellOrdinal": "166", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "167", "formattedValue": "5", "type": 2, "value": 4.8192771084337354}, {"cellOrdinal": "168", "formattedValue": "46", "type": 1, "value": 46}, {"cellOrdinal": "169", "formattedValue": "33", "type": 2, "value": 32.857142857142854}, {"cellOrdinal": "170", "formattedValue": "30", "type": 1, "value": 30}, {"cellOrdinal": "171", "formattedValue": "13", "type": 2, "value": 13.100436681222707}, {"cellOrdinal": "172", "formattedValue": "2", "type": 1, "value": 2}, {"cellOrdinal": "173", "formattedValue": "14", "type": 2, "value": 14.285714285714285}, {"cellOrdinal": "174", "formattedValue": "474", "type": 1, "value": 474}, {"cellOrdinal": "175", "formattedValue": "31", "type": 2, "value": 30.899608865710558}, {"cellOrdinal": "176", "formattedValue": "423", "type": 1, "value": 423}, {"cellOrdinal": "177", "formattedValue": "15", "type": 2, "value": 14.868189806678384}, {"cellOrdinal": "178", "formattedValue": "25", "type": 1, "value": 25}, {"cellOrdinal": "179", "formattedValue": "26", "type": 2, "value": 25.510204081632654}, {"cellOrdinal": "180", "formattedValue": "8", "type": 1, "value": 8}, {"cellOrdinal": "181", "formattedValue": "6", "type": 2, "value": 6.3492063492063489}, {"cellOrdinal": "182", "formattedValue": "16", "type": 1, "value": 16}, {"cellOrdinal": "183", "formattedValue": "9", "type": 2, "value": 8.791208791208792}, {"cellOrdinal": "184", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "185", "formattedValue": "33", "type": 2, "value": 33.333333333333329}, {"cellOrdinal": "186", "formattedValue": "24", "type": 1, "value": 24}, {"cellOrdinal": "187", "formattedValue": "12", "type": 2, "value": 12.18274111675127}, {"cellOrdinal": "188", "formattedValue": "4", "type": 1, "value": 4}, {"cellOrdinal": "189", "formattedValue": "11", "type": 2, "value": 10.526315789473683}, {"cellOrdinal": "190", "formattedValue": "17", "type": 1, "value": 17}, {"cellOrdinal": "191", "formattedValue": "10", "type": 2, "value": 10.365853658536585}, {"cellOrdinal": "192", "formattedValue": "83", "type": 1, "value": 83}, {"cellOrdinal": "193", "formattedValue": "35", "type": 2, "value": 34.583333333333336}, {"cellOrdinal": "194", "formattedValue": "162", "type": 1, "value": 162}, {"cellOrdinal": "195", "formattedValue": "17", "type": 2, "value": 17.363344051446948}, {"cellOrdinal": "196", "formattedValue": "31", "type": 1, "value": 31}, {"cellOrdinal": "197", "formattedValue": "18", "type": 2, "value": 18.452380952380953}, {"cellOrdinal": "198", "formattedValue": "34", "type": 1, "value": 34}, {"cellOrdinal": "199", "formattedValue": "23", "type": 2, "value": 22.818791946308725}, {"cellOrdinal": "200", "formattedValue": "2", "type": 1, "value": 2}, {"cellOrdinal": "201", "formattedValue": "40", "type": 2, "value": 40.0}, {"cellOrdinal": "202", "formattedValue": "24", "type": 1, "value": 24}, {"cellOrdinal": "203", "formattedValue": "13", "type": 2, "value": 13.114754098360656}, {"cellOrdinal": "204", "formattedValue": "216", "type": 1, "value": 216}, {"cellOrdinal": "205", "formattedValue": "29", "type": 2, "value": 28.799999999999997}, {"cellOrdinal": "206", "formattedValue": "194", "type": 1, "value": 194}, {"cellOrdinal": "207", "formattedValue": "13", "type": 2, "value": 12.822207534699274}, {"cellOrdinal": "208", "formattedValue": "2", "type": 1, "value": 2}, {"cellOrdinal": "209", "formattedValue": "3", "type": 2, "value": 3.1746031746031744}, {"cellOrdinal": "210", "formattedValue": "55", "type": 1, "value": 55}, {"cellOrdinal": "211", "formattedValue": "16", "type": 2, "value": 16.034985422740526}, {"cellOrdinal": "212", "formattedValue": "11", "type": 1, "value": 11}, {"cellOrdinal": "213", "formattedValue": "27", "type": 2, "value": 26.829268292682929}, {"cellOrdinal": "214", "formattedValue": "72", "type": 1, "value": 72}, {"cellOrdinal": "215", "formattedValue": "14", "type": 2, "value": 13.662239089184061}, {"cellOrdinal": "216", "formattedValue": "263", "type": 1, "value": 263}, {"cellOrdinal": "217", "formattedValue": "31", "type": 2, "value": 31.30952380952381}, {"cellOrdinal": "218", "formattedValue": "12", "type": 1, "value": 12}, {"cellOrdinal": "219", "formattedValue": "11", "type": 2, "value": 10.619469026548673}, {"cellOrdinal": "220", "formattedValue": "19", "type": 1, "value": 19}, {"cellOrdinal": "221", "formattedValue": "5", "type": 2, "value": 5.1912568306010929}, {"cellOrdinal": "222", "formattedValue": "78", "type": 1, "value": 78}, {"cellOrdinal": "223", "formattedValue": "31", "type": 2, "value": 31.451612903225808}, {"cellOrdinal": "224", "formattedValue": "35", "type": 1, "value": 35}, {"cellOrdinal": "225", "formattedValue": "14", "type": 2, "value": 13.888888888888889}, {"cellOrdinal": "226", "formattedValue": "135", "type": 1, "value": 135}, {"cellOrdinal": "227", "formattedValue": "33", "type": 2, "value": 33.169533169533175}, {"cellOrdinal": "228", "formattedValue": "23", "type": 1, "value": 23}, {"cellOrdinal": "229", "formattedValue": "11", "type": 2, "value": 11.442786069651742}, {"cellOrdinal": "230", "formattedValue": "70", "type": 1, "value": 70}, {"cellOrdinal": "231", "formattedValue": "18", "type": 2, "value": 17.857142857142858}, {"cellOrdinal": "232", "formattedValue": "85", "type": 1, "value": 85}, {"cellOrdinal": "233", "formattedValue": "42", "type": 2, "value": 42.288557213930353}, {"cellOrdinal": "234", "formattedValue": "52", "type": 1, "value": 52}, {"cellOrdinal": "235", "formattedValue": "21", "type": 2, "value": 21.224489795918366}, {"cellOrdinal": "236", "formattedValue": "36", "type": 1, "value": 36}, {"cellOrdinal": "237", "formattedValue": "61", "type": 2, "value": 61.016949152542374}, {"cellOrdinal": "238", "formattedValue": "294", "type": 1, "value": 294}, {"cellOrdinal": "239", "formattedValue": "73", "type": 2, "value": 72.952853598014883}, {"cellOrdinal": "240", "formattedValue": "127", "type": 1, "value": 127}, {"cellOrdinal": "241", "formattedValue": "36", "type": 2, "value": 36.182336182336186}, {"cellOrdinal": "242", "formattedValue": "116", "type": 1, "value": 116}, {"cellOrdinal": "243", "formattedValue": "56", "type": 2, "value": 55.502392344497608}, {"cellOrdinal": "244", "formattedValue": "318", "type": 1, "value": 318}, {"cellOrdinal": "245", "formattedValue": "71", "type": 2, "value": 70.666666666666671}, {"cellOrdinal": "246", "formattedValue": "112", "type": 1, "value": 112}, {"cellOrdinal": "247", "formattedValue": "62", "type": 2, "value": 62.222222222222221}, {"cellOrdinal": "248", "formattedValue": "107", "type": 1, "value": 107}, {"cellOrdinal": "249", "formattedValue": "55", "type": 2, "value": 54.591836734693878}, {"cellOrdinal": "250", "formattedValue": "106", "type": 1, "value": 106}, {"cellOrdinal": "251", "formattedValue": "58", "type": 2, "value": 57.923497267759558}, {"cellOrdinal": "252", "formattedValue": "77", "type": 1, "value": 77}, {"cellOrdinal": "253", "formattedValue": "66", "type": 2, "value": 65.811965811965806}, {"cellOrdinal": "254", "formattedValue": "133", "type": 1, "value": 133}, {"cellOrdinal": "255", "formattedValue": "56", "type": 2, "value": 56.118143459915615}, {"cellOrdinal": "256", "formattedValue": "362", "type": 1, "value": 362}, {"cellOrdinal": "257", "formattedValue": "58", "type": 2, "value": 58.199356913183273}, {"cellOrdinal": "258", "formattedValue": "36", "type": 1, "value": 36}, {"cellOrdinal": "259", "formattedValue": "55", "type": 2, "value": 55.384615384615387}, {"cellOrdinal": "260", "formattedValue": "99", "type": 1, "value": 99}, {"cellOrdinal": "261", "formattedValue": "42", "type": 2, "value": 41.596638655462186}, {"cellOrdinal": "262", "formattedValue": "2,653", "type": 1, "value": 2653}, {"cellOrdinal": "263", "formattedValue": "61", "type": 2, "value": 60.737179487179482}, {"cellOrdinal": "264", "formattedValue": "138", "type": 1, "value": 138}, {"cellOrdinal": "265", "formattedValue": "50", "type": 2, "value": 50.364963503649641}, {"cellOrdinal": "266", "formattedValue": "68", "type": 1, "value": 68}, {"cellOrdinal": "267", "formattedValue": "55", "type": 2, "value": 54.838709677419352}, {"cellOrdinal": "268", "formattedValue": "74", "type": 1, "value": 74}, {"cellOrdinal": "269", "formattedValue": "20", "type": 2, "value": 20.108695652173914}, {"cellOrdinal": "270", "formattedValue": "747", "type": 1, "value": 747}, {"cellOrdinal": "271", "formattedValue": "63", "type": 2, "value": 63.358778625954194}, {"cellOrdinal": "272", "formattedValue": "169", "type": 1, "value": 169}, {"cellOrdinal": "273", "formattedValue": "54", "type": 2, "value": 54.166666666666664}, {"cellOrdinal": "274", "formattedValue": "26", "type": 1, "value": 26}, {"cellOrdinal": "275", "formattedValue": "63", "type": 2, "value": 63.414634146341463}, {"cellOrdinal": "276", "formattedValue": "825", "type": 1, "value": 825}, {"cellOrdinal": "277", "formattedValue": "64", "type": 2, "value": 63.903950426026334}, {"cellOrdinal": "278", "formattedValue": "1,962", "type": 1, "value": 1962}, {"cellOrdinal": "279", "formattedValue": "59", "type": 2, "value": 59.149834187518849}, {"cellOrdinal": "280", "formattedValue": "130", "type": 1, "value": 130}, {"cellOrdinal": "281", "formattedValue": "58", "type": 2, "value": 58.035714285714292}, {"cellOrdinal": "282", "formattedValue": "78", "type": 1, "value": 78}, {"cellOrdinal": "283", "formattedValue": "44", "type": 2, "value": 43.820224719101127}, {"cellOrdinal": "284", "formattedValue": "122", "type": 1, "value": 122}, {"cellOrdinal": "285", "formattedValue": "49", "type": 2, "value": 48.99598393574297}, {"cellOrdinal": "286", "formattedValue": "75", "type": 1, "value": 75}, {"cellOrdinal": "287", "formattedValue": "54", "type": 2, "value": 53.571428571428569}, {"cellOrdinal": "288", "formattedValue": "159", "type": 1, "value": 159}, {"cellOrdinal": "289", "formattedValue": "69", "type": 2, "value": 69.432314410480345}, {"cellOrdinal": "290", "formattedValue": "11", "type": 1, "value": 11}, {"cellOrdinal": "291", "formattedValue": "79", "type": 2, "value": 78.571428571428569}, {"cellOrdinal": "292", "formattedValue": "804", "type": 1, "value": 804}, {"cellOrdinal": "293", "formattedValue": "52", "type": 2, "value": 52.411994784876136}, {"cellOrdinal": "294", "formattedValue": "1,958", "type": 1, "value": 1958}, {"cellOrdinal": "295", "formattedValue": "69", "type": 2, "value": 68.822495606326896}, {"cellOrdinal": "296", "formattedValue": "52", "type": 1, "value": 52}, {"cellOrdinal": "297", "formattedValue": "53", "type": 2, "value": 53.061224489795919}, {"cellOrdinal": "298", "formattedValue": "81", "type": 1, "value": 81}, {"cellOrdinal": "299", "formattedValue": "64", "type": 2, "value": 64.285714285714292}, {"cellOrdinal": "300", "formattedValue": "74", "type": 1, "value": 74}, {"cellOrdinal": "301", "formattedValue": "41", "type": 2, "value": 40.659340659340657}, {"cellOrdinal": "302", "formattedValue": "19", "type": 1, "value": 19}, {"cellOrdinal": "303", "formattedValue": "53", "type": 2, "value": 52.777777777777779}, {"cellOrdinal": "304", "formattedValue": "117", "type": 1, "value": 117}, {"cellOrdinal": "305", "formattedValue": "59", "type": 2, "value": 59.390862944162436}, {"cellOrdinal": "306", "formattedValue": "25", "type": 1, "value": 25}, {"cellOrdinal": "307", "formattedValue": "66", "type": 2, "value": 65.789473684210535}, {"cellOrdinal": "308", "formattedValue": "95", "type": 1, "value": 95}, {"cellOrdinal": "309", "formattedValue": "58", "type": 2, "value": 57.926829268292678}, {"cellOrdinal": "310", "formattedValue": "134", "type": 1, "value": 134}, {"cellOrdinal": "311", "formattedValue": "56", "type": 2, "value": 55.833333333333336}, {"cellOrdinal": "312", "formattedValue": "702", "type": 1, "value": 702}, {"cellOrdinal": "313", "formattedValue": "75", "type": 2, "value": 75.241157556270096}, {"cellOrdinal": "314", "formattedValue": "113", "type": 1, "value": 113}, {"cellOrdinal": "315", "formattedValue": "67", "type": 2, "value": 67.261904761904773}, {"cellOrdinal": "316", "formattedValue": "87", "type": 1, "value": 87}, {"cellOrdinal": "317", "formattedValue": "58", "type": 2, "value": 58.389261744966447}, {"cellOrdinal": "318", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "319", "formattedValue": "60", "type": 2, "value": 60.0}, {"cellOrdinal": "320", "formattedValue": "132", "type": 1, "value": 132}, {"cellOrdinal": "321", "formattedValue": "72", "type": 2, "value": 72.131147540983605}, {"cellOrdinal": "322", "formattedValue": "208", "type": 1, "value": 208}, {"cellOrdinal": "323", "formattedValue": "28", "type": 2, "value": 27.733333333333331}, {"cellOrdinal": "324", "formattedValue": "1,149", "type": 1, "value": 1149}, {"cellOrdinal": "325", "formattedValue": "76", "type": 2, "value": 75.94183740912095}, {"cellOrdinal": "326", "formattedValue": "36", "type": 1, "value": 36}, {"cellOrdinal": "327", "formattedValue": "57", "type": 2, "value": 57.142857142857139}, {"cellOrdinal": "328", "formattedValue": "203", "type": 1, "value": 203}, {"cellOrdinal": "329", "formattedValue": "59", "type": 2, "value": 59.183673469387756}, {"cellOrdinal": "330", "formattedValue": "22", "type": 1, "value": 22}, {"cellOrdinal": "331", "formattedValue": "54", "type": 2, "value": 53.658536585365859}, {"cellOrdinal": "332", "formattedValue": "290", "type": 1, "value": 290}, {"cellOrdinal": "333", "formattedValue": "55", "type": 2, "value": 55.028462998102469}, {"cellOrdinal": "334", "formattedValue": "507", "type": 1, "value": 507}, {"cellOrdinal": "335", "formattedValue": "60", "type": 2, "value": 60.357142857142854}, {"cellOrdinal": "336", "formattedValue": "76", "type": 1, "value": 76}, {"cellOrdinal": "337", "formattedValue": "67", "type": 2, "value": 67.256637168141594}, {"cellOrdinal": "338", "formattedValue": "226", "type": 1, "value": 226}, {"cellOrdinal": "339", "formattedValue": "62", "type": 2, "value": 61.748633879781423}, {"cellOrdinal": "340", "formattedValue": "128", "type": 1, "value": 128}, {"cellOrdinal": "341", "formattedValue": "52", "type": 2, "value": 51.612903225806448}, {"cellOrdinal": "342", "formattedValue": "118", "type": 1, "value": 118}, {"cellOrdinal": "343", "formattedValue": "47", "type": 2, "value": 46.825396825396822}, {"cellOrdinal": "344", "formattedValue": "223", "type": 1, "value": 223}, {"cellOrdinal": "345", "formattedValue": "55", "type": 2, "value": 54.791154791154796}, {"cellOrdinal": "346", "formattedValue": "116", "type": 1, "value": 116}, {"cellOrdinal": "347", "formattedValue": "58", "type": 2, "value": 57.711442786069654}, {"cellOrdinal": "348", "formattedValue": "190", "type": 1, "value": 190}, {"cellOrdinal": "349", "formattedValue": "48", "type": 2, "value": 48.469387755102041}, {"cellOrdinal": "350", "formattedValue": "80", "type": 1, "value": 80}, {"cellOrdinal": "351", "formattedValue": "40", "type": 2, "value": 39.800995024875625}, {"cellOrdinal": "352", "formattedValue": "121", "type": 1, "value": 121}, {"cellOrdinal": "353", "formattedValue": "49", "type": 2, "value": 49.387755102040813}, {"cellOrdinal": "354", "formattedValue": "5", "type": 1, "value": 5}, {"cellOrdinal": "355", "formattedValue": "8", "type": 2, "value": 8.4745762711864394}, {"cellOrdinal": "356", "formattedValue": "50", "type": 1, "value": 50}, {"cellOrdinal": "357", "formattedValue": "12", "type": 2, "value": 12.406947890818859}, {"cellOrdinal": "358", "formattedValue": "207", "type": 1, "value": 207}, {"cellOrdinal": "359", "formattedValue": "59", "type": 2, "value": 58.974358974358978}, {"cellOrdinal": "360", "formattedValue": "20", "type": 1, "value": 20}, {"cellOrdinal": "361", "formattedValue": "10", "type": 2, "value": 9.5693779904306222}, {"cellOrdinal": "362", "formattedValue": "55", "type": 1, "value": 55}, {"cellOrdinal": "363", "formattedValue": "12", "type": 2, "value": 12.222222222222221}, {"cellOrdinal": "364", "formattedValue": "51", "type": 1, "value": 51}, {"cellOrdinal": "365", "formattedValue": "28", "type": 2, "value": 28.333333333333332}, {"cellOrdinal": "366", "formattedValue": "64", "type": 1, "value": 64}, {"cellOrdinal": "367", "formattedValue": "33", "type": 2, "value": 32.653061224489797}, {"cellOrdinal": "368", "formattedValue": "43", "type": 1, "value": 43}, {"cellOrdinal": "369", "formattedValue": "23", "type": 2, "value": 23.497267759562842}, {"cellOrdinal": "370", "formattedValue": "19", "type": 1, "value": 19}, {"cellOrdinal": "371", "formattedValue": "16", "type": 2, "value": 16.239316239316238}, {"cellOrdinal": "372", "formattedValue": "28", "type": 1, "value": 28}, {"cellOrdinal": "373", "formattedValue": "12", "type": 2, "value": 11.814345991561181}, {"cellOrdinal": "374", "formattedValue": "107", "type": 1, "value": 107}, {"cellOrdinal": "375", "formattedValue": "17", "type": 2, "value": 17.20257234726688}, {"cellOrdinal": "376", "formattedValue": "17", "type": 1, "value": 17}, {"cellOrdinal": "377", "formattedValue": "26", "type": 2, "value": 26.153846153846157}, {"cellOrdinal": "378", "formattedValue": "129", "type": 1, "value": 129}, {"cellOrdinal": "379", "formattedValue": "54", "type": 2, "value": 54.201680672268907}, {"cellOrdinal": "380", "formattedValue": "1,224", "type": 1, "value": 1224}, {"cellOrdinal": "381", "formattedValue": "28", "type": 2, "value": 28.021978021978022}, {"cellOrdinal": "382", "formattedValue": "92", "type": 1, "value": 92}, {"cellOrdinal": "383", "formattedValue": "34", "type": 2, "value": 33.576642335766422}, {"cellOrdinal": "384", "formattedValue": "44", "type": 1, "value": 44}, {"cellOrdinal": "385", "formattedValue": "35", "type": 2, "value": 35.483870967741936}, {"cellOrdinal": "386", "formattedValue": "203", "type": 1, "value": 203}, {"cellOrdinal": "387", "formattedValue": "55", "type": 2, "value": 55.163043478260867}, {"cellOrdinal": "388", "formattedValue": "60", "type": 1, "value": 60}, {"cellOrdinal": "389", "formattedValue": "5", "type": 2, "value": 5.0890585241730273}, {"cellOrdinal": "390", "formattedValue": "88", "type": 1, "value": 88}, {"cellOrdinal": "391", "formattedValue": "28", "type": 2, "value": 28.205128205128204}, {"cellOrdinal": "392", "formattedValue": "9", "type": 1, "value": 9}, {"cellOrdinal": "393", "formattedValue": "22", "type": 2, "value": 21.951219512195124}, {"cellOrdinal": "394", "formattedValue": "139", "type": 1, "value": 139}, {"cellOrdinal": "395", "formattedValue": "11", "type": 2, "value": 10.766847405112316}, {"cellOrdinal": "396", "formattedValue": "475", "type": 1, "value": 475}, {"cellOrdinal": "397", "formattedValue": "14", "type": 2, "value": 14.320168827253543}, {"cellOrdinal": "398", "formattedValue": "58", "type": 1, "value": 58}, {"cellOrdinal": "399", "formattedValue": "26", "type": 2, "value": 25.892857142857146}, {"cellOrdinal": "400", "formattedValue": "3", "type": 1, "value": 3}, {"cellOrdinal": "401", "formattedValue": "2", "type": 2, "value": 1.6853932584269662}, {"cellOrdinal": "402", "formattedValue": "114", "type": 1, "value": 114}, {"cellOrdinal": "403", "formattedValue": "46", "type": 2, "value": 45.783132530120483}, {"cellOrdinal": "404", "formattedValue": "15", "type": 1, "value": 15}, {"cellOrdinal": "405", "formattedValue": "11", "type": 2, "value": 10.714285714285714}, {"cellOrdinal": "406", "formattedValue": "34", "type": 1, "value": 34}, {"cellOrdinal": "407", "formattedValue": "15", "type": 2, "value": 14.847161572052403}, {"cellOrdinal": "410", "formattedValue": "127", "type": 1, "value": 127}, {"cellOrdinal": "411", "formattedValue": "8", "type": 2, "value": 8.2790091264667538}, {"cellOrdinal": "412", "formattedValue": "359", "type": 1, "value": 359}, {"cellOrdinal": "413", "formattedValue": "13", "type": 2, "value": 12.618629173989454}, {"cellOrdinal": "414", "formattedValue": "9", "type": 1, "value": 9}, {"cellOrdinal": "415", "formattedValue": "9", "type": 2, "value": 9.183673469387756}, {"cellOrdinal": "416", "formattedValue": "35", "type": 1, "value": 35}, {"cellOrdinal": "417", "formattedValue": "28", "type": 2, "value": 27.777777777777779}, {"cellOrdinal": "418", "formattedValue": "86", "type": 1, "value": 86}, {"cellOrdinal": "419", "formattedValue": "47", "type": 2, "value": 47.252747252747248}, {"cellOrdinal": "420", "formattedValue": "1", "type": 1, "value": 1}, {"cellOrdinal": "421", "formattedValue": "3", "type": 2, "value": 2.7777777777777777}, {"cellOrdinal": "422", "formattedValue": "51", "type": 1, "value": 51}, {"cellOrdinal": "423", "formattedValue": "26", "type": 2, "value": 25.888324873096447}, {"cellOrdinal": "424", "formattedValue": "9", "type": 1, "value": 9}, {"cellOrdinal": "425", "formattedValue": "24", "type": 2, "value": 23.684210526315788}, {"cellOrdinal": "426", "formattedValue": "51", "type": 1, "value": 51}, {"cellOrdinal": "427", "formattedValue": "31", "type": 2, "value": 31.097560975609756}, {"cellOrdinal": "428", "formattedValue": "14", "type": 1, "value": 14}, {"cellOrdinal": "429", "formattedValue": "6", "type": 2, "value": 5.833333333333333}, {"cellOrdinal": "430", "formattedValue": "29", "type": 1, "value": 29}, {"cellOrdinal": "431", "formattedValue": "3", "type": 2, "value": 3.1082529474812435}, {"cellOrdinal": "432", "formattedValue": "21", "type": 1, "value": 21}, {"cellOrdinal": "433", "formattedValue": "13", "type": 2, "value": 12.5}, {"cellOrdinal": "434", "formattedValue": "20", "type": 1, "value": 20}, {"cellOrdinal": "435", "formattedValue": "13", "type": 2, "value": 13.422818791946309}, {"cellOrdinal": "438", "formattedValue": "23", "type": 1, "value": 23}, {"cellOrdinal": "439", "formattedValue": "13", "type": 2, "value": 12.568306010928962}, {"cellOrdinal": "440", "formattedValue": "232", "type": 1, "value": 232}, {"cellOrdinal": "441", "formattedValue": "31", "type": 2, "value": 30.933333333333334}, {"cellOrdinal": "442", "formattedValue": "137", "type": 1, "value": 137}, {"cellOrdinal": "443", "formattedValue": "9", "type": 2, "value": 9.0548578982154648}, {"cellOrdinal": "444", "formattedValue": "25", "type": 1, "value": 25}, {"cellOrdinal": "445", "formattedValue": "40", "type": 2, "value": 39.682539682539684}, {"cellOrdinal": "446", "formattedValue": "71", "type": 1, "value": 71}, {"cellOrdinal": "447", "formattedValue": "21", "type": 2, "value": 20.699708454810494}, {"cellOrdinal": "448", "formattedValue": "5", "type": 1, "value": 5}, {"cellOrdinal": "449", "formattedValue": "12", "type": 2, "value": 12.195121951219512}, {"cellOrdinal": "450", "formattedValue": "155", "type": 1, "value": 155}, {"cellOrdinal": "451", "formattedValue": "29", "type": 2, "value": 29.411764705882355}, {"cellOrdinal": "452", "formattedValue": "45", "type": 1, "value": 45}, {"cellOrdinal": "453", "formattedValue": "5", "type": 2, "value": 5.3571428571428568}, {"cellOrdinal": "454", "formattedValue": "22", "type": 1, "value": 22}, {"cellOrdinal": "455", "formattedValue": "19", "type": 2, "value": 19.469026548672566}, {"cellOrdinal": "456", "formattedValue": "120", "type": 1, "value": 120}, {"cellOrdinal": "457", "formattedValue": "33", "type": 2, "value": 32.786885245901637}, {"cellOrdinal": "458", "formattedValue": "30", "type": 1, "value": 30}, {"cellOrdinal": "459", "formattedValue": "12", "type": 2, "value": 12.096774193548388}, {"cellOrdinal": "460", "formattedValue": "92", "type": 1, "value": 92}, {"cellOrdinal": "461", "formattedValue": "37", "type": 2, "value": 36.507936507936506}, {"cellOrdinal": "462", "formattedValue": "36", "type": 1, "value": 36}, {"cellOrdinal": "463", "formattedValue": "9", "type": 2, "value": 8.8452088452088447}, {"cellOrdinal": "464", "formattedValue": "56", "type": 1, "value": 56}, {"cellOrdinal": "465", "formattedValue": "28", "type": 2, "value": 27.860696517412936}, {"cellOrdinal": "466", "formattedValue": "104", "type": 1, "value": 104}, {"cellOrdinal": "467", "formattedValue": "27", "type": 2, "value": 26.530612244897959}, {"cellOrdinal": "468", "formattedValue": "28", "type": 1, "value": 28}, {"cellOrdinal": "469", "formattedValue": "14", "type": 2, "value": 13.930348258706468}, {"cellOrdinal": "470", "formattedValue": "47", "type": 1, "value": 47}, {"cellOrdinal": "471", "formattedValue": "19", "type": 2, "value": 19.183673469387756}], "rows": [[{"hierarchy": "Attribute", "caption": "a. Would you recommend TNT Express to others ?", "lname": "[Attribute].[Attribute]", "lnum": "2", "uname": "[Attribute].[Single].[a. Would you recommend TNT Express to others ?]"}, {"hierarchy": "Answer", "caption": "not at all", "lname": "[Answer].[Answer]", "lnum": "1", "uname": "[Answer].[not at all]"}], [{"hierarchy": "Attribute", "caption": "a. Would you recommend TNT Express to others ?", "lname": "[Attribute].[Attribute]", "lnum": "2", "uname": "[Attribute].[Single].[a. Would you recommend TNT Express to others ?]"}, {"hierarchy": "Answer", "caption": "maybe", "lname": "[Answer].[Answer]", "lnum": "1", "uname": "[Answer].[maybe]"}], [{"hierarchy": "Attribute", "caption": "a. Would you recommend TNT Express to others ?", "lname": "[Attribute].[Attribute]", "lnum": "2", "uname": "[Attribute].[Single].[a. Would you recommend TNT Express to others ?]"}, {"hierarchy": "Answer", "caption": "yes", "lname": "[Answer].[Answer]", "lnum": "1", "uname": "[Answer].[yes]"}], [{"hierarchy": "Attribute", "caption": "a. Would you recommend TNT Express to others ?", "lname": "[Attribute].[Attribute]", "lnum": "2", "uname": "[Attribute].[Single].[a. Would you recommend TNT Express to others ?]"}, {"hierarchy": "Answer", "caption": "strongly", "lname": "[Answer].[Answer]", "lnum": "1", "uname": "[Answer].[strongly]"}]], "slicers": [[]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "AE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[AE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "AE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[AE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "AR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[AR]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "AR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[AR]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "AT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[AT]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "AT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[AT]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BD", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BD]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BD", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BD]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BG]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BG]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BR]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "BR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BR]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CA]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CA]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CH", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CH]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CH", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CH]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CL]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CL]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CY", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CY]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CY", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CY]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CZ", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CZ]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "CZ", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CZ]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "DK", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DK]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "DK", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DK]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "EE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "EE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "ES", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[ES]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "ES", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[ES]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "FI", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FI]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "FI", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FI]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "FJ", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FJ]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "FJ", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FJ]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "FR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FR]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "FR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[FR]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "GR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GR]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "GR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GR]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "HK", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[HK]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "HK", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[HK]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "HU", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[HU]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "HU", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[HU]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "ID", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[ID]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "ID", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[ID]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IL]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IL]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IN]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IN]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IT]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "IT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[IT]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "JO", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JO]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "JO", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JO]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "KE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[KE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "KE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[KE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "KR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[KR]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "KR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[KR]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "KW", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[KW]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "KW", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[KW]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "LT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[LT]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "LT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[LT]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "LU", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[LU]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "LU", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[LU]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "LV", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[LV]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "LV", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[LV]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "MY", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[MY]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "MY", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[MY]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "NO", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NO]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "NO", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NO]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "NZ", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NZ]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "NZ", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NZ]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "OM", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[OM]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "OM", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[OM]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "PH", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PH]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "PH", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PH]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "PL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PL]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "PL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PL]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "PT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PT]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "PT", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[PT]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "RO", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[RO]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "RO", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[RO]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "RU", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[RU]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "RU", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[RU]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SA]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SA]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SE]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SE]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SG]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SG]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SI", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SI]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SI", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SI]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SK", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SK]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "SK", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[SK]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "TH", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[TH]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "TH", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[TH]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "TR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[TR]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "TR", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[TR]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "TW", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[TW]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "TW", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[TW]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "UA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[UA]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "UA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[UA]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "US", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[US]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "US", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[US]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "VN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[VN]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "VN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[VN]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "ZA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[ZA]"}, {"hierarchy": "Measures", "caption": "No. of Answers", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Code]", "lnum": "2", "uname": "[Wave].[Main Waves].[W39Q22011]"}, {"hierarchy": "Country", "caption": "ZA", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[ZA]"}, {"hierarchy": "Measures", "caption": "No. of Answers %", "lname": "[Measures].[MeasuresLevel]", "lnum": "0", "uname": "[Measures].[No. of Answers %]"}]]};

		var callbacks = [];

		var ct = new BASESOFT.iqube.CubeTable(null, {columns: response.columns, rows: response.rows, slicers: response.slicers, data: response.data, callbacks: callbacks, showHierarchyNames: true, dragDrop: true});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);
		var grid = ct.get('grid');

		YAHOO.util.Assert.areEqual(7, grid.length); // no. of rows.
		YAHOO.util.Assert.areEqual(120, grid[0].length); // no. of columns.
	},

	testPercentageColsSimple : function () {

		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "1", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "2", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "3", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "4", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "5", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "6", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "7", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "8", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "9", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "10", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "11", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "12", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "13", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "14", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "15", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "16", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "17", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "18", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "19", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "20", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "21", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "22", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "23", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "24", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "25", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "26", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "27", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "28", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "29", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "30", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "31", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "32", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "33", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "34", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "35", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "36", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "37", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "38", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "39", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "40", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "41", "formattedValue": "26", "value": "26"}], "rows": [[{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "JP", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JP]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}]], "slicers": [[{"hierarchy": "Position", "caption": "Overall satisfaction", "lname": "[Position].[(All)]", "lnum": "0", "uname": "[Position].[Overall satisfaction]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};

		var ct = new BASESOFT.iqube.CubeTable(null, {
			columns: response.columns,
			rows: response.rows,
			slicers: response.slicers,
			data: response.data,
			callbacks: [],
			showHierarchyNames: true,
			dragDrop: false,
			showValuesAsPercentage: BASESOFT.iqube.core.PERCENTAGE_CALCULATED_OVER_COLS
		});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);

		YAHOO.util.Assert.areEqual(223, ct.getColumnSum(0, ct.get('data')));
		var grid = ct.processPercentages(ct.get('data'));

		YAHOO.util.Assert.areEqual('11.21%', grid[0].formattedValue);
		YAHOO.util.Assert.areEqual('18.66%', grid[9].formattedValue);
	},

	testPercentageRowsSimple : function () {
		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "1", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "2", "formattedValue": "25", "value": "25"}, {"cellOrdinal": "3", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "4", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "5", "formattedValue": "21", "value": "21"}, {"cellOrdinal": "6", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "7", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "8", "formattedValue": "40", "value": "40"}, {"cellOrdinal": "9", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "10", "formattedValue": "1", "value": "1"}, {"cellOrdinal": "11", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "12", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "13", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "14", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "15", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "16", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "17", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "18", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "19", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "20", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "21", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "22", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "23", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "24", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "25", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "26", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "27", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "28", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "29", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "30", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "31", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "32", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "33", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "34", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "35", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "36", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "37", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "38", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "39", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "40", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "41", "formattedValue": "26", "value": "26"}], "rows": [[{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "JP", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JP]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}]], "slicers": [[{"hierarchy": "Position", "caption": "Overall satisfaction", "lname": "[Position].[(All)]", "lnum": "0", "uname": "[Position].[Overall satisfaction]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};

		var ct = new BASESOFT.iqube.CubeTable(null, {
			columns: response.columns,
			rows: response.rows,
			slicers: response.slicers,
			data: response.data,
			callbacks: [],
			showHierarchyNames: true,
			dragDrop: false,
			showValuesAsPercentage: BASESOFT.iqube.core.PERCENTAGE_CALCULATED_OVER_ROWS
		});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);

		YAHOO.util.Assert.areEqual(99, ct.getRowSum(0, ct.get('data')));
	},

	testShowDataAsBars: function () {

		var response = {"data": [{"cellOrdinal": "0", "formattedValue": "2554", "value": "2554"},
			{"cellOrdinal": "1", "formattedValue": "100", "value": "100"},
			{"cellOrdinal": "2", "formattedValue": "253455", "value": "253455"},
			{"cellOrdinal": "3", "formattedValue": "2199", "value": "2199"},
			{"cellOrdinal": "4", "formattedValue": "986", "value": "986"},
			{"cellOrdinal": "5", "formattedValue": "2178", "value": "2178"},
			{"cellOrdinal": "6", "formattedValue": "4098", "value": "4098"},
			{"cellOrdinal": "7", "formattedValue": "2989", "value": "2989"},
			{"cellOrdinal": "8", "formattedValue": "4000", "value": "4000"},
			{"cellOrdinal": "9", "formattedValue": "420", "value": "420"},
			{"cellOrdinal": "10", "formattedValue": "100", "value": "100"},
			{"cellOrdinal": "11", "formattedValue": "42", "value": "42"}, {"cellOrdinal": "12", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "13", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "14", "formattedValue": "37", "value": "37"}, {"cellOrdinal": "15", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "16", "formattedValue": "2", "value": "2"}, {"cellOrdinal": "17", "formattedValue": "33", "value": "33"}, {"cellOrdinal": "18", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "19", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "20", "formattedValue": "29", "value": "29"}, {"cellOrdinal": "21", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "22", "formattedValue": "3", "value": "3"}, {"cellOrdinal": "23", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "24", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "25", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "26", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "27", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "28", "formattedValue": "4", "value": "4"}, {"cellOrdinal": "29", "formattedValue": "27", "value": "27"}, {"cellOrdinal": "30", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "31", "formattedValue": "6", "value": "6"}, {"cellOrdinal": "32", "formattedValue": "34", "value": "34"}, {"cellOrdinal": "33", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "34", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "35", "formattedValue": "44", "value": "44"}, {"cellOrdinal": "36", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "37", "formattedValue": "7", "value": "7"}, {"cellOrdinal": "38", "formattedValue": "32", "value": "32"}, {"cellOrdinal": "39", "formattedValue": "26", "value": "26"}, {"cellOrdinal": "40", "formattedValue": "5", "value": "5"}, {"cellOrdinal": "41", "formattedValue": "26", "value": "26"}], "rows": [[{"hierarchy": "Country", "caption": "CN", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[CN]"}], [{"hierarchy": "Country", "caption": "JP", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[JP]"}], [{"hierarchy": "Country", "caption": "NL", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[NL]"}], [{"hierarchy": "Country", "caption": "GB", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[GB]"}], [{"hierarchy": "Country", "caption": "EG", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[EG]"}], [{"hierarchy": "Country", "caption": "DE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[DE]"}], [{"hierarchy": "Country", "caption": "BE", "lname": "[Country].[Country]", "lnum": "1", "uname": "[Country].[BE]"}]], "slicers": [[{"hierarchy": "Position", "caption": "Overall satisfaction", "lname": "[Position].[(All)]", "lnum": "0", "uname": "[Position].[Overall satisfaction]"}]], "columns": [[{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W39Q22011", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W39Q22011]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "NCS Rank", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[NCS Rank]"}], [{"hierarchy": "Wave", "caption": "W38Q12010", "lname": "[Wave].[Wave]", "lnum": "1", "uname": "[Wave].[W38Q12010]"}, {"hierarchy": "Answers", "caption": "Total", "lname": "[Answers].[(All)]", "lnum": "0", "uname": "[Answers].[Total]"}]]};

		var ct = new BASESOFT.iqube.CubeTable(null, {
			columns: response.columns,
			rows: response.rows,
			slicers: response.slicers,
			data: response.data,
			callbacks: [],
			showHierarchyNames: true,
			dragDrop: false,
			showValuesAsPercentage: BASESOFT.iqube.core.PERCENTAGE_CALCULATED_OVER_ROWS,
			showPercentagesAs: BASESOFT.iqube.core.SHOW_PERCENTAGE_AND_BARS,
			colors: ["#fe6403", "#4684EE", "#DC3912", "#FF9900", "#008000", "#666666", "#4942CC", "#CB4AC5", "#d6ae00", "#336699", "#dd4477", "#aaaa11", "#66aa00", "#888888", "#994499", "#dd5511", "#22aa99", "#999999", "#705770", "#109618", "#a32929"]
		});
		this.sandbox.appendChild(ct.get('element'));

		this._garbage.push(ct);

		var grid = ct.processPercentages(ct.get('data'));

		// the table should have coloured divs with innerHTML the percentage
		YAHOO.util.Assert.areEqual('0.97%', grid[0].formattedValue.innerHTML);
		YAHOO.util.Assert.areEqual('34.33%', grid[8].formattedValue.innerHTML);
	}

}));

})();
